/* A Bison parser, made by GNU Bison 3.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 30 "parser.yy"


#define yyerror Lily_parser::parser_error

/* We use custom location type: Input objects */
#define YYLTYPE Input
#define YYSTYPE SCM
#define YYLLOC_DEFAULT(Current,Rhs,N) \
	((Current).set_location ((Rhs)[1], (Rhs)[N]))

#define YYPRINT(file, type, value)					\
	do {								\
		if (scm_is_eq (value, SCM_UNSPECIFIED))			\
			break;						\
		SCM s = Display::value_to_lily_string (value);		\
		char *p = scm_to_locale_string (s);			\
		fputs (p, file);					\
		free (p);						\
	} while (0)

#line 103 "parser.yy"
 // -*-Fundamental-*-

/*
FIXME:

   * The rules for who is protecting what are very shady.  Uniformise
     this.

   * There are too many lexical modes?
*/

#include "config.hh"

#include <cctype>
#include <cstdlib>
#include <cstdio>

#include "book.hh"
#include "context.hh"
#include "context-def.hh"
#include "context-mod.hh"
#include "dimensions.hh"
#include "file-path.hh"
#include "input.hh"
#include "international.hh"
#include "lily-guile.hh"
#include "lily-lexer.hh"
#include "lily-parser.hh"
#include "ly-module.hh"
#include "main.hh"
#include "misc.hh"
#include "music.hh"
#include "output-def.hh"
#include "paper-book.hh"
#include "scm-hash.hh"
#include "score.hh"
#include "text-interface.hh"
#include "warn.hh"
#include "lily-imports.hh"

void
Lily_parser::parser_error (Input const *i, Lily_parser *parser, SCM *, const std::string &s)
{
	parser->parser_error (*i, s);
}

// The following are somewhat precarious constructs as they may change
// the value of the lookahead token.  That implies that the lookahead
// token must not yet have made an impact on the state stack other
// than causing the reduction of the current rule, or switching the
// lookahead token while Bison is mulling it over will cause trouble.

#define MYBACKUP(Token, Value, Location)				\
	do {								\
		if (yychar != YYEMPTY)					\
			parser->lexer_->push_extra_token		\
				(yylloc, yychar, yylval);		\
		parser->lexer_->push_extra_token			\
			(Location, Token, Value);			\
		parser->lexer_->push_extra_token (Location, BACKUP);	\
		yychar = YYEMPTY;					\
	} while (0)


#define MYREPARSE(Location, Pred, Token, Value)				\
	do {								\
		if (yychar != YYEMPTY)					\
			parser->lexer_->push_extra_token		\
				(yylloc, yychar, yylval);		\
		parser->lexer_->push_extra_token			\
			(Location, Token, Value);			\
		parser->lexer_->push_extra_token			\
			(Location, REPARSE, Pred);			\
		yychar = YYEMPTY;					\
	} while (0)

#line 182 "parser.yy"


#define MY_MAKE_MUSIC(x, spot) \
	make_music_with_input (ly_symbol2scm (x), \
			       parser->lexer_->override_input (spot))

/* ES TODO:
- delay application of the function
*/

#define LOWLEVEL_MAKE_SYNTAX(location, proc, ...)			\
	with_location							\
		(parser->lexer_->override_input (location).smobbed_copy (), \
		 proc,							\
		 ##__VA_ARGS__)

/* Syntactic Sugar. */
#define MAKE_SYNTAX(name, location, ...)				\
	LOWLEVEL_MAKE_SYNTAX (location, Syntax::name, ##__VA_ARGS__)

#define START_MAKE_SYNTAX(name, ...)					\
	scm_list_n (Syntax::name, ##__VA_ARGS__, SCM_UNDEFINED)

#define FINISH_MAKE_SYNTAX(start, location, ...)			\
	LOWLEVEL_MAKE_SYNTAX						\
		(location,						\
		 Guile_user::apply,					\
		 scm_car (start),					\
		 scm_append_x						\
		 (scm_list_2 (scm_cdr (start),				\
			      scm_list_n (__VA_ARGS__, SCM_UNDEFINED))))

SCM get_next_unique_context_id ();
SCM get_next_unique_lyrics_context_id ();

#undef _
#if !HAVE_GETTEXT
#define _(x) x
#else
#include <libintl.h>
#define _(x) gettext (x)
#endif

using std::string;

static Music *make_music_with_input (SCM name, Input where);
bool add_post_events (Music *music, SCM events);
SCM reverse_music_list (Lily_parser *parser, Input loc, SCM lst, bool preserve, bool compress);
SCM check_scheme_arg (Lily_parser *parser, Input loc,
		      SCM arg, SCM args, SCM pred, SCM disp = SCM_UNDEFINED);
SCM make_music_from_simple (Lily_parser *parser, Input loc, SCM pitch);
SCM loc_on_copy (Lily_parser *parser, Input loc, SCM arg);
SCM make_chord_elements (Input loc, SCM pitch, SCM dur, SCM modification_list);
SCM make_chord_step (SCM step, Rational alter);
SCM make_simple_markup (SCM a);
SCM make_duration (SCM t, int dots = 0, SCM factor = SCM_UNDEFINED);
bool is_regular_identifier (SCM id, bool multiple=false);
SCM make_reverse_key_list (SCM keys);
SCM try_word_variants (SCM pred, SCM str);
SCM try_string_variants (SCM pred, SCM str);
SCM post_event_cons (SCM ev, SCM tail);
int yylex (YYSTYPE *s, YYLTYPE *loc, Lily_parser *parser);


#line 233 "./out/parser.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_OUT_PARSER_HH_INCLUDED
# define YY_YY_OUT_PARSER_HH_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END_OF_FILE = 0,
    PREC_BOT = 258,
    REPEAT = 259,
    ALTERNATIVE = 260,
    COMPOSITE = 261,
    ADDLYRICS = 262,
    UNSIGNED = 263,
    REAL = 264,
    E_UNSIGNED = 265,
    EVENT_IDENTIFIER = 266,
    EVENT_FUNCTION = 267,
    HYPHEN = 268,
    EXTENDER = 269,
    DURATION_IDENTIFIER = 270,
    NUMBER_IDENTIFIER = 271,
    PREC_TOP = 272,
    ACCEPTS = 273,
    ALIAS = 274,
    BOOK = 275,
    BOOKPART = 276,
    CHANGE = 277,
    CHORDMODE = 278,
    CHORDS = 279,
    CONSISTS = 280,
    CONTEXT = 281,
    DEFAULT = 282,
    DEFAULTCHILD = 283,
    DENIES = 284,
    DESCRIPTION = 285,
    DRUMMODE = 286,
    DRUMS = 287,
    ETC = 288,
    FIGUREMODE = 289,
    FIGURES = 290,
    HEADER = 291,
    INVALID = 292,
    LAYOUT = 293,
    LYRICMODE = 294,
    LYRICS = 295,
    LYRICSTO = 296,
    MARKUP = 297,
    MARKUPLIST = 298,
    MIDI = 299,
    NAME = 300,
    NOTEMODE = 301,
    OVERRIDE = 302,
    PAPER = 303,
    REMOVE = 304,
    REST = 305,
    REVERT = 306,
    SCORE = 307,
    SCORELINES = 308,
    SEQUENTIAL = 309,
    SET = 310,
    SIMULTANEOUS = 311,
    TEMPO = 312,
    TYPE = 313,
    UNSET = 314,
    WITH = 315,
    NEWCONTEXT = 316,
    CHORD_BASS = 317,
    CHORD_CARET = 318,
    CHORD_COLON = 319,
    CHORD_MINUS = 320,
    CHORD_SLASH = 321,
    ANGLE_OPEN = 322,
    ANGLE_CLOSE = 323,
    DOUBLE_ANGLE_OPEN = 324,
    DOUBLE_ANGLE_CLOSE = 325,
    E_BACKSLASH = 326,
    E_EXCLAMATION = 327,
    E_PLUS = 328,
    FIGURE_CLOSE = 329,
    FIGURE_OPEN = 330,
    FIGURE_SPACE = 331,
    MULTI_MEASURE_REST = 332,
    EXPECT_MARKUP = 333,
    EXPECT_SCM = 334,
    BACKUP = 335,
    REPARSE = 336,
    EXPECT_MARKUP_LIST = 337,
    EXPECT_OPTIONAL = 338,
    EXPECT_NO_MORE_ARGS = 339,
    EMBEDDED_LILY = 340,
    BOOK_IDENTIFIER = 341,
    CHORD_MODIFIER = 342,
    CHORD_REPETITION = 343,
    DRUM_PITCH = 344,
    DURATION_ARG = 345,
    FRACTION = 346,
    LOOKUP_IDENTIFIER = 347,
    LYRIC_ELEMENT = 348,
    MARKUP_FUNCTION = 349,
    MARKUP_LIST_FUNCTION = 350,
    MARKUP_IDENTIFIER = 351,
    MARKUPLIST_IDENTIFIER = 352,
    MUSIC_FUNCTION = 353,
    MUSIC_IDENTIFIER = 354,
    NOTENAME_PITCH = 355,
    PITCH_IDENTIFIER = 356,
    RESTNAME = 357,
    SCM_ARG = 358,
    SCM_FUNCTION = 359,
    SCM_IDENTIFIER = 360,
    SCM_TOKEN = 361,
    STRING = 362,
    SYMBOL_LIST = 363,
    TONICNAME_PITCH = 364,
    SYMBOL = 365,
    UNARY_MINUS = 366
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int yyparse (Lily_parser *parser, SCM *retval);

#endif /* !YY_YY_OUT_PARSER_HH_INCLUDED  */



#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))

/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4596

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  129
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  203
/* YYNRULES -- Number of rules.  */
#define YYNRULES  606
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  894

#define YYUNDEFTOK  2
#define YYMAXUTOK   366


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    19,     2,     2,     2,     2,     2,    20,
       2,     2,   124,   118,    21,   117,   120,   126,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     8,     2,
       2,   123,     2,   128,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   127,     2,   125,    14,    15,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   121,     2,   122,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     9,    10,    11,    12,    13,    16,    17,
      18,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   119
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   392,   392,   393,   393,   401,   402,   404,   406,   409,
     416,   419,   423,   427,   434,   438,   442,   446,   450,   454,
     489,   505,   506,   514,   518,   522,   523,   524,   528,   529,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   549,   550,   551,   564,   565,   566,   570,   577,   581,
     582,   590,   597,   598,   599,   604,   616,   634,   638,   646,
     647,   650,   654,   663,   669,   669,   680,   684,   691,   695,
     700,   715,   716,   717,   721,   725,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   765,   769,   773,   777,   781,   785,   789,   793,   797,
     804,   805,   815,   825,   835,   846,   856,   862,   871,   884,
     886,   886,   898,   901,   911,   922,   950,   962,   972,   975,
     979,   983,   987,   991,   995,   999,  1003,  1032,  1031,  1035,
    1044,  1052,  1057,  1060,  1063,  1067,  1071,  1075,  1079,  1083,
    1113,  1112,  1119,  1127,  1134,  1151,  1157,  1158,  1159,  1164,
    1167,  1227,  1226,  1249,  1262,  1272,  1278,  1283,  1292,  1304,
    1305,  1309,  1316,  1320,  1349,  1356,  1355,  1373,  1379,  1382,
    1385,  1394,  1397,  1401,  1411,  1417,  1418,  1419,  1423,  1435,
    1436,  1437,  1441,  1445,  1460,  1478,  1479,  1483,  1487,  1494,
    1497,  1503,  1506,  1514,  1515,  1516,  1521,  1520,  1528,  1547,
    1548,  1556,  1570,  1573,  1586,  1589,  1593,  1607,  1610,  1616,
    1619,  1641,  1642,  1643,  1644,  1647,  1654,  1655,  1656,  1660,
    1667,  1671,  1678,  1679,  1680,  1687,  1688,  1689,  1693,  1694,
    1751,  1752,  1756,  1763,  1764,  1768,  1777,  1778,  1790,  1794,
    1799,  1808,  1815,  1816,  1820,  1832,  1838,  1844,  1854,  1858,
    1868,  1872,  1876,  1880,  1884,  1888,  1896,  1909,  1926,  1937,
    1948,  1965,  1982,  1995,  2018,  2036,  2037,  2052,  2062,  2078,
    2094,  2103,  2130,  2141,  2151,  2170,  2181,  2191,  2205,  2220,
    2235,  2250,  2260,  2265,  2270,  2275,  2282,  2283,  2290,  2291,
    2310,  2314,  2318,  2322,  2329,  2333,  2337,  2341,  2348,  2351,
    2361,  2366,  2371,  2376,  2381,  2386,  2396,  2401,  2406,  2411,
    2418,  2436,  2447,  2458,  2476,  2494,  2508,  2531,  2543,  2559,
    2568,  2569,  2573,  2577,  2578,  2585,  2593,  2594,  2606,  2606,
    2613,  2617,  2628,  2639,  2644,  2650,  2655,  2662,  2669,  2674,
    2679,  2685,  2692,  2699,  2705,  2708,  2711,  2722,  2751,  2758,
    2770,  2771,  2775,  2779,  2786,  2787,  2789,  2790,  2791,  2793,
    2794,  2795,  2796,  2800,  2801,  2804,  2807,  2825,  2843,  2851,
    2866,  2898,  2916,  2925,  2928,  2937,  2948,  2949,  2950,  2954,
    2955,  2956,  2957,  2968,  2969,  2970,  2982,  2985,  2991,  3007,
    3008,  3009,  3010,  3018,  3022,  3023,  3027,  3034,  3041,  3045,
    3049,  3050,  3055,  3073,  3079,  3086,  3087,  3094,  3120,  3130,
    3146,  3150,  3151,  3152,  3156,  3163,  3166,  3172,  3175,  3187,
    3192,  3197,  3207,  3214,  3221,  3231,  3232,  3239,  3247,  3248,
    3251,  3256,  3260,  3263,  3284,  3285,  3290,  3293,  3294,  3299,
    3306,  3309,  3315,  3318,  3324,  3339,  3350,  3351,  3362,  3363,
    3367,  3372,  3378,  3385,  3393,  3401,  3404,  3407,  3410,  3413,
    3416,  3419,  3425,  3426,  3427,  3431,  3434,  3442,  3450,  3458,
    3464,  3470,  3473,  3479,  3480,  3485,  3488,  3495,  3503,  3516,
    3519,  3531,  3532,  3533,  3534,  3535,  3550,  3551,  3552,  3556,
    3560,  3571,  3575,  3586,  3594,  3597,  3600,  3603,  3609,  3612,
    3619,  3622,  3628,  3629,  3637,  3696,  3716,  3723,  3739,  3744,
    3749,  3754,  3758,  3768,  3774,  3781,  3784,  3790,  3793,  3796,
    3799,  3805,  3808,  3811,  3817,  3818,  3824,  3827,  3830,  3836,
    3839,  3851,  3854,  3857,  3861,  3864,  3867,  3873,  3876,  3880,
    3881,  3882,  3889,  3890,  3891,  3897,  3898,  3907,  3919,  3920,
    3936,  3937,  3948,  3947,  3956,  3972,  3981,  3985,  3992,  4000,
    4003,  4008,  4015,  4014,  4029,  4032,  4036,  4039,  4042,  4046,
    4046,  4062,  4069,  4075,  4076,  4079,  4085,  4091,  4091,  4101,
    4104,  4107,  4111,  4114,  4117,  4120,  4126,  4127,  4133,  4137,
    4145,  4149,  4153,  4157,  4164,  4170,  4173,  4179,  4180,  4184,
    4188,  4192,  4192,  4205,  4208,  4215,  4220
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of input\"", "error", "$undefined", "PREC_BOT", "\"\\\\repeat\"",
  "\"\\\\alternative\"", "COMPOSITE", "\"\\\\addlyrics\"", "':'",
  "UNSIGNED", "REAL", "E_UNSIGNED", "EVENT_IDENTIFIER", "EVENT_FUNCTION",
  "'^'", "'_'", "\"--\"", "\"__\"", "DURATION_IDENTIFIER", "'!'", "'\\''",
  "','", "NUMBER_IDENTIFIER", "PREC_TOP", "\"\\\\accepts\"",
  "\"\\\\alias\"", "\"\\\\book\"", "\"\\\\bookpart\"", "\"\\\\change\"",
  "\"\\\\chordmode\"", "\"\\\\chords\"", "\"\\\\consists\"",
  "\"\\\\context\"", "\"\\\\default\"", "\"\\\\defaultchild\"",
  "\"\\\\denies\"", "\"\\\\description\"", "\"\\\\drummode\"",
  "\"\\\\drums\"", "\"\\\\etc\"", "\"\\\\figuremode\"", "\"\\\\figures\"",
  "\"\\\\header\"", "\"\\\\version-error\"", "\"\\\\layout\"",
  "\"\\\\lyricmode\"", "\"\\\\lyrics\"", "\"\\\\lyricsto\"",
  "\"\\\\markup\"", "\"\\\\markuplist\"", "\"\\\\midi\"", "\"\\\\name\"",
  "\"\\\\notemode\"", "\"\\\\override\"", "\"\\\\paper\"",
  "\"\\\\remove\"", "\"\\\\rest\"", "\"\\\\revert\"", "\"\\\\score\"",
  "\"\\\\score-lines\"", "\"\\\\sequential\"", "\"\\\\set\"",
  "\"\\\\simultaneous\"", "\"\\\\tempo\"", "\"\\\\type\"", "\"\\\\unset\"",
  "\"\\\\with\"", "\"\\\\new\"", "\"/+\"", "\"^\"", "\":\"", "\"-\"",
  "\"/\"", "\"<\"", "\">\"", "\"<<\"", "\">>\"", "\"\\\\\\\\\"",
  "\"\\\\!\"", "\"\\\\+\"", "FIGURE_CLOSE", "FIGURE_OPEN", "\"_\"",
  "MULTI_MEASURE_REST", "\"markup?\"", "\"scheme?\"", "\"(backed-up?)\"",
  "\"(reparsed?)\"", "\"markup-list?\"", "\"optional?\"",
  "EXPECT_NO_MORE_ARGS", "\"#{\"", "BOOK_IDENTIFIER", "CHORD_MODIFIER",
  "CHORD_REPETITION", "DRUM_PITCH", "DURATION_ARG", "FRACTION",
  "LOOKUP_IDENTIFIER", "LYRIC_ELEMENT", "MARKUP_FUNCTION",
  "MARKUP_LIST_FUNCTION", "MARKUP_IDENTIFIER", "MARKUPLIST_IDENTIFIER",
  "MUSIC_FUNCTION", "MUSIC_IDENTIFIER", "NOTENAME_PITCH",
  "PITCH_IDENTIFIER", "RESTNAME", "SCM_ARG", "SCM_FUNCTION",
  "SCM_IDENTIFIER", "SCM_TOKEN", "STRING", "SYMBOL_LIST",
  "TONICNAME_PITCH", "SYMBOL", "'-'", "'+'", "UNARY_MINUS", "'.'", "'{'",
  "'}'", "'='", "'*'", "']'", "'/'", "'['", "'?'", "$accept",
  "start_symbol", "$@1", "lilypond", "toplevel_expression", "lookup",
  "embedded_scm_bare", "embedded_scm_active", "embedded_scm_bare_arg",
  "embedded_scm", "embedded_scm_arg", "scm_function_call",
  "embedded_lilypond_number", "embedded_lilypond", "lilypond_header_body",
  "lilypond_header", "header_block", "$@2", "assignment_id", "assignment",
  "identifier_init", "identifier_init_nonumber",
  "partial_function_scriptable", "partial_function",
  "context_def_spec_block", "context_mod_arg", "$@3",
  "context_def_spec_body", "book_block", "book_body", "$@4",
  "bookpart_block", "bookpart_body", "$@5", "score_block", "score_body",
  "score_item", "score_items", "$@6", "paper_block", "output_def",
  "output_def_head", "output_def_head_with_mode_switch",
  "music_or_context_def", "output_def_body", "$@7", "tempo_event",
  "music_list", "braced_music_list", "music", "pitch_as_music",
  "music_embedded", "music_embedded_backup", "music_assign",
  "repeated_music", "sequential_music", "simultaneous_music",
  "simple_music", "context_modification", "$@8",
  "context_modification_arg", "optional_context_mods",
  "context_modification_mods_list", "context_mod_list", "context_prefix",
  "new_lyrics", "basic_music", "contextable_music",
  "contexted_basic_music", "composite_music", "music_bare",
  "grouped_music_list", "symbol_list_arg", "symbol_list_rev",
  "symbol_list_part", "symbol_list_element", "symbol_list_part_bare",
  "function_arglist_nonbackup", "reparsed_rhythm",
  "function_arglist_nonbackup_reparse", "function_arglist_backup",
  "function_arglist", "function_arglist_skip_nonbackup",
  "function_arglist_partial", "function_arglist_partial_optional",
  "function_arglist_common", "function_arglist_common_reparse",
  "function_arglist_optional", "function_arglist_skip_backup",
  "music_function_call", "optional_id", "lyric_mode_music", "$@9",
  "mode_changed_music", "mode_changing_head",
  "mode_changing_head_with_context", "context_change", "property_path",
  "property_operation", "revert_arg", "revert_arg_backup",
  "revert_arg_part", "context_def_mod", "context_mod", "grob_prop_spec",
  "grob_prop_path", "context_prop_spec", "simple_revert_context",
  "music_property_def", "string", "text", "simple_string", "symbol",
  "scalar", "event_chord", "note_chord_element", "chord_body",
  "chord_body_elements", "chord_body_element", "music_function_chord_body",
  "event_function_event", "post_events", "post_event_nofinger",
  "post_event", "string_number_event", "direction_less_event",
  "direction_reqd_event", "octave_check", "quotes", "erroneous_quotes",
  "sup_quotes", "sub_quotes", "steno_pitch", "steno_tonic_pitch", "pitch",
  "pitch_or_tonic_pitch", "gen_text_def", "fingering",
  "script_abbreviation", "script_dir", "maybe_notemode_duration",
  "optional_notemode_duration", "steno_duration", "duration", "dots",
  "multiplier_scm", "multipliers", "tremolo_type", "bass_number",
  "figured_bass_alteration", "bass_figure", "figured_bass_modification",
  "br_bass_figure", "figure_list", "optional_rest", "pitch_or_music",
  "simple_element", "lyric_element", "lyric_element_music", "new_chord",
  "chord_items", "chord_separator", "chord_item", "step_numbers",
  "step_number", "tempo_range", "number_expression", "number_term",
  "number_factor", "bare_number_common", "bare_number", "unsigned_number",
  "exclamations", "questions", "full_markup_list", "$@10", "markup_mode",
  "markup_mode_word", "full_markup", "partial_markup", "markup_top",
  "markup_scm", "$@11", "markup_list", "markup_uncomposed_list", "$@12",
  "markup_composed_list", "markup_braced_list", "markup_braced_list_body",
  "markup_command_list", "markup_command_embedded_lilypond", "$@13",
  "markup_command_basic_arguments", "markup_command_list_arguments",
  "markup_partial_function", "markup_arglist_partial",
  "markup_head_1_item", "markup_head_1_list", "markup_word",
  "simple_markup", "simple_markup_noword", "$@14", "markup", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,    58,   263,
     264,   265,   266,   267,    94,    95,   268,   269,   270,    33,
      39,    44,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    45,    43,   366,
      46,   123,   125,    61,    42,    93,    47,    91,    63
};
# endif

#define YYPACT_NINF (-611)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-593)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      21,  -611,   119,  1982,  1626,  -611,  -611,   392,    22,    55,
    -611,  -611,   767,  -611,  -611,  -611,  -611,  -611,  -611,  -611,
    -611,   775,  -611,  -611,  -611,  -611,  -611,    82,   108,   108,
     767,  -611,  -611,   125,   498,  -611,   498,  -611,  -611,  -611,
    -611,  -611,  -611,  -611,  -611,  -611,  -611,    90,   220,  -611,
    -611,  -611,  -611,  -611,  -611,   121,  1181,  -611,  -611,  -611,
    -611,  4284,   147,  -611,  -611,  -611,  -611,  -611,  -611,   260,
    -611,  -611,  1139,    86,  -611,  -611,   253,   250,   264,  -611,
    -611,   546,   287,   287,  -611,  -611,  -611,  -611,   767,   642,
    1388,   218,   218,   218,   945,   218,   553,  -611,  -611,   159,
     159,   159,  -611,  -611,   632,   292,   292,   159,   655,  -611,
    -611,    52,   292,   103,   466,  -611,  -611,   122,  -611,  -611,
    -611,  -611,  -611,  -611,   262,  -611,  -611,  -611,  -611,  -611,
    -611,  -611,  -611,  3971,   217,   146,  -611,  -611,  -611,  -611,
    -611,  -611,  -611,  -611,   159,  -611,  -611,   169,  -611,  -611,
    -611,   159,  -611,  1040,  -611,  -611,  -611,   170,  -611,   159,
    -611,  -611,  -611,  -611,  1241,  -611,   173,  -611,  -611,  -611,
    -611,   419,   259,   267,  -611,  -611,  -611,   238,   269,   271,
     274,   282,   304,  1475,  -611,  -611,  -611,   238,  2273,   218,
     661,   344,  -611,  -611,   347,  -611,  -611,   352,  -611,  1863,
     310,  -611,   218,  3527,  -611,  -611,  -611,  -611,  -611,  -611,
    4245,    59,    86,  -611,  -611,   147,  -611,  -611,  -611,  -611,
     446,  -611,   260,   390,  -611,  -611,   589,   651,  -611,  -611,
    -611,  -611,  -611,    91,  -611,  -611,  -611,  -611,  -611,  -611,
    1139,  -611,  -611,  3527,  -611,  -611,   341,  -611,   774,   383,
    -611,  -611,  -611,  -611,  -611,   341,   349,  -611,  -611,  -611,
    -611,  -611,  -611,    75,  -611,  -611,  -611,   218,   359,  -611,
     218,    75,   370,  -611,  -611,  -611,  -611,   159,   377,  -611,
    -611,  -611,  -611,   381,  -611,  1018,   533,  -611,  -611,  -611,
    -611,  -611,   774,   433,  -611,  -611,  -611,  -611,   501,   502,
    -611,  -611,   774,   443,  -611,  -611,   250,  -611,  -611,  -611,
     498,   218,   218,  -611,  -611,   287,  -611,  -611,  -611,  -611,
    2137,  -611,  -611,   234,  -611,   950,   995,   520,  -611,  -611,
    -611,  -611,  -611,  -611,  -611,  -611,  -611,  -611,  -611,  -611,
    -611,  -611,  -611,  -611,  1241,  -611,   423,   294,   789,  -611,
     789,   684,   511,  1430,  -611,  -611,  -611,  4163,  -611,  2072,
    -611,  2158,   392,  -611,  -611,  -611,   260,   392,   470,   453,
    -611,  1475,    89,  4067,  -611,  -611,  -611,  -611,    75,   475,
     303,  -611,  3413,   476,   854,  1361,  2059,  -611,  -611,    75,
     441,   161,    88,   168,   523,  -611,  -611,  -611,  -611,   177,
    -611,  -611,   289,  -611,    29,  -611,  -611,  -611,  -611,  -611,
    -611,   446,   282,  -611,  -611,  -611,   447,   458,   651,   651,
     651,  -611,  -611,   651,  -611,  -611,  1222,   488,  -611,  -611,
    -611,  -611,  -611,  -611,  -611,  -611,  -611,   774,   505,  -611,
    2843,   879,   392,  4385,   218,   218,  -611,  3637,  -611,  -611,
     508,  -611,  3747,   479,   419,  -611,  -611,  -611,  -611,  -611,
    -611,  -611,  -611,  -611,  -611,  -611,  -611,  -611,  -611,  -611,
    -611,  -611,   900,  -611,  -611,   816,  -611,  -611,   789,   789,
    2843,   879,  -611,  -611,  2843,   879,   482,   496,  1507,   789,
    -611,   789,   513,  -611,  -611,   513,  -611,  -611,    62,  -611,
     413,  -611,   789,   735,   735,  -611,  -611,   684,   606,  -611,
    -611,  -611,  -611,    90,  -611,  -611,  -611,  -611,  -611,  -611,
    -611,  -611,  -611,  -611,  -611,    90,  -611,  -611,  -611,  -611,
    -611,  -611,  -611,  -611,   282,  -611,  -611,  -611,  -611,    90,
    -611,  -611,  -611,   910,  1077,  -611,  -611,  -611,  -611,  -611,
    -611,  -611,  -611,   548,  -611,  -611,  -611,  -611,  -611,  -611,
    -611,  -611,  -611,  -611,  -611,  -611,  -611,  -611,  -611,  -611,
    -611,  -611,  -611,  -611,   565,  2957,   609,  -611,  -611,   184,
    -611,  -611,  -611,  -611,  -611,  -611,  -611,  -611,  -611,  -611,
    -611,  -611,  -611,  1197,  3527,  -611,   630,   182,  -611,   218,
     218,   789,   182,   182,   182,   182,  -611,   282,  -611,  -611,
    -611,  4475,  1475,  1549,  -611,  -611,  1139,  -611,  -611,  -611,
    -611,  3071,   916,  -611,   774,   569,  2501,  -611,  -611,  -611,
    -611,  -611,  -611,  -611,  -611,  -611,   218,  -611,   218,  -611,
     767,  -611,   274,  -611,  -611,  4366,  -611,  -611,   929,  -611,
     536,  -611,  -611,    50,  -611,  -611,  -611,   523,  -611,  -611,
     225,  -611,  -611,   382,  -611,  -611,    87,  -611,  -611,   419,
    -611,   539,  4421,   789,   520,   816,  -611,  -611,  -611,  -611,
    -611,  -611,  -611,  -611,  -611,  -611,  -611,  2501,  -611,  2501,
    3857,  3857,  -611,  -611,   883,   292,  -611,   159,  -611,  -611,
    -611,  -611,  -611,   735,   623,  -611,  4475,  -611,  -611,   108,
    -611,  -611,  -611,  -611,   582,  2615,   636,  -611,  -611,  -611,
    -611,  -611,  -611,  -611,  -611,   854,  -611,  -611,  -611,  -611,
    -611,   575,  -611,  -611,  -611,  -611,  -611,  -611,  -611,   341,
     218,   218,  -611,  -611,  -611,  -611,  -611,  -611,  -611,  -611,
    -611,  -611,  -611,  -611,    92,   156,  -611,  -611,  -611,  -611,
    -611,  -611,  -611,   570,  1549,  -611,  -611,   590,  2387,  -611,
    3185,   879,  -611,   555,  -611,  -611,  -611,  -611,  -611,  -611,
    3857,   774,   600,  -611,   218,   218,   229,   247,   597,   716,
    -611,  -611,   419,  -611,  -611,  -611,    62,  -611,  -611,   523,
      63,  -611,  -611,  -611,   583,  -611,  -611,   292,  1549,  -611,
     910,  -611,  -611,  -611,  -611,  -611,  -611,  -611,   598,  -611,
    -611,  -611,  -611,  -611,  -611,  -611,  -611,  -611,  -611,   423,
      75,    75,  -611,  -611,  1744,   916,  2729,  3857,  -611,  1058,
     918,  -611,  -611,   774,   604,   774,   620,   324,   608,   218,
     218,  -611,  -611,  -611,  -611,  -611,   706,  -611,   674,  -611,
    -611,  -611,  -611,   789,   616,  -611,   218,   218,  -611,   646,
    1058,  1058,   918,  1058,   918,   735,   324,  -611,  -611,   789,
    -611,  -611,  -611,  -611,   633,   634,   918,  1058,  1058,  -611,
     789,  1058,  1058,  3299
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       5,     3,     0,     0,     0,     1,     8,     0,     0,     0,
     336,   340,     0,   334,   338,   335,   339,     9,   157,   337,
     341,     0,   554,   552,   156,   333,   155,     0,     0,     0,
       0,   171,    13,    21,     0,   226,     0,    25,    18,    66,
      67,   171,     6,    27,    19,    26,    10,     0,     0,     7,
      11,    12,    14,    20,   158,     0,     0,   190,   212,   229,
     228,     0,   222,   223,    15,   213,   227,   211,   225,     0,
     202,    17,     0,   557,    16,    57,   479,   471,   539,   427,
     429,     0,   463,   462,   419,   420,   471,   540,     0,     0,
       0,     0,     0,     0,     0,     0,   196,   405,   500,   465,
     465,   465,    84,   511,     0,   436,   436,   465,     0,    24,
      23,   510,   436,   509,   464,    43,    41,   184,    42,    53,
       4,    76,    52,   100,     0,    81,    78,    79,    77,    80,
     400,   179,   177,     0,   181,   175,   185,    89,   186,   195,
     194,    85,   193,   401,   465,   431,   425,   180,   428,   417,
     446,   465,   548,   107,   475,   415,   430,   178,   415,   465,
     176,   415,    49,    88,     0,   557,   508,    87,   383,   384,
     385,     0,   117,   131,   386,   387,   388,   326,   383,   384,
     385,   328,     0,     0,   149,   189,   191,   326,     0,     0,
       0,     0,   298,   286,     0,   325,   242,     0,    47,     0,
       0,    65,     0,    64,   161,   167,   164,   154,   163,   162,
       0,     0,     0,   217,   216,   220,   221,   218,   178,   202,
     224,   331,     0,   201,   601,   569,     0,     0,   597,   598,
     573,   562,   556,     0,   559,   565,   564,   566,   567,   595,
       0,   555,   561,    64,   480,    50,   468,   541,     0,     0,
     414,    92,   454,   423,   424,   469,     0,   112,    58,   239,
     238,   240,   237,   367,   233,   241,   236,   368,     0,   371,
       0,   370,     0,   471,   379,   380,   382,   170,     0,   381,
     375,   200,   199,     0,   198,     0,     0,   467,   415,   466,
     415,   506,     0,     0,    91,   440,   442,   444,   438,   437,
     447,   507,     0,     0,    93,   445,   454,    48,   426,    90,
       0,     0,     0,   510,   509,   464,   184,   171,   175,   180,
       0,   415,   508,     0,   415,   513,     0,   550,   455,   461,
     458,   459,   451,   452,   457,   456,   460,   453,   106,   418,
     422,   421,   432,   433,     0,   450,   470,   183,   397,   415,
     505,     0,     0,     0,   545,   546,   547,     0,   118,     0,
     132,     0,     0,   202,   330,   214,     0,     0,     0,     0,
     553,     0,     0,   144,   202,   173,   192,   172,    22,     0,
     320,   265,    64,     0,     0,     0,     0,   174,    59,   343,
       0,   543,   376,   377,   464,    86,    68,    71,    82,     0,
     415,    83,    72,   533,   534,   542,   538,   378,   160,   166,
     159,   219,   328,   202,   332,   203,     0,     0,     0,     0,
       0,   585,   603,     0,   586,   576,     0,     0,   604,   568,
     571,   596,   599,   560,   600,    70,   472,     0,     0,   291,
      64,     0,     0,   110,     0,     0,   369,    64,   350,   373,
       0,   349,    64,     0,     0,   204,   403,   415,   412,   413,
     411,   406,   409,   410,   449,   448,   548,   481,   404,   489,
     482,   483,     0,   485,   490,   498,   501,   484,   399,   398,
      64,     0,   441,   443,    64,     0,     0,     0,     0,   183,
     182,   402,     0,   518,   517,     0,   515,   549,   434,   105,
       0,   416,   512,     0,     0,   588,   558,     0,   187,   129,
     125,   116,   126,     0,   120,   121,   119,   153,   122,   124,
     123,   142,   138,   130,   139,     0,   134,   133,   135,   137,
     136,   327,   207,   329,   328,   145,   143,   146,   150,     0,
     148,   147,   208,     0,     0,   316,   317,    30,    28,   310,
      29,   313,   314,   464,    40,    44,   299,    45,    34,    36,
      37,    38,    35,    39,    46,    33,   301,   312,   311,   300,
      32,   315,    31,   322,     0,    64,     0,   471,   253,   230,
     255,   251,   250,   249,   254,   252,   303,   309,   308,   307,
     305,   304,   306,     0,    64,   544,   543,     0,   537,     0,
       0,    75,     0,     0,     0,     0,   209,   328,   149,   149,
     594,     0,     0,     0,   572,   575,     0,   606,   574,   563,
     295,    64,     0,    95,     0,     0,    64,   293,   342,   356,
     359,   354,   357,   358,   361,   362,     0,   355,     0,   360,
       0,   108,    41,   109,   115,     0,   114,   363,     0,   113,
       0,   235,   234,     0,   463,   462,   391,   464,   389,   103,
       0,   394,   372,   107,   390,   392,     0,   104,   374,     0,
     168,   529,   110,   408,   550,   499,   488,   497,   495,   494,
     486,   487,   491,   496,   492,   493,    94,    64,    96,    64,
      64,    64,   520,   519,   514,   436,   551,   465,   476,   473,
     477,   474,   478,     0,   594,   590,   593,   591,   589,     0,
     128,   141,   215,   152,     0,   323,   324,   285,   284,   283,
     281,   282,   318,   319,   302,     0,   263,   264,   257,   260,
     261,   464,   247,   243,   259,   258,   248,   262,   287,   475,
       0,     0,    61,    63,    62,    60,    69,    74,    73,   532,
     531,   535,   536,   210,     0,     0,   583,   584,   577,   580,
     582,   581,   579,     0,     0,   587,   605,     0,   323,   297,
      64,     0,    98,     0,   347,   345,   111,   364,   365,   366,
      64,     0,     0,   393,     0,     0,     0,     0,     0,     0,
     348,   169,     0,   197,   206,   205,   434,    97,    99,     0,
     526,   523,   521,   516,   522,   524,   435,   436,   592,   188,
       0,   271,   272,   277,   273,   278,   279,   280,   464,   266,
     267,   269,   268,   270,   321,   289,   244,   245,   246,   415,
     232,   231,   602,   570,     0,     0,    64,    64,   344,   290,
       0,   396,   395,     0,     0,     0,     0,     0,     0,     0,
       0,   353,   530,   415,   528,   527,     0,   439,   502,   324,
     274,   275,   276,   256,     0,   346,     0,     0,   464,     0,
     292,   290,     0,   290,     0,     0,     0,   352,   351,   407,
     525,   503,   415,   578,     0,     0,     0,   292,   292,   593,
     504,   101,   102,    64
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -611,  -611,  -611,  -611,  -611,     3,    71,   -17,  -611,   356,
     300,    11,   650,   -86,  -611,  -113,     9,  -611,  -611,   -13,
    -190,  -130,  -112,   477,    28,    94,  -611,  -611,    20,  -611,
    -611,    15,  -611,  -611,     7,  -161,  -611,  -611,  -611,   409,
       4,  -611,  -611,  -611,  -611,  -611,  -611,    35,     1,  -257,
     717,   -63,  -611,    18,  -611,  -611,  -611,  -611,    16,  -611,
    -611,   -74,  -611,  -611,  -611,   567,   723,  -611,   727,    37,
    -611,    10,  -288,   -45,   -90,  -611,  -154,  -206,  -275,  -611,
    -489,    39,  -610,   -53,  -381,   -49,  -611,  -188,  -482,   -69,
     603,  -270,  -611,  -554,  -611,  -611,  -611,   -65,  -611,  -452,
    -611,  -611,  -611,   120,  -611,  -277,   -92,  -611,  -611,  -375,
    -611,    48,    41,  -366,   734,  -611,  -611,  -611,  -611,  -611,
    -611,    96,   309,    34,  -611,   -72,  -611,    13,   -79,  -611,
    -611,  -611,  -611,   491,   500,  -611,  -611,   557,  -611,    27,
    -134,   858,   -12,    38,   -39,  -611,    68,  -611,  -611,  -611,
     326,  -611,  -611,  -611,  -611,    33,  -611,  -611,   155,  -611,
    -611,   114,  -611,  -611,   -42,   148,  -611,    45,  -320,    17,
    -367,  -162,   350,   141,    12,  -611,   724,     2,    -3,    31,
    -611,  -147,  -611,  -139,  -174,  -611,  -611,  -611,  -611,  -611,
    -611,  -611,  -138,  -355,   660,  -377,  -215,   -46,   116,  -195,
      23,  -611,   400
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     4,     3,    42,   115,   116,    44,   555,   231,
     556,   118,   119,   120,   593,   201,   558,    47,    48,    49,
     396,   122,   123,   124,   559,   644,   645,   443,   560,   359,
     513,   561,   361,   525,   562,   372,   538,   373,   539,   516,
     563,    54,    55,   409,    56,   210,   130,   188,    57,   131,
     132,   133,   134,   564,    58,    59,    60,   136,   565,   283,
     284,   222,   223,   672,    61,   220,    62,   215,    63,   138,
      65,    66,   580,   389,   264,   265,   266,   193,   581,   194,
     380,   195,   576,   627,   439,   196,   197,   382,   383,    67,
     363,   365,   366,    68,    69,    70,   139,   390,   647,   449,
     450,   451,   648,   649,   267,   268,   272,   270,   140,   141,
     277,   171,   177,   662,   142,   143,   144,   285,   461,   462,
     145,   347,   146,   501,   148,   149,   341,   697,   297,   858,
     298,   299,   150,   151,   152,   466,   342,   308,   343,   320,
     287,   288,   154,   289,   246,   702,   346,   156,   474,   684,
     475,   685,   476,   286,   882,   218,   158,   159,   160,   161,
     694,   496,   803,   804,   805,   670,   402,   403,   404,   405,
     406,   671,   327,   498,   570,   183,   164,   165,   322,   572,
     232,   233,   427,   234,   235,   417,   236,   237,   426,   238,
     761,   834,   424,   425,   499,   505,   239,   353,   432,   617,
     434,   416,   765
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      74,   166,   269,   280,   258,    73,    43,    53,   129,   357,
      52,   128,    46,   121,    45,    71,   163,   325,    51,   127,
     137,   162,   135,    50,   126,   431,   240,   300,   251,   185,
     186,   153,   125,   305,   486,   167,   369,   157,   147,   208,
      64,   338,   155,   209,   370,   433,   263,   255,   271,   399,
     271,   294,  -376,   435,   715,   304,   620,   760,   212,    43,
     440,   716,   182,   610,   611,   612,   430,    45,   613,   181,
     317,   187,   661,   397,   598,   198,   199,   661,   170,   221,
     665,   340,   278,   176,   339,   665,   668,   166,   422,   399,
     535,   279,   180,   535,   129,   242,   444,   128,   587,   121,
     508,   176,   163,  -377,   480,   127,   137,   162,   135,  -238,
     126,   588,     1,   397,   484,   825,   541,   153,   125,     5,
     250,   167,   -86,   157,   147,   377,   705,   707,   155,   256,
     708,   162,   200,   768,   854,   781,   377,   371,   431,   782,
     716,   381,   606,   172,   378,   412,   -82,   198,   704,   706,
     345,   318,   760,   604,   219,   605,   431,   535,   433,   176,
     176,   825,   262,   262,   262,   276,   262,   319,   273,   -54,
     -83,   321,   228,  -378,  -376,   229,   173,    86,   575,   430,
     448,   855,  -239,   595,   773,   695,   774,   242,   241,  -240,
     696,   596,    78,   428,   429,   445,   789,   430,   599,   381,
     407,   579,   446,   184,    87,   740,   318,   129,  -238,   243,
     128,   536,   121,   422,   832,   163,   460,   318,   127,   137,
     487,   398,   319,   126,   369,  -377,   321,   259,   410,    41,
     153,   125,   414,   319,   167,   626,   401,   321,   408,   415,
     407,   769,   204,   381,   -86,   189,   784,   129,   340,   621,
     128,   339,   121,   381,   348,   163,   717,   350,   127,   137,
     262,   398,   244,   126,   712,   453,   263,   271,   -82,   718,
     153,   125,   245,   262,   167,   687,   401,   598,   833,   689,
     241,  -239,    22,   477,   751,   752,   247,   615,  -240,   532,
     783,   -54,   -83,   660,   -55,  -378,   252,   600,   660,   597,
     542,   309,    76,   323,   741,    79,    80,   310,    82,    83,
      84,    85,   295,   296,   843,   661,   661,   345,   844,   463,
      28,   715,    29,   665,   665,   668,   705,   241,   859,   109,
     110,   260,   845,   103,   261,    31,   846,   753,   262,   607,
     202,   262,   512,   203,   524,   785,   768,   313,   808,   250,
     314,   358,   488,   859,   651,   652,   520,   473,   530,   360,
     117,   362,    43,   517,    43,   517,   515,   242,   526,   422,
      45,   519,    45,   529,   514,   318,   533,   540,   790,   571,
     616,    41,   262,   262,   478,   554,   479,   364,   381,  -323,
     544,   318,  -386,   557,  -387,   653,   518,  -388,   528,   569,
     710,   431,   585,   592,   746,   661,   602,   603,   503,   875,
     531,   315,   711,   665,   838,   534,   -55,   489,   583,   590,
     491,   766,   698,   582,   589,   377,   713,   367,   354,   384,
      22,   388,   783,   170,   385,   699,   770,   571,   170,   386,
     399,   355,   430,   554,   407,   502,   117,   754,   755,   407,
     554,   557,   282,   413,   769,   554,    96,   569,   557,   646,
     241,   436,   661,   557,   397,   369,   763,   153,   441,   477,
     665,   865,   442,   762,   663,   306,    78,   571,   490,   663,
     664,   571,   447,   554,   650,   664,   786,   554,    87,   316,
     628,   557,   787,   452,   381,   557,   601,   569,   707,   708,
     454,   569,   455,   109,   110,   168,   318,   153,   169,   337,
     700,   153,   400,   170,   642,   262,   262,    33,   481,   575,
     889,   482,   319,   483,   109,   110,   321,   356,   485,    36,
     109,   110,   596,    78,   747,   748,   660,   660,   739,   497,
     584,   591,   467,   473,   316,    87,   448,   500,   448,   431,
     506,   338,   400,   673,   418,   316,   429,   722,   723,   395,
     543,   721,   573,   807,   594,   836,   371,   764,   608,   766,
     724,   701,   737,   381,   619,   381,   744,   720,   554,   609,
     745,    22,   719,   190,   826,   827,   557,   191,   192,   884,
     622,   407,   736,   839,   666,   212,    43,   828,   129,   395,
     251,   128,   669,   121,    45,   690,   163,   860,   861,   127,
     137,   709,   398,   468,   126,   469,   806,   763,   571,   691,
     862,   153,   125,   737,   554,   167,   660,   401,   112,   554,
     852,   248,   557,   431,   870,   249,   192,   557,   569,   253,
     254,   459,   738,   736,   109,   110,   470,   749,   750,   471,
     725,    33,   595,   153,   771,   871,   792,   873,   281,   780,
     472,   763,  -592,    36,   109,   110,   887,   810,   888,   824,
     262,   262,   428,   418,   419,   835,   337,   420,   837,   421,
     893,   775,   776,   660,   737,   840,   737,   407,   407,   872,
     554,   566,   554,   554,   554,   830,   831,   847,   557,   851,
     557,   557,   557,   856,   736,   874,   736,   262,   876,   262,
     809,   176,   823,   650,   153,   800,   153,   292,   554,   841,
     842,   293,   192,   664,   664,   259,   557,    72,   857,   537,
     881,   886,   381,   294,   304,   423,   419,   849,   883,   420,
     302,   421,   848,   642,   303,   192,   190,   658,   864,   566,
     379,   192,   658,   109,   110,   174,   891,   892,   175,   877,
     878,   381,   764,   257,   307,   823,   794,   571,   503,   504,
     527,   554,   420,   554,   421,   885,   464,   407,   213,   557,
     211,   557,   411,   554,   214,   465,   381,   569,   216,   566,
     374,   557,   795,   566,   381,   217,   381,    76,   675,   643,
      79,    80,   310,    82,    83,    84,    85,   829,   802,   853,
     356,   262,   262,   664,   880,   796,   674,   791,    72,   703,
     504,   263,   271,   420,   352,   421,   618,   109,   110,   260,
       0,   166,   261,   737,   407,   676,   850,     0,   129,   554,
     554,   128,     0,   121,   316,     0,   163,   557,   557,   127,
     137,   162,   135,   736,   126,   262,   262,    72,     0,   437,
     262,   153,   125,   438,   192,   167,   663,   157,   147,     0,
     664,     0,   155,   567,     0,   732,     0,   344,   109,   110,
     174,     0,   568,   175,   733,     0,   109,   110,   178,     0,
     737,   179,   800,   677,   678,   679,   554,   663,   663,     0,
     663,     0,     0,   400,   557,     0,   315,     0,     0,   467,
     736,     0,    72,     0,   663,   663,     0,   623,   663,   663,
     262,   262,     0,    72,   659,   863,   732,     0,     0,   667,
     566,   567,     0,   680,   681,   733,     0,   262,   262,   190,
     568,   682,   683,   574,   192,     0,     0,     0,    22,   879,
     395,   492,   493,   494,   273,   495,     0,   686,   290,   291,
       0,   688,     0,    86,   624,   301,     0,   759,   625,   192,
       0,   567,     0,     0,     0,   567,   801,     0,   890,     0,
     568,     0,   469,   692,   568,     0,   693,   732,     0,   732,
     658,   658,     0,    22,     0,   190,   733,     0,   733,   714,
     192,   437,   324,   624,   779,   767,   192,   869,   192,   326,
      72,   109,   110,   470,     0,   819,   471,   349,  -467,  -467,
    -467,     0,  -467,     0,   820,   356,    76,    33,   643,    79,
      80,   310,    82,    83,    84,    85,     0,     0,     0,    36,
     109,   110,   777,     0,    72,   778,     0,    72,    76,     0,
       0,    79,    80,    81,   328,   329,   109,   110,   274,   330,
       0,   275,   759,   492,   493,   494,   734,   495,   819,     0,
       0,   653,   654,   655,     0,   735,     0,   820,     0,   566,
     658,    72,     0,    72,     0,    72,   273,    78,    22,     0,
       0,     0,   456,     0,     0,    86,     0,    72,     0,    87,
       0,     0,     0,   772,     0,     0,     0,     0,     0,    72,
      72,   866,   567,   457,   331,     0,    33,   734,     0,   867,
       0,   568,    34,   458,   105,   106,   735,     0,    36,   109,
     110,     0,     0,   112,     0,   315,   732,   658,    33,     0,
       0,     0,     0,     0,   104,   733,     0,     0,   356,     0,
     108,   109,   110,   332,     0,     0,   333,   334,   335,     0,
     336,     0,   786,     0,   797,     0,   798,     0,   787,     0,
       0,     0,     0,   577,     0,   868,     0,     0,   734,     0,
     734,     0,   205,   105,   106,  -165,     0,   735,     0,   735,
     117,   579,   112,   732,     0,     0,    72,   224,   225,     0,
       0,     0,   733,     0,     0,     0,   821,     0,     0,  -165,
    -165,  -165,    72,  -165,     0,   822,     0,     0,  -165,  -165,
       0,  -165,  -165,     0,     0,     0,  -165,  -165,  -165,    22,
       0,     0,     0,  -165,  -165,     0,     0,    33,  -165,   226,
     227,  -165,  -165,  -165,  -165,    22,  -165,     0,  -165,    36,
     109,   110,   228,     0,  -165,   229,  -165,     0,     0,   821,
     230,   567,  -165,     0,  -165,     0,     0,     0,   822,     0,
     568,     0,     0,     0,     0,  -165,  -165,     0,     0,    33,
     224,   225,     0,     0,     0,  -165,  -165,     0,     0,  -165,
       0,    36,    37,   206,    39,    33,     0,    40,     0,   224,
     225,     0,  -165,   207,     0,     0,     0,    36,    37,   742,
      39,     0,     0,    40,     0,     0,   623,   211,     0,   743,
      33,     0,   226,   227,     0,     0,     0,   734,     0,     0,
       0,     0,    36,   109,   110,   228,   735,     0,   229,    33,
       0,   351,   227,   230,   614,     0,     0,   772,   686,     0,
     688,    36,   109,   110,   228,     0,     0,   229,     0,     0,
       0,     0,   230,     0,   797,   798,     0,     0,   659,   667,
     273,    78,     0,     0,     0,     0,     0,     0,     0,    86,
       0,     0,     0,    87,   734,     0,     0,   788,   -51,    75,
       0,     0,     7,   735,     0,     0,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,     0,     0,    22,
      87,     0,     0,     0,     8,     9,    88,    10,    11,     0,
      89,     0,     0,     0,     0,    13,    14,     0,    15,    16,
     -64,    90,    18,    19,    20,    21,    22,    23,    24,     0,
      25,    91,    26,     0,     0,    92,    27,     0,    28,    93,
      29,    94,     0,    95,    96,    30,     0,   577,     0,     0,
     103,    97,     0,    31,     0,     0,     0,   105,   106,    98,
     578,    99,     0,     0,   313,   579,   112,   314,     0,     0,
       0,     0,   100,   101,     0,   102,    33,   103,   224,   225,
       0,     0,   104,    35,   105,   106,   107,     0,   108,   109,
     110,   111,     0,   112,   113,   114,     0,   -56,   375,    41,
     -51,     7,     0,     0,     0,    76,   273,     0,    79,    80,
     310,    82,    83,    84,    85,    86,     0,     0,    33,     0,
     507,   227,     0,     0,   225,    88,    10,    11,     0,    12,
      36,   109,   110,   228,    13,    14,   229,    15,    16,     0,
       0,   230,    19,    20,    21,    22,     0,     0,     0,    25,
     311,     0,     0,     0,    92,     0,     0,    28,   312,    29,
      94,     0,    95,    33,    30,   368,   227,     0,     0,     0,
      97,     0,    31,     0,     0,    36,   109,   110,    98,     0,
      99,     0,     0,     0,     0,     0,   230,     0,     0,     0,
       0,   100,   101,     0,     0,    33,   103,   224,     0,     0,
       0,    34,    35,   105,   106,   107,     0,    36,   109,   110,
     313,     0,   112,   314,   315,     0,   -51,    75,    41,   -56,
       7,     0,     0,     0,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,     0,     0,    33,    87,   226,
       0,     0,     8,     9,    88,    10,    11,     0,    89,    36,
     109,   110,   228,    13,    14,   229,    15,    16,   -64,    90,
      18,    19,    20,    21,    22,    23,    24,     0,    25,    91,
      26,     0,     0,    92,    27,     0,    28,    93,    29,    94,
       0,    95,    96,    30,     0,     0,     0,     0,     0,    97,
       0,    31,     0,     0,     0,     0,     0,    98,     0,    99,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     100,   101,     0,   102,    33,   103,     0,     0,     0,     0,
     104,    35,   105,   106,   107,     0,   108,   109,   110,   111,
       0,   112,   113,   114,     0,    75,     0,    41,     7,     0,
       0,     0,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,     0,     0,     0,    87,     0,     0,     0,
       8,     9,    88,    10,    11,     0,    89,     0,     0,     0,
       0,    13,    14,     0,    15,    16,   -64,    90,    18,    19,
      20,    21,    22,    23,    24,     0,    25,    91,    26,     0,
       0,    92,    27,     0,    28,    93,    29,    94,     0,    95,
      96,    30,     0,     0,     0,     0,     0,    97,     0,    31,
       0,     0,     0,     0,     0,    98,     0,    99,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   100,   101,
       0,   102,    33,   103,     0,     0,     0,     0,   104,    35,
     105,   106,   107,     0,   108,   109,   110,   111,     0,   112,
     113,   114,     0,     0,   375,    41,   -51,     7,     0,     0,
       0,    76,   273,     0,    79,    80,   310,    82,    83,    84,
      85,    86,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    88,    10,    11,     0,    12,     0,     0,     0,     0,
      13,    14,     0,    15,    16,     0,     0,     0,    19,    20,
      21,    22,     0,     0,     0,    25,   311,     0,     0,     0,
      92,     0,     0,    28,   312,    29,    94,     0,    95,     0,
      30,     0,     0,     0,     0,     0,    97,     0,    31,     0,
       0,     0,     0,     0,    98,     0,    99,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   100,   101,     0,
       0,    33,   103,     0,     0,     0,     0,    34,    35,   105,
     106,   107,     0,    36,   109,   110,   313,     0,   112,   314,
     315,     0,    -2,     6,    41,   387,     7,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     8,     9,
       0,    10,    11,     0,    12,     0,     0,     0,     0,    13,
      14,     0,    15,    16,   -64,    17,    18,    19,    20,    21,
      22,    23,    24,     0,    25,     0,    26,     0,     0,     0,
      27,     0,    28,     0,    29,     0,     0,     0,     0,    30,
       0,     0,     0,     0,     0,     0,     0,    31,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   273,    78,
       0,     0,     0,   509,    32,     0,     7,    86,     0,     0,
      33,    87,     0,     0,     0,     0,    34,    35,     0,     0,
       0,     0,    36,    37,    38,    39,     0,     0,    40,     9,
       0,    10,    11,    41,    12,     0,     0,    22,     0,    13,
      14,     0,    15,    16,  -127,     0,    18,    19,    20,    21,
      22,    23,    24,     0,    25,     0,    26,     0,     0,     0,
      27,     0,    28,     0,    29,     0,     0,     0,     0,    30,
       0,     0,     0,     0,     0,    76,     0,    31,    79,    80,
     310,   328,   329,     0,     0,   577,   330,     0,   103,   521,
       0,     0,     7,     0,     0,   105,   106,     0,   586,     0,
      33,     0,   313,   579,   112,   314,    34,    35,     0,     0,
       0,     0,    36,    37,   510,    22,     0,    10,    11,     0,
      12,     0,     0,    41,   511,    13,    14,     0,    15,    16,
    -140,     0,    18,    19,    20,    21,    22,    23,    24,     0,
      25,   331,    26,     0,     0,     0,    27,     0,    28,     0,
      29,     0,     0,     0,     0,    30,     0,     0,     0,     0,
       0,     0,     0,    31,     0,    33,     0,     0,     0,     0,
       0,    34,     0,     0,     0,     0,     0,    36,   109,   110,
     332,     0,     0,   333,   334,   335,    33,   336,     0,     0,
       0,     0,    34,    35,     0,     0,     0,     0,    36,    37,
     522,     0,     0,     0,   375,     0,     0,     7,     0,    41,
     523,    76,   273,     0,    79,    80,   310,    82,    83,    84,
      85,    86,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    88,    10,    11,     0,    12,     0,     0,     0,     0,
      13,    14,     0,    15,    16,     0,     0,     0,    19,    20,
      21,    22,     0,     0,     0,    25,   311,     0,     0,     0,
      92,     0,     0,    28,   312,    29,    94,     0,    95,     0,
      30,     0,     0,     0,     0,     0,    97,     0,    31,   376,
       0,     0,     0,     0,    98,     0,    99,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   100,   101,     0,
       0,    33,   103,     0,     0,     0,     0,    34,    35,   105,
     106,   107,     0,    36,   109,   110,   313,     0,   112,   314,
     315,     7,     0,     0,    41,    76,   811,   812,    79,    80,
     310,    82,    83,    84,    85,   813,     0,     0,     0,   814,
       0,     0,     0,     8,     9,    88,    10,    11,     0,    89,
       0,     0,     0,     0,    13,    14,  -296,    15,    16,   -64,
       0,    18,    19,    20,    21,    22,    23,    24,     0,    25,
     311,    26,     0,     0,    92,    27,     0,    28,   312,    29,
      94,     0,    95,    96,    30,     0,     0,     0,     0,     0,
      97,     0,    31,     0,     0,     0,     0,     0,    98,     0,
      99,     0,     0,     0,   544,     0,     0,     0,     0,     0,
       0,   100,   101,     0,   547,    33,     0,     0,     0,     0,
       0,    34,    35,   105,   106,   107,   548,    36,   815,   550,
     816,     0,   112,   817,   818,     7,     0,     0,    41,    76,
     726,    78,    79,    80,    81,    82,    83,    84,    85,   727,
       0,     0,     0,    87,     0,     0,     0,     8,     9,    88,
      10,    11,     0,    89,  -288,     0,     0,     0,    13,    14,
    -292,    15,    16,     0,     0,    18,    19,    20,    21,    22,
      23,    24,     0,    25,    91,    26,     0,     0,    92,    27,
       0,    28,    93,    29,    94,     0,    95,    96,    30,     0,
       0,     0,     0,     0,    97,     0,    31,     0,     0,     0,
       0,     0,    98,     0,    99,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   100,   101,     0,   547,    33,
       0,     0,     0,     0,     0,   104,    35,   105,   106,   107,
     548,   108,   728,   550,   729,     0,   112,   730,   731,     7,
       0,     0,    41,    76,   811,   812,    79,    80,   310,    82,
      83,    84,    85,   813,     0,     0,     0,   814,     0,     0,
       0,     8,     9,    88,    10,    11,     0,    89,     0,     0,
       0,     0,    13,    14,     0,    15,    16,   -64,     0,    18,
      19,    20,    21,    22,    23,    24,     0,    25,   311,    26,
       0,     0,    92,    27,     0,    28,   312,    29,    94,     0,
      95,    96,    30,     0,     0,     0,     0,     0,    97,     0,
      31,     0,     0,     0,     0,     0,    98,     0,    99,     0,
       0,     0,   544,     0,     0,     0,     0,     0,     0,   100,
     101,     0,   547,    33,     0,     0,     0,     0,     0,    34,
      35,   105,   106,   107,   548,    36,   815,   550,   816,     0,
     112,   817,   818,     7,     0,     0,    41,    76,   726,    78,
      79,    80,   310,    82,    83,    84,    85,   727,     0,     0,
       0,    87,     0,     0,     0,     8,     9,    88,    10,    11,
       0,    89,  -288,     0,     0,     0,    13,    14,  -292,    15,
      16,     0,     0,    18,    19,    20,    21,    22,    23,    24,
       0,    25,   311,    26,     0,     0,    92,    27,     0,    28,
     312,    29,    94,     0,    95,    96,    30,     0,     0,     0,
       0,     0,    97,     0,    31,     0,     0,     0,     0,     0,
      98,     0,    99,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   100,   101,     0,   547,    33,     0,     0,
       0,     0,     0,    34,    35,   105,   106,   107,   548,    36,
     728,   550,   729,     0,   112,   730,   731,     7,     0,     0,
      41,    76,   545,    78,    79,    80,    81,    82,    83,    84,
      85,   546,     0,     0,     0,    87,     0,     0,     0,     8,
       9,    88,    10,    11,     0,    89,     0,     0,     0,     0,
      13,    14,  -290,    15,    16,     0,     0,    18,    19,    20,
      21,    22,    23,    24,     0,    25,    91,    26,     0,     0,
      92,    27,     0,    28,    93,    29,    94,     0,    95,    96,
      30,     0,     0,     0,     0,     0,    97,     0,    31,     0,
       0,     0,     0,     0,    98,     0,    99,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   100,   101,     0,
     547,    33,     0,     0,     0,     0,     0,   104,    35,   105,
     106,   107,   548,   108,   549,   550,   551,     0,   112,   552,
     553,     7,     0,     0,    41,    76,   726,    78,    79,    80,
     310,    82,    83,    84,    85,   727,     0,     0,     0,    87,
       0,     0,     0,     8,     9,    88,    10,    11,     0,    89,
    -288,     0,     0,     0,    13,    14,     0,    15,    16,     0,
       0,    18,    19,    20,    21,    22,    23,    24,     0,    25,
     311,    26,     0,     0,    92,    27,     0,    28,   312,    29,
      94,     0,    95,    96,    30,     0,     0,     0,     0,     0,
      97,     0,    31,     0,     0,     0,     0,     0,    98,     0,
      99,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   100,   101,     0,   547,    33,     0,     0,     0,     0,
       0,    34,    35,   105,   106,   107,   548,    36,   728,   550,
     729,     0,   112,   730,   731,     7,     0,     0,    41,    76,
     545,    78,    79,    80,   310,    82,    83,    84,    85,   546,
       0,     0,     0,    87,     0,     0,     0,     8,     9,    88,
      10,    11,     0,    89,     0,     0,     0,     0,    13,    14,
    -294,    15,    16,     0,     0,    18,    19,    20,    21,    22,
      23,    24,     0,    25,   311,    26,     0,     0,    92,    27,
       0,    28,   312,    29,    94,     0,    95,    96,    30,     0,
       0,     0,     0,     0,    97,     0,    31,     0,     0,     0,
       0,     0,    98,     0,    99,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   100,   101,     0,   547,    33,
       0,     0,     0,     0,     0,    34,    35,   105,   106,   107,
     548,    36,   549,   550,   551,     0,   112,   552,   553,     7,
       0,     0,    41,    76,   545,    78,    79,    80,   310,    82,
      83,    84,    85,   546,     0,     0,     0,    87,     0,     0,
       0,     8,     9,    88,    10,    11,     0,    89,     0,     0,
       0,     0,    13,    14,  -290,    15,    16,     0,     0,    18,
      19,    20,    21,    22,    23,    24,     0,    25,   311,    26,
       0,     0,    92,    27,     0,    28,   312,    29,    94,     0,
      95,    96,    30,     0,     0,     0,     0,     0,    97,     0,
      31,     0,     0,     0,     0,     0,    98,     0,    99,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   100,
     101,     0,   547,    33,     0,     0,     0,     0,     0,    34,
      35,   105,   106,   107,   548,    36,   549,   550,   551,     0,
     112,   552,   553,     7,     0,     0,    41,    76,   726,    78,
      79,    80,   310,    82,    83,    84,    85,   727,     0,     0,
       0,    87,     0,     0,     0,     8,     9,    88,    10,    11,
       0,    89,     0,     0,     0,     0,    13,    14,  -292,    15,
      16,     0,     0,    18,    19,    20,    21,    22,    23,    24,
       0,    25,   311,    26,     0,     0,    92,    27,     0,    28,
     312,    29,    94,     0,    95,    96,    30,     0,     0,     0,
       0,     0,    97,     0,    31,     0,     0,     0,     0,     0,
      98,     0,    99,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   100,   101,     0,   547,    33,     0,     0,
       0,     0,     0,    34,    35,   105,   106,   107,   548,    36,
     728,   550,   729,     0,   112,   730,   731,     7,     0,     0,
      41,    76,   545,    78,    79,    80,   310,    82,    83,    84,
      85,   546,     0,     0,     0,    87,     0,     0,     0,     8,
       9,    88,    10,    11,     0,    89,     0,     0,     0,     0,
      13,    14,     0,    15,    16,     0,     0,    18,    19,    20,
      21,    22,    23,    24,     0,    25,   311,    26,     0,     0,
      92,    27,     0,    28,   312,    29,    94,     0,    95,    96,
      30,     0,     0,     0,     0,     0,    97,     0,    31,     0,
       0,     0,     0,     0,    98,     0,    99,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   100,   101,     0,
     547,    33,     0,     0,     0,     0,     0,    34,    35,   105,
     106,   107,   548,    36,   549,   550,   551,     0,   112,   552,
     553,     7,     0,     0,    41,    76,   391,    78,    79,    80,
      81,    82,    83,    84,    85,     0,     0,     0,     0,    87,
       0,     0,     0,     8,     9,    88,    10,    11,     0,    89,
       0,     0,     0,     0,    13,    14,     0,    15,    16,     0,
       0,    18,    19,    20,    21,    22,    23,    24,     0,    25,
      91,    26,     0,     0,    92,    27,     0,    28,    93,    29,
      94,     0,    95,    96,    30,     0,     0,     0,     0,     0,
      97,     0,    31,     0,     0,     0,     0,     0,    98,     0,
      99,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   100,   101,     0,   102,    33,     0,     0,     0,     0,
       0,   104,    35,   105,   106,   107,     0,   108,   109,   110,
     392,     7,   112,   393,   394,     0,   391,    78,    41,     0,
     653,   654,   655,     0,     0,     0,     0,     0,     0,    87,
       0,     0,     0,     8,     9,    88,    10,    11,     0,    89,
       0,     0,     0,     0,    13,    14,  -101,    15,    16,     0,
       0,    18,    19,    20,    21,    22,    23,    24,     0,    25,
      91,    26,     0,     0,    92,    27,     0,    28,    93,    29,
      94,     0,    95,    96,    30,     0,     0,     0,     0,     0,
      97,     0,    31,     0,     0,     0,     0,     0,    98,     0,
      99,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   100,   101,     0,   547,    33,     0,     0,     0,     0,
       0,   104,    35,   105,   106,   107,   548,   108,   656,   550,
     392,     7,   112,   393,   657,     0,   391,    78,    41,     0,
     653,   654,   655,     0,     0,     0,     0,     0,     0,    87,
       0,     0,     0,     8,     9,    88,    10,    11,     0,    89,
       0,     0,     0,     0,    13,    14,  -102,    15,    16,     0,
       0,    18,    19,    20,    21,    22,    23,    24,     0,    25,
      91,    26,     0,     0,    92,    27,     0,    28,    93,    29,
      94,     0,    95,    96,    30,     0,     0,     0,     0,     0,
      97,     0,    31,     0,     0,     0,     0,     0,    98,     0,
      99,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   100,   101,     0,   547,    33,     0,     0,     0,     0,
       0,   104,    35,   105,   106,   107,   548,   108,   656,   550,
     392,     7,   112,   393,   657,     0,   391,    78,    41,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    87,
       0,     0,     0,     8,     9,    88,    10,    11,     0,    89,
       0,     0,     0,     0,    13,    14,     0,    15,    16,     0,
       0,    18,    19,    20,    21,    22,    23,    24,     0,    25,
     311,    26,     0,     0,    92,    27,     0,    28,   312,    29,
      94,     0,    95,    96,    30,     0,     0,     0,     0,     0,
      97,     0,    31,     0,     0,     0,     0,     0,    98,     0,
      99,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   100,   101,     0,   547,    33,     0,     0,     0,     0,
       0,    34,    35,   105,   106,   107,   548,    36,   656,   550,
     392,     0,   112,   393,   799,     7,     0,     0,    41,    76,
     273,     0,    79,    80,   310,    82,    83,    84,    85,    86,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    88,
      10,    11,     0,    12,     0,     0,     0,     0,    13,    14,
       0,    15,    16,     0,     0,     0,    19,    20,    21,    22,
       0,     0,     0,    25,   311,     0,     0,     0,    92,     0,
       0,    28,   312,    29,    94,     0,    95,     0,    30,     0,
       0,     0,     0,     0,    97,     0,    31,     0,     0,     0,
       0,     0,    98,     0,    99,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   100,   101,     0,     0,    33,
     103,     7,     0,     0,     0,    34,    35,   105,   106,   107,
       0,    36,   109,   110,   313,     0,   112,   314,   315,     0,
       0,     0,    41,     0,     0,    88,    10,    11,     0,    12,
       0,     0,     0,     0,    13,    14,     0,    15,    16,  -151,
       0,    18,    19,    20,    21,    22,     0,    24,     0,    25,
     311,    26,     0,     0,    92,     0,     0,    28,   312,    29,
      94,     0,    95,     0,    30,     0,     0,     0,     0,     0,
      97,     0,    31,     0,     0,     0,     0,     0,    98,     0,
      99,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   100,   101,     0,     0,    33,   103,     7,     0,     0,
       0,    34,    35,   105,   106,   107,     0,    36,   109,   110,
     313,     0,   112,   314,     0,     0,     0,     0,    41,     0,
       0,    88,    10,    11,     0,    12,     0,     0,     0,     0,
      13,    14,     0,    15,    16,     0,     0,     0,    19,    20,
      21,    22,     0,     0,     0,    25,   311,     0,     0,     0,
      92,     0,     0,    28,   312,    29,    94,     0,    95,     0,
      30,     0,     0,     0,     0,     0,    97,     0,    31,     0,
       0,     0,     0,     0,    98,     0,    99,     0,     0,     7,
       0,     0,     0,     0,     0,     0,     0,   100,   101,     0,
       0,     0,   103,     0,     0,     0,     0,    34,    35,   105,
     106,   107,     0,    88,    10,    11,   313,    89,   112,   314,
       0,     0,    13,    14,    41,    15,    16,     0,     7,     0,
      19,    20,    21,     0,     0,     0,     0,    25,   311,     0,
       0,     0,    92,     0,     0,    28,   312,    29,    94,     0,
      95,     0,    30,    10,    11,     0,    12,     0,    97,     0,
      31,    13,    14,     0,    15,    16,    98,     0,    99,    19,
      20,    21,     0,     0,     0,     0,    25,     0,     0,   100,
     101,     0,     0,     0,    28,     0,    29,    94,     0,    34,
      35,    30,     0,   107,     0,     0,     0,    97,     0,    31,
       0,     0,     0,     0,     0,    98,    41,    99,     0,     0,
       7,     0,     0,     0,     0,     0,     0,     0,   100,   101,
       0,     0,     0,     0,     0,     0,     0,     0,    34,    35,
     105,   106,   107,     0,     0,    10,    11,     0,    12,   112,
       0,     0,     0,    13,    14,    41,    15,    16,     0,   629,
     630,    19,    20,    21,     0,     0,   631,     0,    25,   632,
     633,   634,     0,     0,     0,     0,    28,     0,    29,     0,
       0,     0,     0,    30,     0,     0,   635,     0,   636,     0,
     637,    31,   638,     0,     0,   629,   630,     0,     0,   639,
     640,    96,   631,     0,     0,   632,   633,   634,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      34,    35,   635,     0,   636,     0,   637,     0,   638,     0,
       0,     0,     0,    33,     0,   639,   640,    41,     0,     0,
       0,     0,     0,     0,     0,    36,   109,   110,   174,     0,
       0,   175,     0,     0,    10,    11,     0,   641,     0,     0,
       0,     0,    13,    14,     0,    15,    16,     0,     0,    33,
      19,    20,     0,     0,     0,     0,     0,    25,     0,     0,
       0,    36,   109,   110,   174,     0,     0,   175,     0,     0,
       0,     0,     0,   793,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    33,     0,     0,     0,     0,     0,     0,
     756,     0,     0,     0,     0,    36,   109,   110,   757,     0,
       0,     0,     0,     0,     0,     0,   758
};

static const yytype_int16 yycheck[] =
{
       3,     4,    92,    95,    90,     3,     3,     3,     4,   171,
       3,     4,     3,     4,     3,     3,     4,   151,     3,     4,
       4,     4,     4,     3,     4,   240,    72,   106,    81,    28,
      29,     4,     4,   112,   311,     4,   183,     4,     4,    56,
       3,   153,     4,    56,   183,   240,    91,    86,    93,   203,
      95,   104,     0,   243,   543,   108,   437,   611,    56,    56,
     248,   543,    21,   418,   419,   420,   240,    56,   423,    21,
     133,    30,   447,   203,   394,    36,    41,   452,     7,    69,
     447,   153,    94,    12,   153,   452,   452,    90,   226,   243,
       1,    94,    21,     1,    90,    72,    21,    90,   386,    90,
     357,    30,    90,     0,   292,    90,    90,    90,    90,    21,
      90,   386,    91,   243,   302,   725,   373,    90,    90,     0,
      81,    90,     0,    90,    90,   188,   503,   504,    90,    88,
     507,   114,    42,   622,    71,    85,   199,   183,   353,    89,
     622,   190,   412,   121,   189,   219,     0,   108,   503,   504,
     153,   133,   706,   124,     7,   126,   371,     1,   353,    88,
      89,   771,    91,    92,    93,    94,    95,   133,     9,     0,
       0,   133,   113,     0,   122,   116,   121,    18,   384,   353,
     270,   118,    21,    22,   636,   123,   638,   164,    72,    21,
     128,     9,    10,   102,   103,   120,   109,   371,    21,   248,
     203,   114,   267,   121,    22,    21,   188,   203,   120,   123,
     203,   122,   203,   351,   122,   203,   285,   199,   203,   203,
     312,   203,   188,   203,   371,   122,   188,     9,   210,   121,
     203,   203,   222,   199,   203,   441,   203,   199,   210,   223,
     243,   622,   121,   292,   122,   120,    21,   243,   320,   437,
     243,   320,   243,   302,   158,   243,   544,   161,   243,   243,
     189,   243,     9,   243,   534,   277,   311,   312,   122,   544,
     243,   243,    22,   202,   243,   481,   243,   597,   122,   485,
     164,   120,    48,   286,   604,   605,    22,   426,   120,   363,
     657,   122,   122,   447,     0,   122,     9,   120,   452,   117,
     374,    39,     8,    86,   120,    11,    12,    13,    14,    15,
      16,    17,    20,    21,    85,   690,   691,   320,    89,   285,
      60,   810,    62,   690,   691,   691,   703,   211,   810,   111,
     112,   113,    85,    99,   116,    75,    89,   607,   267,   413,
     120,   270,   359,   123,   361,   120,   835,   113,   703,   310,
     116,    92,   317,   835,   444,   445,   359,   286,   361,    92,
       4,   123,   359,   359,   361,   361,   359,   344,   361,   507,
     359,   359,   361,   361,   359,   357,   366,   373,   666,   382,
     426,   121,   311,   312,   288,   382,   290,   105,   437,    86,
      87,   373,   123,   382,   123,    13,   359,   123,   361,   382,
     513,   616,   385,   386,   594,   780,   117,   118,    84,    85,
     362,   117,   525,   780,   780,   367,   122,   321,   385,   386,
     324,   616,     9,   385,   386,   488,   539,   123,     9,    85,
      48,   121,   799,   362,    87,    22,   624,   440,   367,    87,
     594,    22,   616,   440,   447,   349,    90,   608,   609,   452,
     447,   440,    96,     7,   835,   452,    66,   440,   447,   443,
     344,   120,   837,   452,   594,   612,   613,   440,    85,   472,
     837,   837,   123,   612,   447,     9,    10,   480,   323,   452,
     447,   484,   123,   480,   443,   452,   104,   484,    22,   133,
     442,   480,   110,   123,   543,   484,   400,   480,   875,   876,
     123,   484,   121,   111,   112,   113,   488,   480,   116,   153,
      97,   484,   203,   442,   443,   444,   445,    98,    85,   725,
     875,    20,   488,    21,   111,   112,   488,   171,    85,   110,
     111,   112,     9,    10,   599,   600,   690,   691,   577,    19,
     385,   386,     9,   472,   188,    22,   636,   124,   638,   764,
      39,   663,   243,   457,    84,   199,   103,     9,    10,   203,
      85,   544,    86,   697,   123,   771,   612,   613,   121,   764,
      22,   500,   575,   622,    86,   624,   593,   544,   575,   121,
     593,    48,   544,    85,     9,    10,   575,    89,    90,   866,
      85,   594,   575,   781,    86,   593,   593,    22,   594,   243,
     653,   594,   123,   594,   593,   123,   594,     9,    10,   594,
     594,     5,   594,    80,   594,    82,   695,   764,   621,   123,
      22,   594,   594,   626,   621,   594,   780,   594,   115,   626,
     792,    85,   621,   848,   840,    89,    90,   626,   621,    82,
      83,   285,    33,   626,   111,   112,   113,   602,   603,   116,
      85,    98,    22,   626,    85,   843,   117,   845,   105,   123,
     127,   808,    39,   110,   111,   112,   872,    85,   874,    33,
     599,   600,   102,    84,    85,    85,   320,    88,   123,    90,
     886,   640,   645,   837,   687,    85,   689,   690,   691,    85,
     687,   382,   689,   690,   691,   740,   741,   100,   687,   789,
     689,   690,   691,   120,   687,    85,   689,   636,   100,   638,
     709,   640,   715,   672,   687,     9,   689,    85,   715,   784,
     785,    89,    90,   690,   691,     9,   715,     3,   807,   373,
      56,    85,   781,   786,   787,    84,    85,    21,   122,    88,
      85,    90,   788,   672,    89,    90,    85,   447,   834,   440,
      89,    90,   452,   111,   112,   113,   123,   123,   116,   849,
     850,   810,   808,   121,   114,   768,   672,   770,    84,    85,
     361,   768,    88,   770,    90,   867,   285,   780,    61,   768,
      56,   770,   215,   780,    61,   285,   835,   770,    61,   480,
     187,   780,   672,   484,   843,    61,   845,     8,   472,   443,
      11,    12,    13,    14,    15,    16,    17,   739,   694,   796,
     454,   740,   741,   780,   856,   674,   466,   669,    94,    84,
      85,   866,   867,    88,   164,    90,   426,   111,   112,   113,
      -1,   834,   116,   836,   837,    19,   120,    -1,   834,   836,
     837,   834,    -1,   834,   488,    -1,   834,   836,   837,   834,
     834,   834,   834,   836,   834,   784,   785,   133,    -1,    85,
     789,   834,   834,    89,    90,   834,   839,   834,   834,    -1,
     837,    -1,   834,   382,    -1,   575,    -1,   153,   111,   112,
     113,    -1,   382,   116,   575,    -1,   111,   112,   113,    -1,
     893,   116,     9,    77,    78,    79,   893,   870,   871,    -1,
     873,    -1,    -1,   594,   893,    -1,   117,    -1,    -1,     9,
     893,    -1,   188,    -1,   887,   888,    -1,   440,   891,   892,
     849,   850,    -1,   199,   447,   829,   626,    -1,    -1,   452,
     621,   440,    -1,   117,   118,   626,    -1,   866,   867,    85,
     440,   125,   126,    89,    90,    -1,    -1,    -1,    48,   853,
     594,    68,    69,    70,     9,    72,    -1,   480,   100,   101,
      -1,   484,    -1,    18,    85,   107,    -1,   611,    89,    90,
      -1,   480,    -1,    -1,    -1,   484,    93,    -1,   882,    -1,
     480,    -1,    82,   492,   484,    -1,   495,   687,    -1,   689,
     690,   691,    -1,    48,    -1,    85,   687,    -1,   689,    89,
      90,    85,   144,    85,   648,    89,    90,    89,    90,   151,
     286,   111,   112,   113,    -1,   715,   116,   159,    68,    69,
      70,    -1,    72,    -1,   715,   669,     8,    98,   672,    11,
      12,    13,    14,    15,    16,    17,    -1,    -1,    -1,   110,
     111,   112,   113,    -1,   320,   116,    -1,   323,     8,    -1,
      -1,    11,    12,    13,    14,    15,   111,   112,   113,    19,
      -1,   116,   706,    68,    69,    70,   575,    72,   768,    -1,
      -1,    13,    14,    15,    -1,   575,    -1,   768,    -1,   770,
     780,   357,    -1,   359,    -1,   361,     9,    10,    48,    -1,
      -1,    -1,    74,    -1,    -1,    18,    -1,   373,    -1,    22,
      -1,    -1,    -1,   626,    -1,    -1,    -1,    -1,    -1,   385,
     386,    53,   621,    95,    74,    -1,    98,   626,    -1,    61,
      -1,   621,   104,   105,   106,   107,   626,    -1,   110,   111,
     112,    -1,    -1,   115,    -1,   117,   836,   837,    98,    -1,
      -1,    -1,    -1,    -1,   104,   836,    -1,    -1,   792,    -1,
     110,   111,   112,   113,    -1,    -1,   116,   117,   118,    -1,
     120,    -1,   104,    -1,   687,    -1,   689,    -1,   110,    -1,
      -1,    -1,    -1,    96,    -1,   117,    -1,    -1,   687,    -1,
     689,    -1,     1,   106,   107,     4,    -1,   687,    -1,   689,
     834,   114,   115,   893,    -1,    -1,   472,    58,    59,    -1,
      -1,    -1,   893,    -1,    -1,    -1,   715,    -1,    -1,    28,
      29,    30,   488,    32,    -1,   715,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    -1,    -1,    45,    46,    47,    48,
      -1,    -1,    -1,    52,    53,    -1,    -1,    98,    57,   100,
     101,    60,    61,    62,    63,    48,    65,    -1,    67,   110,
     111,   112,   113,    -1,    73,   116,    75,    -1,    -1,   768,
     121,   770,    81,    -1,    83,    -1,    -1,    -1,   768,    -1,
     770,    -1,    -1,    -1,    -1,    94,    95,    -1,    -1,    98,
      58,    59,    -1,    -1,    -1,   104,   105,    -1,    -1,   108,
      -1,   110,   111,   112,   113,    98,    -1,   116,    -1,    58,
      59,    -1,   121,   122,    -1,    -1,    -1,   110,   111,   112,
     113,    -1,    -1,   116,    -1,    -1,   839,   593,    -1,   122,
      98,    -1,   100,   101,    -1,    -1,    -1,   836,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   836,    -1,   116,    98,
      -1,   100,   101,   121,   122,    -1,    -1,   870,   871,    -1,
     873,   110,   111,   112,   113,    -1,    -1,   116,    -1,    -1,
      -1,    -1,   121,    -1,   887,   888,    -1,    -1,   891,   892,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      -1,    -1,    -1,    22,   893,    -1,    -1,   663,     0,     1,
      -1,    -1,     4,   893,    -1,    -1,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    -1,    -1,    48,
      22,    -1,    -1,    -1,    26,    27,    28,    29,    30,    -1,
      32,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    -1,    -1,    57,    58,    -1,    60,    61,
      62,    63,    -1,    65,    66,    67,    -1,    96,    -1,    -1,
      99,    73,    -1,    75,    -1,    -1,    -1,   106,   107,    81,
     109,    83,    -1,    -1,   113,   114,   115,   116,    -1,    -1,
      -1,    -1,    94,    95,    -1,    97,    98,    99,    58,    59,
      -1,    -1,   104,   105,   106,   107,   108,    -1,   110,   111,
     112,   113,    -1,   115,   116,   117,    -1,     0,     1,   121,
     122,     4,    -1,    -1,    -1,     8,     9,    -1,    11,    12,
      13,    14,    15,    16,    17,    18,    -1,    -1,    98,    -1,
     100,   101,    -1,    -1,    59,    28,    29,    30,    -1,    32,
     110,   111,   112,   113,    37,    38,   116,    40,    41,    -1,
      -1,   121,    45,    46,    47,    48,    -1,    -1,    -1,    52,
      53,    -1,    -1,    -1,    57,    -1,    -1,    60,    61,    62,
      63,    -1,    65,    98,    67,   100,   101,    -1,    -1,    -1,
      73,    -1,    75,    -1,    -1,   110,   111,   112,    81,    -1,
      83,    -1,    -1,    -1,    -1,    -1,   121,    -1,    -1,    -1,
      -1,    94,    95,    -1,    -1,    98,    99,    58,    -1,    -1,
      -1,   104,   105,   106,   107,   108,    -1,   110,   111,   112,
     113,    -1,   115,   116,   117,    -1,     0,     1,   121,   122,
       4,    -1,    -1,    -1,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    -1,    -1,    98,    22,   100,
      -1,    -1,    26,    27,    28,    29,    30,    -1,    32,   110,
     111,   112,   113,    37,    38,   116,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    -1,    -1,    57,    58,    -1,    60,    61,    62,    63,
      -1,    65,    66,    67,    -1,    -1,    -1,    -1,    -1,    73,
      -1,    75,    -1,    -1,    -1,    -1,    -1,    81,    -1,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    -1,    97,    98,    99,    -1,    -1,    -1,    -1,
     104,   105,   106,   107,   108,    -1,   110,   111,   112,   113,
      -1,   115,   116,   117,    -1,     1,    -1,   121,     4,    -1,
      -1,    -1,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    -1,    -1,    -1,    22,    -1,    -1,    -1,
      26,    27,    28,    29,    30,    -1,    32,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    -1,
      -1,    57,    58,    -1,    60,    61,    62,    63,    -1,    65,
      66,    67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,
      -1,    -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      -1,    97,    98,    99,    -1,    -1,    -1,    -1,   104,   105,
     106,   107,   108,    -1,   110,   111,   112,   113,    -1,   115,
     116,   117,    -1,    -1,     1,   121,   122,     4,    -1,    -1,
      -1,     8,     9,    -1,    11,    12,    13,    14,    15,    16,
      17,    18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    -1,    -1,    45,    46,
      47,    48,    -1,    -1,    -1,    52,    53,    -1,    -1,    -1,
      57,    -1,    -1,    60,    61,    62,    63,    -1,    65,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    -1,
      -1,    98,    99,    -1,    -1,    -1,    -1,   104,   105,   106,
     107,   108,    -1,   110,   111,   112,   113,    -1,   115,   116,
     117,    -1,     0,     1,   121,   122,     4,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,    27,
      -1,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    -1,    54,    -1,    -1,    -1,
      58,    -1,    60,    -1,    62,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     9,    10,
      -1,    -1,    -1,     1,    92,    -1,     4,    18,    -1,    -1,
      98,    22,    -1,    -1,    -1,    -1,   104,   105,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,    -1,    -1,   116,    27,
      -1,    29,    30,   121,    32,    -1,    -1,    48,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    -1,    54,    -1,    -1,    -1,
      58,    -1,    60,    -1,    62,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    75,    11,    12,
      13,    14,    15,    -1,    -1,    96,    19,    -1,    99,     1,
      -1,    -1,     4,    -1,    -1,   106,   107,    -1,   109,    -1,
      98,    -1,   113,   114,   115,   116,   104,   105,    -1,    -1,
      -1,    -1,   110,   111,   112,    48,    -1,    29,    30,    -1,
      32,    -1,    -1,   121,   122,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    74,    54,    -1,    -1,    -1,    58,    -1,    60,    -1,
      62,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    75,    -1,    98,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,
     113,    -1,    -1,   116,   117,   118,    98,   120,    -1,    -1,
      -1,    -1,   104,   105,    -1,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,     1,    -1,    -1,     4,    -1,   121,
     122,     8,     9,    -1,    11,    12,    13,    14,    15,    16,
      17,    18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    -1,    -1,    45,    46,
      47,    48,    -1,    -1,    -1,    52,    53,    -1,    -1,    -1,
      57,    -1,    -1,    60,    61,    62,    63,    -1,    65,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    76,
      -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    -1,
      -1,    98,    99,    -1,    -1,    -1,    -1,   104,   105,   106,
     107,   108,    -1,   110,   111,   112,   113,    -1,   115,   116,
     117,     4,    -1,    -1,   121,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    -1,    -1,    -1,    22,
      -1,    -1,    -1,    26,    27,    28,    29,    30,    -1,    32,
      -1,    -1,    -1,    -1,    37,    38,    39,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    -1,    -1,    57,    58,    -1,    60,    61,    62,
      63,    -1,    65,    66,    67,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    75,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      83,    -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    -1,    97,    98,    -1,    -1,    -1,    -1,
      -1,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,   116,   117,     4,    -1,    -1,   121,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    26,    27,    28,
      29,    30,    -1,    32,    33,    -1,    -1,    -1,    37,    38,
      39,    40,    41,    -1,    -1,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    -1,    -1,    57,    58,
      -1,    60,    61,    62,    63,    -1,    65,    66,    67,    -1,
      -1,    -1,    -1,    -1,    73,    -1,    75,    -1,    -1,    -1,
      -1,    -1,    81,    -1,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    -1,    97,    98,
      -1,    -1,    -1,    -1,    -1,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,   116,   117,     4,
      -1,    -1,   121,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    -1,    -1,    -1,    22,    -1,    -1,
      -1,    26,    27,    28,    29,    30,    -1,    32,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      -1,    -1,    57,    58,    -1,    60,    61,    62,    63,    -1,
      65,    66,    67,    -1,    -1,    -1,    -1,    -1,    73,    -1,
      75,    -1,    -1,    -1,    -1,    -1,    81,    -1,    83,    -1,
      -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    -1,    97,    98,    -1,    -1,    -1,    -1,    -1,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,   116,   117,     4,    -1,    -1,   121,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    26,    27,    28,    29,    30,
      -1,    32,    33,    -1,    -1,    -1,    37,    38,    39,    40,
      41,    -1,    -1,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    -1,    -1,    57,    58,    -1,    60,
      61,    62,    63,    -1,    65,    66,    67,    -1,    -1,    -1,
      -1,    -1,    73,    -1,    75,    -1,    -1,    -1,    -1,    -1,
      81,    -1,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    -1,    97,    98,    -1,    -1,
      -1,    -1,    -1,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,   116,   117,     4,    -1,    -1,
     121,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    -1,    -1,    -1,    22,    -1,    -1,    -1,    26,
      27,    28,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,
      37,    38,    39,    40,    41,    -1,    -1,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    -1,    -1,
      57,    58,    -1,    60,    61,    62,    63,    -1,    65,    66,
      67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    -1,
      97,    98,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,   116,
     117,     4,    -1,    -1,   121,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    -1,    -1,    -1,    22,
      -1,    -1,    -1,    26,    27,    28,    29,    30,    -1,    32,
      33,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      -1,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    -1,    -1,    57,    58,    -1,    60,    61,    62,
      63,    -1,    65,    66,    67,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    75,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    -1,    97,    98,    -1,    -1,    -1,    -1,
      -1,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,   116,   117,     4,    -1,    -1,   121,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    26,    27,    28,
      29,    30,    -1,    32,    -1,    -1,    -1,    -1,    37,    38,
      39,    40,    41,    -1,    -1,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    -1,    -1,    57,    58,
      -1,    60,    61,    62,    63,    -1,    65,    66,    67,    -1,
      -1,    -1,    -1,    -1,    73,    -1,    75,    -1,    -1,    -1,
      -1,    -1,    81,    -1,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    -1,    97,    98,
      -1,    -1,    -1,    -1,    -1,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,   116,   117,     4,
      -1,    -1,   121,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    -1,    -1,    -1,    22,    -1,    -1,
      -1,    26,    27,    28,    29,    30,    -1,    32,    -1,    -1,
      -1,    -1,    37,    38,    39,    40,    41,    -1,    -1,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      -1,    -1,    57,    58,    -1,    60,    61,    62,    63,    -1,
      65,    66,    67,    -1,    -1,    -1,    -1,    -1,    73,    -1,
      75,    -1,    -1,    -1,    -1,    -1,    81,    -1,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    -1,    97,    98,    -1,    -1,    -1,    -1,    -1,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,   116,   117,     4,    -1,    -1,   121,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    26,    27,    28,    29,    30,
      -1,    32,    -1,    -1,    -1,    -1,    37,    38,    39,    40,
      41,    -1,    -1,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    -1,    -1,    57,    58,    -1,    60,
      61,    62,    63,    -1,    65,    66,    67,    -1,    -1,    -1,
      -1,    -1,    73,    -1,    75,    -1,    -1,    -1,    -1,    -1,
      81,    -1,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    -1,    97,    98,    -1,    -1,
      -1,    -1,    -1,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,   116,   117,     4,    -1,    -1,
     121,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    -1,    -1,    -1,    22,    -1,    -1,    -1,    26,
      27,    28,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    -1,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    -1,    -1,
      57,    58,    -1,    60,    61,    62,    63,    -1,    65,    66,
      67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    -1,
      97,    98,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,   116,
     117,     4,    -1,    -1,   121,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    -1,    -1,    -1,    -1,    22,
      -1,    -1,    -1,    26,    27,    28,    29,    30,    -1,    32,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      -1,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    -1,    -1,    57,    58,    -1,    60,    61,    62,
      63,    -1,    65,    66,    67,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    75,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    -1,    97,    98,    -1,    -1,    -1,    -1,
      -1,   104,   105,   106,   107,   108,    -1,   110,   111,   112,
     113,     4,   115,   116,   117,    -1,     9,    10,   121,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      -1,    -1,    -1,    26,    27,    28,    29,    30,    -1,    32,
      -1,    -1,    -1,    -1,    37,    38,    39,    40,    41,    -1,
      -1,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    -1,    -1,    57,    58,    -1,    60,    61,    62,
      63,    -1,    65,    66,    67,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    75,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    -1,    97,    98,    -1,    -1,    -1,    -1,
      -1,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,     4,   115,   116,   117,    -1,     9,    10,   121,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      -1,    -1,    -1,    26,    27,    28,    29,    30,    -1,    32,
      -1,    -1,    -1,    -1,    37,    38,    39,    40,    41,    -1,
      -1,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    -1,    -1,    57,    58,    -1,    60,    61,    62,
      63,    -1,    65,    66,    67,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    75,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    -1,    97,    98,    -1,    -1,    -1,    -1,
      -1,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,     4,   115,   116,   117,    -1,     9,    10,   121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      -1,    -1,    -1,    26,    27,    28,    29,    30,    -1,    32,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      -1,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    -1,    -1,    57,    58,    -1,    60,    61,    62,
      63,    -1,    65,    66,    67,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    75,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    -1,    97,    98,    -1,    -1,    -1,    -1,
      -1,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,   116,   117,     4,    -1,    -1,   121,     8,
       9,    -1,    11,    12,    13,    14,    15,    16,    17,    18,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      29,    30,    -1,    32,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    -1,    -1,    45,    46,    47,    48,
      -1,    -1,    -1,    52,    53,    -1,    -1,    -1,    57,    -1,
      -1,    60,    61,    62,    63,    -1,    65,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    73,    -1,    75,    -1,    -1,    -1,
      -1,    -1,    81,    -1,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    -1,    -1,    98,
      99,     4,    -1,    -1,    -1,   104,   105,   106,   107,   108,
      -1,   110,   111,   112,   113,    -1,   115,   116,   117,    -1,
      -1,    -1,   121,    -1,    -1,    28,    29,    30,    -1,    32,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    -1,    50,    -1,    52,
      53,    54,    -1,    -1,    57,    -1,    -1,    60,    61,    62,
      63,    -1,    65,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    75,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    -1,    -1,    98,    99,     4,    -1,    -1,
      -1,   104,   105,   106,   107,   108,    -1,   110,   111,   112,
     113,    -1,   115,   116,    -1,    -1,    -1,    -1,   121,    -1,
      -1,    28,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    -1,    -1,    45,    46,
      47,    48,    -1,    -1,    -1,    52,    53,    -1,    -1,    -1,
      57,    -1,    -1,    60,    61,    62,    63,    -1,    65,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    -1,
      -1,    -1,    99,    -1,    -1,    -1,    -1,   104,   105,   106,
     107,   108,    -1,    28,    29,    30,   113,    32,   115,   116,
      -1,    -1,    37,    38,   121,    40,    41,    -1,     4,    -1,
      45,    46,    47,    -1,    -1,    -1,    -1,    52,    53,    -1,
      -1,    -1,    57,    -1,    -1,    60,    61,    62,    63,    -1,
      65,    -1,    67,    29,    30,    -1,    32,    -1,    73,    -1,
      75,    37,    38,    -1,    40,    41,    81,    -1,    83,    45,
      46,    47,    -1,    -1,    -1,    -1,    52,    -1,    -1,    94,
      95,    -1,    -1,    -1,    60,    -1,    62,    63,    -1,   104,
     105,    67,    -1,   108,    -1,    -1,    -1,    73,    -1,    75,
      -1,    -1,    -1,    -1,    -1,    81,   121,    83,    -1,    -1,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,   105,
     106,   107,   108,    -1,    -1,    29,    30,    -1,    32,   115,
      -1,    -1,    -1,    37,    38,   121,    40,    41,    -1,    24,
      25,    45,    46,    47,    -1,    -1,    31,    -1,    52,    34,
      35,    36,    -1,    -1,    -1,    -1,    60,    -1,    62,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    51,    -1,    53,    -1,
      55,    75,    57,    -1,    -1,    24,    25,    -1,    -1,    64,
      65,    66,    31,    -1,    -1,    34,    35,    36,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     104,   105,    51,    -1,    53,    -1,    55,    -1,    57,    -1,
      -1,    -1,    -1,    98,    -1,    64,    65,   121,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,    -1,
      -1,   116,    -1,    -1,    29,    30,    -1,   122,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    -1,    -1,    98,
      45,    46,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,   110,   111,   112,   113,    -1,    -1,   116,    -1,    -1,
      -1,    -1,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,
     105,    -1,    -1,    -1,    -1,   110,   111,   112,   113,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   121
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    91,   130,   132,   131,     0,     1,     4,    26,    27,
      29,    30,    32,    37,    38,    40,    41,    43,    44,    45,
      46,    47,    48,    49,    50,    52,    54,    58,    60,    62,
      67,    75,    92,    98,   104,   105,   110,   111,   112,   113,
     116,   121,   133,   134,   136,   140,   145,   146,   147,   148,
     157,   160,   163,   169,   170,   171,   173,   177,   183,   184,
     185,   193,   195,   197,   198,   199,   200,   218,   222,   223,
     224,   303,   305,   306,   307,     1,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    22,    28,    32,
      43,    53,    57,    61,    63,    65,    66,    73,    81,    83,
      94,    95,    97,    99,   104,   106,   107,   108,   110,   111,
     112,   113,   115,   116,   117,   134,   135,   138,   140,   141,
     142,   145,   150,   151,   152,   153,   157,   160,   163,   169,
     175,   178,   179,   180,   181,   182,   186,   187,   198,   225,
     237,   238,   243,   244,   245,   249,   251,   252,   253,   254,
     261,   262,   263,   268,   271,   272,   276,   284,   285,   286,
     287,   288,   298,   303,   305,   306,   307,   308,   113,   116,
     135,   240,   121,   121,   113,   116,   135,   241,   113,   116,
     135,   240,   241,   304,   121,   177,   177,   241,   176,   120,
      85,    89,    90,   206,   208,   210,   214,   215,   210,   176,
      42,   144,   120,   123,   121,     1,   112,   122,   136,   148,
     174,   305,   306,   179,   195,   196,   197,   243,   284,     7,
     194,   200,   190,   191,    58,    59,   100,   101,   113,   116,
     121,   138,   309,   310,   312,   313,   315,   316,   318,   325,
     326,   327,   329,   123,     9,    22,   273,    22,    85,    89,
     210,   212,     9,   266,   266,   273,   241,   121,   142,     9,
     113,   116,   135,   202,   203,   204,   205,   233,   234,   203,
     236,   202,   235,     9,   113,   116,   135,   239,   271,   307,
     235,   105,   138,   188,   189,   246,   282,   269,   270,   272,
     270,   270,    85,    89,   212,    20,    21,   257,   259,   260,
     257,   270,    85,    89,   212,   257,     9,   141,   266,    39,
      13,    53,    61,   113,   116,   117,   138,   180,   182,   252,
     268,   272,   307,    86,   270,   269,   270,   301,    14,    15,
      19,    74,   113,   116,   117,   118,   120,   138,   151,   218,
     254,   255,   265,   267,   305,   307,   275,   250,   250,   270,
     250,   100,   323,   326,     9,    22,   138,   300,    92,   158,
      92,   161,   123,   219,   105,   220,   221,   123,   100,   310,
     312,   326,   164,   166,   219,     1,    76,   180,   202,    89,
     209,   214,   216,   217,    85,    87,    87,   122,   121,   202,
     226,     9,   113,   116,   117,   138,   149,   150,   182,   205,
     251,   284,   295,   296,   297,   298,   299,   307,   153,   172,
     182,   194,   190,     7,   200,   187,   330,   314,    84,    85,
      88,    90,   321,    84,   321,   322,   317,   311,   102,   103,
     313,   325,   327,   328,   329,   149,   120,    85,    89,   213,
     216,    85,   123,   156,    21,   120,   226,   123,   203,   228,
     229,   230,   123,   271,   123,   121,    74,    95,   105,   138,
     218,   247,   248,   252,   262,   263,   264,     9,    80,    82,
     113,   116,   127,   135,   277,   279,   281,   307,   250,   250,
     216,    85,    20,    21,   216,    85,   234,   235,   176,   250,
     287,   250,    68,    69,    70,    72,   290,    19,   302,   323,
     124,   252,   250,    84,    85,   324,    39,   100,   178,     1,
     112,   122,   136,   159,   160,   163,   168,   169,   198,   303,
     307,     1,   112,   122,   136,   162,   163,   168,   198,   303,
     307,   240,   190,   200,   240,     1,   122,   138,   165,   167,
     169,   178,   190,    85,    87,     9,    18,    97,   109,   111,
     112,   113,   116,   117,   134,   137,   139,   140,   145,   153,
     157,   160,   163,   169,   182,   187,   251,   262,   263,   298,
     303,   307,   308,    86,    89,   206,   211,    96,   109,   114,
     201,   207,   272,   284,   287,   298,   109,   201,   207,   272,
     284,   287,   298,   143,   123,    22,     9,   117,   297,    21,
     120,   250,   117,   118,   124,   126,   220,   190,   121,   121,
     322,   322,   322,   322,   122,   312,   326,   328,   331,    86,
     213,   216,    85,   152,    85,    89,   206,   212,   240,    24,
      25,    31,    34,    35,    36,    51,    53,    55,    57,    64,
      65,   122,   135,   138,   154,   155,   187,   227,   231,   232,
     241,   203,   203,    13,    14,    15,   111,   117,   139,   152,
     205,   238,   242,   268,   284,   299,    86,   152,   242,   123,
     294,   300,   192,   250,   301,   279,    19,    77,    78,    79,
     117,   118,   125,   126,   278,   280,   152,   206,   152,   206,
     123,   123,   262,   262,   289,   123,   128,   256,     9,    22,
      97,   135,   274,    84,   322,   324,   322,   324,   324,     5,
     144,   144,   220,   144,    89,   209,   217,   201,   207,   272,
     284,   298,     9,    10,    22,    85,     9,    18,   111,   113,
     116,   117,   139,   251,   262,   263,   298,   307,    33,   273,
      21,   120,   112,   122,   136,   148,   149,   226,   226,   296,
     296,   297,   297,   220,   164,   164,   105,   113,   121,   138,
     222,   319,   312,   310,   326,   331,   328,    89,   209,   213,
     216,    85,   152,   228,   228,   241,   198,   113,   116,   138,
     123,    85,    89,   299,    21,   120,   104,   110,   305,   109,
     201,   294,   117,   122,   154,   232,   302,   152,   152,   117,
       9,    93,   290,   291,   292,   293,   257,   269,   322,   177,
      85,     9,    10,    18,    22,   111,   113,   116,   117,   139,
     251,   262,   263,   307,    33,   211,     9,    10,    22,   275,
     202,   202,   122,   122,   320,    85,   206,   123,   242,   216,
      85,   226,   226,    85,    89,    85,    89,   100,   326,    21,
     120,   203,   300,   256,    71,   118,   120,   257,   258,   217,
       9,    10,    22,   250,   142,   242,    53,    61,   117,    89,
     206,   216,    85,   216,    85,    85,   100,   203,   203,   250,
     293,    56,   283,   122,   234,   235,    85,   206,   206,   322,
     250,   123,   123,   206
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   129,   130,   131,   130,   132,   132,   132,   132,   132,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   134,   134,   135,   135,   136,   136,   136,   137,   137,
     137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
     137,   138,   138,   138,   139,   139,   139,   140,   141,   141,
     141,   142,   142,   142,   142,   142,   142,   142,   142,   143,
     143,   143,   143,   144,   146,   145,   147,   147,   148,   148,
     148,   149,   149,   149,   149,   149,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     150,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     152,   152,   152,   152,   152,   152,   152,   152,   153,   154,
     155,   154,   156,   156,   156,   156,   157,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   159,   158,   158,
     160,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     162,   161,   161,   163,   164,   164,   165,   165,   165,   166,
     166,   167,   166,   168,   169,   170,   170,   170,   171,   172,
     172,   173,   173,   173,   173,   174,   173,   173,   175,   175,
     175,   176,   176,   176,   177,   178,   178,   178,   179,   180,
     180,   180,   180,   180,   181,   182,   182,   183,   183,   184,
     184,   185,   185,   186,   186,   186,   188,   187,   187,   189,
     189,   190,   191,   191,   192,   192,   192,   193,   193,   194,
     194,   195,   195,   195,   195,   195,   196,   196,   196,   197,
     197,   197,   198,   198,   198,   199,   199,   199,   200,   200,
     201,   201,   201,   202,   202,   202,   203,   203,   204,   204,
     205,   205,   206,   206,   206,   206,   206,   206,   206,   206,
     206,   206,   206,   206,   206,   206,   207,   208,   208,   208,
     208,   208,   208,   208,   208,   209,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   210,   210,   211,   211,
     212,   212,   212,   212,   213,   213,   213,   213,   214,   214,
     214,   214,   214,   214,   214,   214,   214,   214,   214,   214,
     215,   215,   215,   215,   215,   215,   215,   215,   215,   215,
     216,   216,   216,   217,   217,   218,   219,   219,   221,   220,
     220,   222,   222,   223,   223,   223,   223,   223,   224,   224,
     224,   224,   225,   226,   227,   227,   227,   227,   228,   229,
     230,   230,   230,   230,   231,   231,   231,   231,   231,   231,
     231,   231,   231,   232,   232,   232,   232,   233,   234,   234,
     235,   236,   237,   237,   237,   237,   238,   238,   238,   239,
     239,   239,   239,   240,   240,   240,   241,   241,   241,   242,
     242,   242,   242,   242,   242,   242,   242,   243,   243,   243,
     243,   243,   244,   245,   245,   246,   246,   247,   247,   247,
     247,   248,   248,   248,   249,   250,   250,   251,   251,   251,
     251,   251,   251,   251,   251,   252,   252,   253,   254,   254,
     254,   254,   255,   255,   256,   256,   257,   257,   257,   258,
     259,   259,   260,   260,   261,   262,   263,   263,   264,   264,
     265,   265,   265,   265,   266,   267,   267,   267,   267,   267,
     267,   267,   268,   268,   268,   269,   269,   270,   271,   271,
     272,   273,   273,   274,   274,   275,   275,   275,   275,   276,
     276,   277,   277,   277,   277,   277,   278,   278,   278,   279,
     279,   279,   279,   279,   280,   280,   280,   280,   281,   281,
     282,   282,   283,   283,   284,   284,   285,   285,   286,   286,
     286,   286,   287,   288,   288,   289,   289,   290,   290,   290,
     290,   291,   291,   291,   292,   292,   293,   293,   293,   294,
     294,   295,   295,   295,   296,   296,   296,   297,   297,   298,
     298,   298,   299,   299,   299,   300,   300,   300,   301,   301,
     302,   302,   304,   303,   305,   306,   307,   307,   308,   309,
     309,   309,   311,   310,   312,   312,   313,   313,   313,   314,
     313,   315,   316,   317,   317,   317,   318,   320,   319,   321,
     321,   321,   321,   321,   321,   321,   322,   322,   323,   323,
     324,   324,   324,   324,   325,   326,   326,   327,   327,   328,
     328,   330,   329,   329,   329,   331,   331
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     3,     0,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       2,     0,     1,     1,     1,     2,     3,     1,     2,     0,
       2,     2,     2,     4,     0,     2,     1,     1,     3,     5,
       3,     1,     1,     3,     3,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     4,     4,     4,     5,     5,     5,
       1,     3,     3,     4,     4,     3,     2,     1,     4,     1,
       0,     2,     0,     2,     2,     2,     4,     0,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     0,     3,     2,
       4,     0,     1,     2,     2,     2,     2,     2,     2,     2,
       0,     3,     2,     4,     1,     2,     1,     1,     1,     0,
       2,     0,     3,     1,     2,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     0,     3,     2,     4,     5,
       2,     0,     2,     2,     3,     1,     1,     1,     1,     1,
       1,     1,     3,     2,     1,     1,     1,     4,     6,     2,
       1,     2,     3,     1,     1,     1,     0,     5,     2,     1,
       1,     1,     0,     2,     0,     2,     2,     4,     4,     3,
       4,     1,     1,     1,     3,     5,     1,     1,     1,     3,
       2,     2,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     3,     3,     1,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     4,     5,     5,     5,     4,     4,     3,
       3,     3,     3,     3,     3,     3,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     1,     4,     4,     4,     4,
       4,     4,     4,     4,     5,     5,     5,     4,     4,     4,
       4,     3,     3,     3,     3,     3,     1,     4,     1,     3,
       2,     2,     3,     3,     2,     2,     3,     3,     1,     3,
       3,     3,     4,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     4,     4,
       1,     4,     2,     1,     3,     2,     0,     2,     0,     2,
       1,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     1,     3,     2,     4,     2,     3,     1,
       1,     5,     5,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     1,     1,     2,
       1,     1,     4,     3,     4,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     3,     3,     2,     3,     3,
       1,     1,     3,     3,     3,     0,     2,     5,     2,     1,
       1,     1,     1,     1,     2,     0,     2,     1,     2,     1,
       1,     2,     2,     2,     2,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     0,     2,     0,     1,     1,     1,
       1,     2,     1,     2,     2,     2,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     1,     2,     2,
       2,     0,     2,     1,     1,     0,     3,     3,     3,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     1,     1,     1,     1,     1,     2,
       0,     2,     0,     1,     8,     2,     2,     2,     1,     1,
       1,     1,     3,     2,     4,     0,     2,     1,     1,     2,
       2,     1,     1,     1,     1,     3,     1,     2,     2,     1,
       3,     3,     3,     1,     1,     3,     3,     2,     1,     1,
       1,     2,     1,     1,     2,     1,     1,     1,     0,     2,
       0,     2,     0,     3,     1,     2,     2,     1,     3,     1,
       2,     1,     0,     3,     1,     1,     1,     1,     2,     0,
       5,     2,     3,     0,     2,     2,     2,     0,     4,     3,
       3,     3,     3,     3,     3,     1,     1,     3,     2,     3,
       2,     2,     2,     2,     3,     1,     2,     1,     1,     1,
       1,     0,     5,     2,     2,     2,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, parser, retval, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, parser, retval); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Lily_parser *parser, SCM *retval)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  YYUSE (parser);
  YYUSE (retval);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Lily_parser *parser, SCM *retval)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yytype, yyvaluep, yylocationp, parser, retval);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, Lily_parser *parser, SCM *retval)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , parser, retval);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, parser, retval); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
#  else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                yy_state_t *yyssp, int yytoken)
{
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Actual size of YYARG. */
  int yycount = 0;
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      YYPTRDIFF_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
      yysize = yysize0;
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYPTRDIFF_T yysize1
                    = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    /* Don't count the "%s"s in the final size, but reserve room for
       the terminator.  */
    YYPTRDIFF_T yysize1 = yysize + (yystrlen (yyformat) - 2 * yycount) + 1;
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, Lily_parser *parser, SCM *retval)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (parser);
  YYUSE (retval);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (Lily_parser *parser, SCM *retval)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYPTRDIFF_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, parser);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3:
#line 393 "parser.yy"
                        {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 3196 "./out/parser.cc"
    break;

  case 4:
#line 395 "parser.yy"
                            {
		parser->lexer_->pop_state ();
                *retval = yyvsp[0];
 	}
#line 3205 "./out/parser.cc"
    break;

  case 5:
#line 401 "parser.yy"
                            { yyval = SCM_UNSPECIFIED; }
#line 3211 "./out/parser.cc"
    break;

  case 6:
#line 402 "parser.yy"
                                       {
	}
#line 3218 "./out/parser.cc"
    break;

  case 7:
#line 404 "parser.yy"
                              {
	}
#line 3225 "./out/parser.cc"
    break;

  case 8:
#line 406 "parser.yy"
                         {
		parser->error_level_ = 1;
	}
#line 3233 "./out/parser.cc"
    break;

  case 9:
#line 409 "parser.yy"
                                {
		parser->error_level_ = 1;
	}
#line 3241 "./out/parser.cc"
    break;

  case 10:
#line 416 "parser.yy"
                     {
		parser->lexer_->set_identifier (ly_symbol2scm ("$defaultheader"), yyvsp[0]);
	}
#line 3249 "./out/parser.cc"
    break;

  case 11:
#line 419 "parser.yy"
                     {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-book-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3258 "./out/parser.cc"
    break;

  case 12:
#line 423 "parser.yy"
                         {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-bookpart-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3267 "./out/parser.cc"
    break;

  case 13:
#line 427 "parser.yy"
                          {
		SCM proc = parser->lexer_->lookup_identifier
			(unsmob<Book>(yyvsp[0])->paper_
			 ? "toplevel-book-handler"
			 : "toplevel-bookpart-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3279 "./out/parser.cc"
    break;

  case 14:
#line 434 "parser.yy"
                      {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-score-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3288 "./out/parser.cc"
    break;

  case 15:
#line 438 "parser.yy"
                          {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-music-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3297 "./out/parser.cc"
    break;

  case 16:
#line 442 "parser.yy"
                      {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
		scm_call_1 (proc, scm_list_1 (yyvsp[0]));
	}
#line 3306 "./out/parser.cc"
    break;

  case 17:
#line 446 "parser.yy"
                           {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3315 "./out/parser.cc"
    break;

  case 18:
#line 450 "parser.yy"
                    {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3324 "./out/parser.cc"
    break;

  case 19:
#line 455 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
			scm_call_1 (proc, out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("toplevel-score-handler");
			scm_call_1 (proc, yyvsp[0]);
		} else if (Output_def * od = unsmob<Output_def> (yyvsp[0])) {
			SCM id = SCM_EOL;

			if (to_boolean (od->c_variable ("is-paper")))
				id = ly_symbol2scm ("$defaultpaper");
			else if (to_boolean (od->c_variable ("is-midi")))
				id = ly_symbol2scm ("$defaultmidi");
			else if (to_boolean (od->c_variable ("is-layout")))
				id = ly_symbol2scm ("$defaultlayout");

			parser->lexer_->set_identifier (id, yyvsp[0]);
		} else if (ly_is_module (yyvsp[0]))
		{
			SCM module = get_header (parser);
			ly_module_copy (module, yyvsp[0]);
			parser->lexer_->set_identifier
				(ly_symbol2scm ("$defaultheader"), module);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 3363 "./out/parser.cc"
    break;

  case 20:
#line 489 "parser.yy"
                     {
		SCM id = SCM_EOL;
		Output_def * od = unsmob<Output_def> (yyvsp[0]);

		if (to_boolean (od->c_variable ("is-paper")))
			id = ly_symbol2scm ("$defaultpaper");
		else if (to_boolean (od->c_variable ("is-midi")))
			id = ly_symbol2scm ("$defaultmidi");
		else if (to_boolean (od->c_variable ("is-layout")))
			id = ly_symbol2scm ("$defaultlayout");

		parser->lexer_->set_identifier (id, yyvsp[0]);
	}
#line 3381 "./out/parser.cc"
    break;

  case 22:
#line 507 "parser.yy"
        {
		yyval = loc_on_copy (parser, (yyloc),
				  nested_property (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 3390 "./out/parser.cc"
    break;

  case 23:
#line 515 "parser.yy"
        {
		yyval = parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3398 "./out/parser.cc"
    break;

  case 29:
#line 530 "parser.yy"
        {
		yyval = parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3406 "./out/parser.cc"
    break;

  case 47:
#line 570 "parser.yy"
                                      {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 3415 "./out/parser.cc"
    break;

  case 48:
#line 578 "parser.yy"
        {
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 3423 "./out/parser.cc"
    break;

  case 50:
#line 583 "parser.yy"
        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 3431 "./out/parser.cc"
    break;

  case 51:
#line 590 "parser.yy"
        {
		// FIXME: @$ does not contain a useful source location
		// for empty rules, and the only token in the whole
		// production, EMBEDDED_LILY, is synthetic and also
		// contains no source location.
		yyval = MAKE_SYNTAX (void_music, (yyloc));
	}
#line 3443 "./out/parser.cc"
    break;

  case 54:
#line 600 "parser.yy"
        {
		if (!unsmob<Music> (yyvsp[0]))
			yyval = MY_MAKE_MUSIC ("PostEvents", (yyloc))->unprotect ();
	}
#line 3452 "./out/parser.cc"
    break;

  case 55:
#line 605 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0])) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

			parser->default_duration_ = *unsmob<Duration> (yyvsp[-1]);
			n->set_property ("duration", yyvsp[-1]);
			n->set_property ("articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
			yyval = n->unprotect ();
		}
	}
#line 3468 "./out/parser.cc"
    break;

  case 56:
#line 616 "parser.yy"
                                                   {
		SCM tail = SCM_EOL;
		if (unsmob<Music> (yyvsp[-2]))
			tail = scm_cons (yyvsp[-2], tail);
		if (unsmob<Music> (yyvsp[-1]))
			tail = scm_cons (yyvsp[-1], tail);
		yyval = reverse_music_list (parser, (yyloc),
					 scm_append_x (scm_list_2 (yyvsp[0], tail)),
					 true, true);
		if (scm_is_pair (yyval)) // unpackaged list
			if (scm_is_null (scm_cdr (yyval)))
				yyval = scm_car (yyval); // single expression
			else
				yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyval);
		else if (scm_is_null (yyval))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		// else already packaged post-event
	}
#line 3491 "./out/parser.cc"
    break;

  case 57:
#line 634 "parser.yy"
                {
		parser->error_level_ = 1;
                yyval = SCM_UNSPECIFIED;
	}
#line 3500 "./out/parser.cc"
    break;

  case 58:
#line 638 "parser.yy"
                                    {
		parser->error_level_ = 1;
                yyval = yyvsp[0];
	}
#line 3509 "./out/parser.cc"
    break;

  case 59:
#line 646 "parser.yy"
                    { yyval = SCM_UNSPECIFIED; }
#line 3515 "./out/parser.cc"
    break;

  case 60:
#line 647 "parser.yy"
                                           {

	}
#line 3523 "./out/parser.cc"
    break;

  case 61:
#line 650 "parser.yy"
                                         {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3532 "./out/parser.cc"
    break;

  case 62:
#line 654 "parser.yy"
                                                   {
		if (ly_is_module (yyvsp[0]))
			ly_module_copy (scm_current_module (), yyvsp[0]);
		else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 3543 "./out/parser.cc"
    break;

  case 63:
#line 663 "parser.yy"
                                                {
		yyval = parser->lexer_->remove_scope ();
	}
#line 3551 "./out/parser.cc"
    break;

  case 64:
#line 669 "parser.yy"
        {
		parser->lexer_->add_scope (get_header (parser));
	}
#line 3559 "./out/parser.cc"
    break;

  case 65:
#line 671 "parser.yy"
                          {
		yyval = yyvsp[0];
	}
#line 3567 "./out/parser.cc"
    break;

  case 66:
#line 681 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 3575 "./out/parser.cc"
    break;

  case 67:
#line 685 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 3583 "./out/parser.cc"
    break;

  case 68:
#line 691 "parser.yy"
                                           {
	        parser->lexer_->set_identifier (yyvsp[-2], yyvsp[0]);
                yyval = SCM_UNSPECIFIED;
	}
#line 3592 "./out/parser.cc"
    break;

  case 69:
#line 695 "parser.yy"
                                                              {
		SCM path = scm_cons (yyvsp[-4], yyvsp[-2]);
		parser->lexer_->set_identifier (path, yyvsp[0]);
                yyval = SCM_UNSPECIFIED;
	}
#line 3602 "./out/parser.cc"
    break;

  case 70:
#line 701 "parser.yy"
        {
		if (scm_is_false (Lily::markup_function_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _ ("Not a markup function"));
		} else {
			Lily::define_markup_command_internal
 				(scm_string_to_symbol (yyvsp[-2]), yyvsp[0], SCM_BOOL_F);
		}
		yyval = SCM_UNSPECIFIED;
	}
#line 3617 "./out/parser.cc"
    break;

  case 73:
#line 718 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 3625 "./out/parser.cc"
    break;

  case 74:
#line 722 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 3633 "./out/parser.cc"
    break;

  case 75:
#line 726 "parser.yy"
        {
		yyval = post_event_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
		if (scm_is_pair (yyval)
		    && scm_is_null (scm_cdr (yyval)))
			yyval = scm_car (yyval);
		else
		{
			Music * m = MY_MAKE_MUSIC ("PostEvents", (yyloc));
			m->set_property ("elements", yyval);
			yyval = m->unprotect ();
		}
	}
#line 3650 "./out/parser.cc"
    break;

  case 90:
#line 756 "parser.yy"
        {
		yyval = MAKE_SYNTAX (partial_music_function, (yyloc),
				  scm_reverse_x (yyvsp[-1], SCM_EOL));
	}
#line 3659 "./out/parser.cc"
    break;

  case 91:
#line 766 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3667 "./out/parser.cc"
    break;

  case 92:
#line 770 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3675 "./out/parser.cc"
    break;

  case 93:
#line 774 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3683 "./out/parser.cc"
    break;

  case 94:
#line 778 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3691 "./out/parser.cc"
    break;

  case 95:
#line 782 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3699 "./out/parser.cc"
    break;

  case 96:
#line 786 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3707 "./out/parser.cc"
    break;

  case 97:
#line 790 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 3715 "./out/parser.cc"
    break;

  case 98:
#line 794 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 3723 "./out/parser.cc"
    break;

  case 99:
#line 798 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 3731 "./out/parser.cc"
    break;

  case 101:
#line 806 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_override,
					     scm_cdr (yyvsp[-1]), scm_car (yyvsp[-1])),
				 SCM_EOL);
	}
#line 3745 "./out/parser.cc"
    break;

  case 102:
#line 816 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_set,
					     scm_cadr (yyvsp[-1]), scm_car (yyvsp[-1])),
				 SCM_EOL);
	}
#line 3759 "./out/parser.cc"
    break;

  case 103:
#line 826 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_override,
					     scm_cdr (yyvsp[-2]), scm_car (yyvsp[-2])),
				 yyvsp[0]);
	}
#line 3773 "./out/parser.cc"
    break;

  case 104:
#line 836 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_set,
					     scm_cadr (yyvsp[-2]), scm_car (yyvsp[-2])),
				 yyvsp[0]);
	}
#line 3787 "./out/parser.cc"
    break;

  case 105:
#line 847 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyvsp[-2] = SCM_INUM0;
		yyvsp[0] = MAKE_SYNTAX (partial_markup, (yylsp[0]), yyvsp[0]);
		parser->lexer_->pop_state ();
// This relies on partial_function always being followed by ETC
		yyval = scm_list_1 (scm_list_3 (MAKE_SYNTAX (partial_text_script, (yyloc), yyvsp[0]),
					     yyvsp[0], yyvsp[-2]));
	}
#line 3801 "./out/parser.cc"
    break;

  case 106:
#line 857 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyvsp[-1] = SCM_INUM0;
		yyval = scm_acons (Syntax::create_script_function, scm_list_1 (yyvsp[-1]), yyvsp[0]);
	}
#line 3811 "./out/parser.cc"
    break;

  case 107:
#line 863 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[0]))
			yyvsp[0] = SCM_INUM0;
		yyval = scm_acons (Syntax::create_script_function, scm_list_1 (yyvsp[0]), SCM_EOL);
	}
#line 3821 "./out/parser.cc"
    break;

  case 108:
#line 872 "parser.yy"
        {
		yyval = yyvsp[-1];
		Context_def *td = unsmob<Context_def> (yyval);
		if (!td) {
			yyval = Context_def::make_scm ();
			td = unsmob<Context_def> (yyval);
		}
		td->origin ()->set_spot ((yyloc));
	}
#line 3835 "./out/parser.cc"
    break;

  case 110:
#line 886 "parser.yy"
        {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 3843 "./out/parser.cc"
    break;

  case 111:
#line 890 "parser.yy"
        {
		parser->lexer_->pop_state ();
		yyval = yyvsp[0];
	}
#line 3852 "./out/parser.cc"
    break;

  case 112:
#line 898 "parser.yy"
             {
		yyval = SCM_UNSPECIFIED;
	}
#line 3860 "./out/parser.cc"
    break;

  case 113:
#line 901 "parser.yy"
                                            {
		if (!SCM_UNBNDP (yyvsp[0])) {
			Context_def *td = unsmob<Context_def> (yyval);
			if (!td) {
				yyval = Context_def::make_scm ();
				td = unsmob<Context_def> (yyval);
			}
			unsmob<Context_def> (yyval)->add_context_mod (yyvsp[0]);
		}
	}
#line 3875 "./out/parser.cc"
    break;

  case 114:
#line 911 "parser.yy"
                                                     {
                Context_def *td = unsmob<Context_def> (yyval);
		if (!td) {
			yyval = Context_def::make_scm ();
			td = unsmob<Context_def> (yyval);
		}
                SCM new_mods = unsmob<Context_mod> (yyvsp[0])->get_mods ();
                for (SCM m = new_mods; scm_is_pair (m); m = scm_cdr (m)) {
                    td->add_context_mod (scm_car (m));
                }
	}
#line 3891 "./out/parser.cc"
    break;

  case 115:
#line 922 "parser.yy"
                                                {
		Context_def *td = unsmob<Context_def> (yyvsp[-1]);
		if (scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			;
		else if (!td && unsmob<Context_def> (yyvsp[0]))
			yyval = yyvsp[0];
		else {
			if (!td) {
				yyval = Context_def::make_scm ();
				td = unsmob<Context_def> (yyval);
			}
			if (unsmob<Music> (yyvsp[0])) {
				SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
				yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
			}
			if (Context_mod *cm = unsmob<Context_mod> (yyvsp[0])) {
				for (SCM m = cm->get_mods (); scm_is_pair (m); m = scm_cdr (m)) {
					td->add_context_mod (scm_car (m));
				}
			} else
				parser->parser_error ((yylsp[0]), _ ("not a context mod"));
		}
	}
#line 3919 "./out/parser.cc"
    break;

  case 116:
#line 950 "parser.yy"
                                {
		yyval = yyvsp[-1];
		unsmob<Book> (yyval)->origin ()->set_spot ((yyloc));
		pop_paper (parser);
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), SCM_BOOL_F);
	}
#line 3930 "./out/parser.cc"
    break;

  case 117:
#line 962 "parser.yy"
        {
		Book *book = new Book;
		init_papers (parser);
		book->paper_ = unsmob<Output_def> (parser->lexer_->lookup_identifier ("$defaultpaper"))->clone ();
		book->paper_->unprotect ();
		push_paper (parser, book->paper_);
		book->header_ = get_header (parser);
                yyval = book->unprotect ();
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), yyval);
	}
#line 3945 "./out/parser.cc"
    break;

  case 118:
#line 972 "parser.yy"
                          {
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), yyvsp[0]);
	}
#line 3953 "./out/parser.cc"
    break;

  case 119:
#line 975 "parser.yy"
                                {
		unsmob<Book> (yyvsp[-1])->paper_ = unsmob<Output_def> (yyvsp[0]);
		set_paper (parser, unsmob<Output_def> (yyvsp[0]));
	}
#line 3962 "./out/parser.cc"
    break;

  case 120:
#line 979 "parser.yy"
                                   {
		SCM proc = parser->lexer_->lookup_identifier ("book-bookpart-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 3971 "./out/parser.cc"
    break;

  case 121:
#line 983 "parser.yy"
                                {
		SCM proc = parser->lexer_->lookup_identifier ("book-score-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 3980 "./out/parser.cc"
    break;

  case 122:
#line 987 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("book-music-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 3989 "./out/parser.cc"
    break;

  case 123:
#line 991 "parser.yy"
                                {
		SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
		scm_call_2 (proc, yyvsp[-1], scm_list_1 (yyvsp[0]));
	}
#line 3998 "./out/parser.cc"
    break;

  case 124:
#line 995 "parser.yy"
                                     {
		SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4007 "./out/parser.cc"
    break;

  case 125:
#line 999 "parser.yy"
                              {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 4016 "./out/parser.cc"
    break;

  case 126:
#line 1004 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
			scm_call_2 (proc, yyvsp[-1], out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("book-score-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (Output_def *od = unsmob<Output_def> (yyvsp[0])) {
			if (to_boolean (od->lookup_variable (ly_symbol2scm ("is-paper")))) {
				unsmob<Book> (yyvsp[-1])->paper_ = od;
				set_paper (parser, od);
			} else {
				parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			}
		} else if (ly_is_module (yyvsp[0]))
		{
			ly_module_copy (unsmob<Book> (yyvsp[-1])->header_, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 4048 "./out/parser.cc"
    break;

  case 127:
#line 1032 "parser.yy"
        {
		parser->lexer_->add_scope (unsmob<Book> (yyvsp[0])->header_);
	}
#line 4056 "./out/parser.cc"
    break;

  case 129:
#line 1035 "parser.yy"
                          {
                Book *book = unsmob<Book> (yyvsp[-1]);
		book->paper_ = 0;
		book->scores_ = SCM_EOL;
		book->bookparts_ = SCM_EOL;
	}
#line 4067 "./out/parser.cc"
    break;

  case 130:
#line 1044 "parser.yy"
                                       {
		yyval = yyvsp[-1];
		unsmob<Book> (yyval)->origin ()->set_spot ((yyloc));
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), SCM_BOOL_F);
	}
#line 4077 "./out/parser.cc"
    break;

  case 131:
#line 1052 "parser.yy"
        {
		Book *book = new Book;
                yyval = book->unprotect ();
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), yyval);
	}
#line 4087 "./out/parser.cc"
    break;

  case 132:
#line 1057 "parser.yy"
                          {
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), yyvsp[0]);
	}
#line 4095 "./out/parser.cc"
    break;

  case 133:
#line 1060 "parser.yy"
                                    {
		unsmob<Book> (yyval)->paper_ = unsmob<Output_def> (yyvsp[0]);
	}
#line 4103 "./out/parser.cc"
    break;

  case 134:
#line 1063 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-score-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4112 "./out/parser.cc"
    break;

  case 135:
#line 1067 "parser.yy"
                                        {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-music-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4121 "./out/parser.cc"
    break;

  case 136:
#line 1071 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
		scm_call_2 (proc, yyvsp[-1], scm_list_1 (yyvsp[0]));
	}
#line 4130 "./out/parser.cc"
    break;

  case 137:
#line 1075 "parser.yy"
                                         {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4139 "./out/parser.cc"
    break;

  case 138:
#line 1079 "parser.yy"
                                  {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 4148 "./out/parser.cc"
    break;

  case 139:
#line 1084 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
			scm_call_2 (proc, yyvsp[-1], out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("bookpart-score-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (Output_def *od = unsmob<Output_def> (yyvsp[0])) {
			if (to_boolean (od->lookup_variable (ly_symbol2scm ("is-paper")))) {
				unsmob<Book> (yyvsp[-1])->paper_ = od;
			} else {
				parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			}
		} else if (ly_is_module (yyvsp[0])) {
			Book *book = unsmob<Book> (yyvsp[-1]);
			if (!ly_is_module (book->header_))
				book->header_ = ly_make_module (false);
			ly_module_copy (book->header_, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 4181 "./out/parser.cc"
    break;

  case 140:
#line 1113 "parser.yy"
        {
                Book *book = unsmob<Book> (yyvsp[0]);
		if (!ly_is_module (book->header_))
			book->header_ = ly_make_module (false);
		parser->lexer_->add_scope (book->header_);
	}
#line 4192 "./out/parser.cc"
    break;

  case 142:
#line 1119 "parser.yy"
                              {
                Book *book = unsmob<Book> (yyvsp[-1]);
		book->paper_ = 0;
		book->scores_ = SCM_EOL;
	}
#line 4202 "./out/parser.cc"
    break;

  case 143:
#line 1127 "parser.yy"
                                        {
		unsmob<Score> (yyvsp[-1])->origin ()->set_spot ((yyloc));
		yyval = yyvsp[-1];
	}
#line 4211 "./out/parser.cc"
    break;

  case 144:
#line 1134 "parser.yy"
                    {
		if (!unsmob<Score> (yyvsp[0])) {
			parser->parser_error ((yylsp[0]), _("Missing music in \\score"));
			yyval = (new Score)->unprotect ();
			if (scm_is_pair (yyvsp[0]) && ly_is_module (scm_car (yyvsp[0])))
			{
				unsmob<Score> (yyval)->set_header (scm_car (yyvsp[0]));
				yyvsp[0] = scm_cdr (yyvsp[0]);
			}
			for (SCM p = scm_reverse_x (yyvsp[0], SCM_EOL);
			     scm_is_pair (p); p = scm_cdr (p))
			{
				unsmob<Score> (yyval)->
					add_output_def (unsmob<Output_def> (scm_car (p)));
			}
		}
	}
#line 4233 "./out/parser.cc"
    break;

  case 145:
#line 1151 "parser.yy"
                           {
		unsmob<Score> (yyval)->error_found_ = true;
	}
#line 4241 "./out/parser.cc"
    break;

  case 149:
#line 1164 "parser.yy"
        {
		yyval = SCM_EOL;
	}
#line 4249 "./out/parser.cc"
    break;

  case 150:
#line 1168 "parser.yy"
        {
		Output_def *od = unsmob<Output_def> (yyvsp[0]);
		if (od) {
			if (to_boolean (od->lookup_variable (ly_symbol2scm ("is-paper"))))
			{
				parser->parser_error ((yylsp[0]), _("\\paper cannot be used in \\score, use \\layout instead"));
				od = 0;
				yyvsp[0] = SCM_UNSPECIFIED;
			}
		} else if (!unsmob<Score> (yyval)) {
			if (unsmob<Music> (yyvsp[0])) {
				yyvsp[0] = Lily::scorify_music (yyvsp[0]);
			}
			if (unsmob<Score> (yyvsp[0]))
			{
				yyval = yyvsp[0];
				yyvsp[0] = SCM_UNSPECIFIED;
			}
		}
		Score *score = unsmob<Score> (yyval);
		if (score && scm_is_pair (yyvsp[-1])) {
			if (ly_is_module (scm_car (yyvsp[-1])))
			{
				score->set_header (scm_car (yyvsp[-1]));
				yyvsp[-1] = scm_cdr (yyvsp[-1]);
			}
			for (SCM p = scm_reverse_x (yyvsp[-1], SCM_EOL);
			     scm_is_pair (p); p = scm_cdr (p))
			{
				score->add_output_def (unsmob<Output_def> (scm_car (p)));
			}
		}
		if (od) {
			if (score)
				score->add_output_def (od);
			else if (scm_is_pair (yyval) && ly_is_module (scm_car (yyval)))
				scm_set_cdr_x (yyval, scm_cons (yyvsp[0], scm_cdr (yyval)));
			else
				yyval = scm_cons (yyvsp[0], yyval);
		} else if (ly_is_module (yyvsp[0])) {
			SCM module = SCM_UNSPECIFIED;
			if (score) {
				module = score->get_header ();
				if (!ly_is_module (module))
				{
					module = ly_make_module (false);
					score->set_header (module);
				}
			} else if (scm_is_pair (yyval) && ly_is_module (scm_car (yyval)))
				module = scm_car (yyval);
			else {
				module = ly_make_module (false);
				yyval = scm_cons (module, yyval);
			}
			ly_module_copy (module, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("Spurious expression in \\score"));
	}
#line 4312 "./out/parser.cc"
    break;

  case 151:
#line 1227 "parser.yy"
        {
		if (Score *score = unsmob<Score> (yyvsp[0])) {
			if (!ly_is_module (score->get_header ()))
				score->set_header (ly_make_module (false));
			parser->lexer_->add_scope (score->get_header ());
		} else {
			if (!scm_is_pair (yyvsp[0]) || !ly_is_module (scm_car (yyvsp[0])))
				yyvsp[0] = scm_cons (ly_make_module (false), yyvsp[0]);
			parser->lexer_->add_scope (scm_car (yyvsp[0]));
		}
	}
#line 4328 "./out/parser.cc"
    break;

  case 152:
#line 1238 "parser.yy"
        {
		yyval = yyvsp[-2];
	}
#line 4336 "./out/parser.cc"
    break;

  case 153:
#line 1249 "parser.yy"
                   {
                Output_def *od = unsmob<Output_def> (yyvsp[0]);

		if (!to_boolean (od->lookup_variable (ly_symbol2scm ("is-paper"))))
		{
			parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			yyval = get_paper (parser)->unprotect ();
		}
	}
#line 4350 "./out/parser.cc"
    break;

  case 154:
#line 1262 "parser.yy"
                            {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);

		parser->lexer_->remove_scope ();
		parser->lexer_->pop_state ();
	}
#line 4362 "./out/parser.cc"
    break;

  case 155:
#line 1272 "parser.yy"
              {
                Output_def *p = get_paper (parser);
		p->input_origin_ = (yyloc);
		parser->lexer_->add_scope (p->scope_);
                yyval = p->unprotect ();
	}
#line 4373 "./out/parser.cc"
    break;

  case 156:
#line 1278 "parser.yy"
                  {
		Output_def *p = get_midi (parser);
		yyval = p->unprotect ();
		parser->lexer_->add_scope (p->scope_);
	}
#line 4383 "./out/parser.cc"
    break;

  case 157:
#line 1283 "parser.yy"
                        {
		Output_def *p = get_layout (parser);

		parser->lexer_->add_scope (p->scope_);
		yyval = p->unprotect ();
	}
#line 4394 "./out/parser.cc"
    break;

  case 158:
#line 1292 "parser.yy"
                        {
		parser->lexer_->push_initial_state ();
		yyval = yyvsp[0];
	}
#line 4403 "./out/parser.cc"
    break;

  case 161:
#line 1309 "parser.yy"
                                             {
		unsmob<Output_def> (yyvsp[-1])->input_origin_.set_spot ((yyloc));
		// This is a stupid trick to mark the beginning of the
		// body for deciding whether to allow
		// embedded_scm_active to have an output definition
		yyval = scm_list_1 (yyvsp[-1]);
	}
#line 4415 "./out/parser.cc"
    break;

  case 162:
#line 1316 "parser.yy"
                                      {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);
	}
#line 4424 "./out/parser.cc"
    break;

  case 163:
#line 1321 "parser.yy"
        {
		// We don't switch into note mode for Scheme functions
		// here.  Does not seem warranted/required in output
		// definitions.
		if (scm_is_pair (yyvsp[-1]))
		{
			Output_def *o = unsmob<Output_def> (yyvsp[0]);
			if (o) {
				o->input_origin_.set_spot ((yyloc));
				yyvsp[-1] = o->self_scm ();
				parser->lexer_->remove_scope ();
				parser->lexer_->add_scope (o->scope_);
				yyvsp[0] = SCM_UNSPECIFIED;
			} else
				yyvsp[-1] = scm_car (yyvsp[-1]);
		}
		if (unsmob<Context_def> (yyvsp[0]))
			assign_context_def (unsmob<Output_def> (yyvsp[-1]), yyvsp[0]);
		// Seems unlikely, but let's be complete:
		else if (unsmob<Music> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier
				("output-def-music-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
		yyval = yyvsp[-1];
	}
#line 4457 "./out/parser.cc"
    break;

  case 164:
#line 1349 "parser.yy"
                                    {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 4468 "./out/parser.cc"
    break;

  case 165:
#line 1356 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0]))
			yyvsp[0] = scm_car (yyvsp[0]);
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 4478 "./out/parser.cc"
    break;

  case 166:
#line 1361 "parser.yy"
        {
		parser->lexer_->pop_state ();
		if (unsmob<Context_def> (yyvsp[0]))
			assign_context_def (unsmob<Output_def> (yyvsp[-2]), yyvsp[0]);
		else {

			SCM proc = parser->lexer_->lookup_identifier
				     ("output-def-music-handler");
			scm_call_2 (proc, yyvsp[-2], yyvsp[0]);
		}
		yyval = yyvsp[-2];
	}
#line 4495 "./out/parser.cc"
    break;

  case 167:
#line 1373 "parser.yy"
                                {

	}
#line 4503 "./out/parser.cc"
    break;

  case 168:
#line 1379 "parser.yy"
                                                {
		yyval = MAKE_SYNTAX (tempo, (yyloc), SCM_EOL, yyvsp[-2], yyvsp[0]);
	}
#line 4511 "./out/parser.cc"
    break;

  case 169:
#line 1382 "parser.yy"
                                                        {
		yyval = MAKE_SYNTAX (tempo, (yyloc), yyvsp[-3], yyvsp[-2], yyvsp[0]);
	}
#line 4519 "./out/parser.cc"
    break;

  case 170:
#line 1385 "parser.yy"
                     {
		yyval = MAKE_SYNTAX (tempo, (yyloc), yyvsp[0]);
	}
#line 4527 "./out/parser.cc"
    break;

  case 171:
#line 1394 "parser.yy"
                    {
		yyval = SCM_EOL;
	}
#line 4535 "./out/parser.cc"
    break;

  case 172:
#line 1397 "parser.yy"
                                    {
		if (unsmob<Music> (yyvsp[0]))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 4544 "./out/parser.cc"
    break;

  case 173:
#line 1401 "parser.yy"
                           {
		Music *m = MY_MAKE_MUSIC("Music", (yyloc));
		// ugh. code dup
		m->set_property ("error-found", SCM_BOOL_T);
		yyval = scm_cons (m->self_scm (), yyvsp[-1]);
		m->unprotect (); /* UGH */
	}
#line 4556 "./out/parser.cc"
    break;

  case 174:
#line 1412 "parser.yy"
        {
		yyval = reverse_music_list (parser, (yyloc), yyvsp[-1], true, false);
	}
#line 4564 "./out/parser.cc"
    break;

  case 178:
#line 1424 "parser.yy"
        {
	        yyval = make_music_from_simple (parser, (yylsp[0]), yyvsp[0]);
                if (!unsmob<Music> (yyval))
		{
                        parser->parser_error ((yylsp[0]), _ ("music expected"));
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		}
	}
#line 4577 "./out/parser.cc"
    break;

  case 181:
#line 1438 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 4585 "./out/parser.cc"
    break;

  case 182:
#line 1442 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 4593 "./out/parser.cc"
    break;

  case 183:
#line 1446 "parser.yy"
        {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

		parser->default_duration_ = *unsmob<Duration> (yyvsp[-1]);
		n->set_property ("duration", yyvsp[-1]);

		if (scm_is_pair (yyvsp[0]))
			n->set_property ("articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
		yyval = n->unprotect ();
	}
#line 4609 "./out/parser.cc"
    break;

  case 184:
#line 1461 "parser.yy"
        {
		if (scm_is_eq (yyvsp[0], SCM_UNSPECIFIED)
		    || unsmob<Music> (yyvsp[0]))
			yyval = yyvsp[0];
		else if (parser->lexer_->is_lyric_state ()
			   && Text_interface::is_markup (yyvsp[0]))
			MYBACKUP (LYRIC_ELEMENT, yyvsp[0], (yylsp[0]));
		else {
			(yyloc).warning (_ ("Ignoring non-music expression"));
			yyval = SCM_UNSPECIFIED;
		}
	}
#line 4626 "./out/parser.cc"
    break;

  case 187:
#line 1484 "parser.yy"
        {
		yyval = MAKE_SYNTAX (repeat, (yyloc), yyvsp[-2], yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 4634 "./out/parser.cc"
    break;

  case 188:
#line 1488 "parser.yy"
        {
		yyval = MAKE_SYNTAX (repeat, (yyloc), yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[0]);
	}
#line 4642 "./out/parser.cc"
    break;

  case 189:
#line 1494 "parser.yy"
                                     {
		yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyvsp[0]);
	}
#line 4650 "./out/parser.cc"
    break;

  case 190:
#line 1497 "parser.yy"
                            {
		yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyvsp[0]);
	}
#line 4658 "./out/parser.cc"
    break;

  case 191:
#line 1503 "parser.yy"
                                       {
		yyval = MAKE_SYNTAX (simultaneous_music, (yyloc), yyvsp[0]);
	}
#line 4666 "./out/parser.cc"
    break;

  case 192:
#line 1506 "parser.yy"
                                                                {
		yyval = MAKE_SYNTAX (simultaneous_music, (yyloc),
				  reverse_music_list (parser, (yyloc), yyvsp[-1],
						      true, false));
	}
#line 4676 "./out/parser.cc"
    break;

  case 196:
#line 1521 "parser.yy"
        {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 4684 "./out/parser.cc"
    break;

  case 197:
#line 1524 "parser.yy"
        {
                parser->lexer_->pop_state ();
                yyval = yyvsp[-1];
        }
#line 4693 "./out/parser.cc"
    break;

  case 198:
#line 1529 "parser.yy"
        {
		if (unsmob<Music> (yyvsp[0])) {
			SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
			yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
		}
		if (unsmob<Context_mod> (yyvsp[0]))
			yyval = yyvsp[0];
		else {
			// let's permit \with #*unspecified* to go for
			// an empty context mod
			if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
				parser->parser_error ((yylsp[0]), _ ("not a context mod"));
			yyval = Context_mod ().smobbed_copy ();
		}
	}
#line 4713 "./out/parser.cc"
    break;

  case 201:
#line 1557 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0]))
			yyval = scm_append_x (scm_reverse_x (yyvsp[0], SCM_EOL));
        }
#line 4722 "./out/parser.cc"
    break;

  case 202:
#line 1570 "parser.yy"
             {
		yyval = SCM_EOL;
	}
#line 4730 "./out/parser.cc"
    break;

  case 203:
#line 1574 "parser.yy"
        {
		if (Context_mod *m = unsmob<Context_mod> (yyvsp[0]))
			yyval = scm_cons (m->get_mods (), yyvsp[-1]);
	}
#line 4739 "./out/parser.cc"
    break;

  case 204:
#line 1586 "parser.yy"
             {
            yyval = Context_mod ().smobbed_copy ();
        }
#line 4747 "./out/parser.cc"
    break;

  case 205:
#line 1589 "parser.yy"
                                        {
		if (!SCM_UNBNDP (yyvsp[0]))
			unsmob<Context_mod> (yyvsp[-1])->add_context_mod (yyvsp[0]);
        }
#line 4756 "./out/parser.cc"
    break;

  case 206:
#line 1593 "parser.yy"
                                           {
		if (unsmob<Music> (yyvsp[0])) {
			SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
			yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
		}
		if (unsmob<Context_mod> (yyvsp[0]))
			unsmob<Context_mod> (yyval)->add_context_mods
				(unsmob<Context_mod> (yyvsp[0])->get_mods ());
		else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _ ("not a context mod"));
        }
#line 4772 "./out/parser.cc"
    break;

  case 207:
#line 1607 "parser.yy"
                                                         {
		yyval = START_MAKE_SYNTAX (context_find_or_create, yyvsp[-2], yyvsp[-1], yyvsp[0]);
	}
#line 4780 "./out/parser.cc"
    break;

  case 208:
#line 1610 "parser.yy"
                                                              {
		yyval = START_MAKE_SYNTAX (context_create, yyvsp[-2], yyvsp[-1], yyvsp[0]);
	}
#line 4788 "./out/parser.cc"
    break;

  case 209:
#line 1616 "parser.yy"
                                                         {
		yyval = scm_acons (yyvsp[0], yyvsp[-1], SCM_EOL);
	}
#line 4796 "./out/parser.cc"
    break;

  case 210:
#line 1619 "parser.yy"
                                                                      {
		yyval = scm_acons (yyvsp[0], yyvsp[-1], yyvsp[-3]);
	}
#line 4804 "./out/parser.cc"
    break;

  case 214:
#line 1644 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (lyric_combine, (yyloc), yyvsp[-1], SCM_EOL, yyvsp[0]);
	}
#line 4812 "./out/parser.cc"
    break;

  case 215:
#line 1648 "parser.yy"
        {
		yyval = MAKE_SYNTAX (lyric_combine, (yyloc), yyvsp[-1], yyvsp[-3], yyvsp[0]);
	}
#line 4820 "./out/parser.cc"
    break;

  case 219:
#line 1661 "parser.yy"
        {
		Input i;
		i.set_location ((yylsp[-2]), (yylsp[-1]));
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-2], i, yyvsp[-1]);
		yyval = MAKE_SYNTAX (add_lyrics, (yyloc), yyval, scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 4831 "./out/parser.cc"
    break;

  case 220:
#line 1668 "parser.yy"
        {
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-1], (yyloc), yyvsp[0]);
	}
#line 4839 "./out/parser.cc"
    break;

  case 221:
#line 1672 "parser.yy"
        {
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-1], (yyloc), yyvsp[0]);
	}
#line 4847 "./out/parser.cc"
    break;

  case 224:
#line 1681 "parser.yy"
        {
		yyval = MAKE_SYNTAX (add_lyrics, (yyloc), yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 4855 "./out/parser.cc"
    break;

  case 228:
#line 1693 "parser.yy"
                                        { yyval = yyvsp[0]; }
#line 4861 "./out/parser.cc"
    break;

  case 229:
#line 1694 "parser.yy"
                                        { yyval = yyvsp[0]; }
#line 4867 "./out/parser.cc"
    break;

  case 231:
#line 1753 "parser.yy"
        {
		yyval = scm_append (scm_list_2 (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 4875 "./out/parser.cc"
    break;

  case 232:
#line 1757 "parser.yy"
        {
		yyval = scm_append (scm_list_2 (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 4883 "./out/parser.cc"
    break;

  case 234:
#line 1765 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 4891 "./out/parser.cc"
    break;

  case 235:
#line 1769 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 4899 "./out/parser.cc"
    break;

  case 237:
#line 1779 "parser.yy"
        {
		yyval = make_reverse_key_list (yyvsp[0]);
		if (SCM_UNBNDP (yyval)) {
			parser->parser_error ((yylsp[0]), _("not a key"));
			yyval = SCM_EOL;
		}
	}
#line 4911 "./out/parser.cc"
    break;

  case 238:
#line 1791 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 4919 "./out/parser.cc"
    break;

  case 240:
#line 1800 "parser.yy"
        {
		yyval = try_word_variants (Lily::key_list_p, yyvsp[0]);
		if (SCM_UNBNDP (yyval)) {
			parser->parser_error ((yylsp[0]), _("not a key"));
			yyval = SCM_EOL;
		} else
			yyval = scm_reverse (yyval);
	}
#line 4932 "./out/parser.cc"
    break;

  case 241:
#line 1809 "parser.yy"
        {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 4940 "./out/parser.cc"
    break;

  case 243:
#line 1817 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 4948 "./out/parser.cc"
    break;

  case 244:
#line 1821 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n)))
			yyval = scm_cons (n, yyvsp[-2]);
		else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			t->set_property ("digit", yyvsp[0]);
			yyval = check_scheme_arg (parser, (yylsp[-1]), t->unprotect (),
					       yyvsp[-2], yyvsp[-3], n);
		}
	}
#line 4964 "./out/parser.cc"
    break;

  case 245:
#line 1833 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[-1]),
				       scm_difference (yyvsp[0], SCM_UNDEFINED),
				       yyvsp[-2], yyvsp[-3]);
	}
#line 4974 "./out/parser.cc"
    break;

  case 246:
#line 1839 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[-1]),
				       scm_difference (yyvsp[0], SCM_UNDEFINED),
				       yyvsp[-2], yyvsp[-3]);
	}
#line 4984 "./out/parser.cc"
    break;

  case 247:
#line 1845 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-1], yyvsp[-2]);
	}
#line 4998 "./out/parser.cc"
    break;

  case 248:
#line 1855 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5006 "./out/parser.cc"
    break;

  case 249:
#line 1859 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1]);
	}
#line 5020 "./out/parser.cc"
    break;

  case 250:
#line 1869 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5028 "./out/parser.cc"
    break;

  case 251:
#line 1873 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5036 "./out/parser.cc"
    break;

  case 252:
#line 1877 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5044 "./out/parser.cc"
    break;

  case 253:
#line 1881 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5052 "./out/parser.cc"
    break;

  case 254:
#line 1885 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5060 "./out/parser.cc"
    break;

  case 255:
#line 1889 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5068 "./out/parser.cc"
    break;

  case 256:
#line 1897 "parser.yy"
        {
		yyval = make_music_from_simple (parser, (yyloc),
					     make_duration (yyvsp[-3], scm_to_int (yyvsp[-2]), yyvsp[-1]));
		Music *m = unsmob<Music> (yyval);
		assert (m);
		if (scm_is_pair (yyvsp[0]))
			m->set_property ("articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 5082 "./out/parser.cc"
    break;

  case 257:
#line 1910 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5103 "./out/parser.cc"
    break;

  case 258:
#line 1927 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5118 "./out/parser.cc"
    break;

  case 259:
#line 1938 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5133 "./out/parser.cc"
    break;

  case 260:
#line 1949 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5154 "./out/parser.cc"
    break;

  case 261:
#line 1966 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5175 "./out/parser.cc"
    break;

  case 262:
#line 1983 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5192 "./out/parser.cc"
    break;

  case 263:
#line 1996 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else
					MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
			} else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
		}
	}
#line 5219 "./out/parser.cc"
    break;

  case 264:
#line 2019 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
	}
#line 5235 "./out/parser.cc"
    break;

  case 266:
#line 2038 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = make_music_from_simple (parser, (yylsp[0]), yyvsp[0]);
			if (scm_is_true (scm_call_1 (yyvsp[-2], yyval)))
				yyval = scm_cons (yyval, yyvsp[-1]);
			else
			{
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
				MYBACKUP (SCM_ARG, yyvsp[0], (yylsp[0]));
			}
		}
	}
#line 5254 "./out/parser.cc"
    break;

  case 267:
#line 2053 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (EVENT_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5268 "./out/parser.cc"
    break;

  case 268:
#line 2063 "parser.yy"
        {
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		} else if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (PITCH_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5288 "./out/parser.cc"
    break;

  case 269:
#line 2079 "parser.yy"
        {
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		} else if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (TONICNAME_PITCH, yyvsp[0], (yylsp[0]));
		}
	}
#line 5308 "./out/parser.cc"
    break;

  case 270:
#line 2095 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (SCM_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5321 "./out/parser.cc"
    break;

  case 271:
#line 2104 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else {
					yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
					MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
				}
			} else {
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
				MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
			}
		}
	}
#line 5352 "./out/parser.cc"
    break;

  case 272:
#line 2131 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (REAL, yyvsp[0], (yylsp[0]));
		}
	}
#line 5367 "./out/parser.cc"
    break;

  case 273:
#line 2142 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (NUMBER_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5381 "./out/parser.cc"
    break;

  case 274:
#line 2152 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			yyval = yyvsp[-2];
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
		} else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			t->set_property ("digit", yyvsp[0]);
			yyval = t->unprotect ();
			if (scm_is_true (scm_call_1 (yyvsp[-3], yyval)))
				yyval = scm_cons (yyval, yyvsp[-2]);
			else {
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
				MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
				parser->lexer_->push_extra_token ((yylsp[-1]), '-');
			}
		}
	}
#line 5404 "./out/parser.cc"
    break;

  case 275:
#line 2171 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
			yyval = yyvsp[-2];
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
			MYBACKUP (REAL, n, (yylsp[0]));
		}
	}
#line 5419 "./out/parser.cc"
    break;

  case 276:
#line 2182 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			yyval = scm_cons (n, yyvsp[-2]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
			MYBACKUP (NUMBER_IDENTIFIER, n, (yylsp[0]));
		}
	}
#line 5433 "./out/parser.cc"
    break;

  case 277:
#line 2192 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (DURATION_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5451 "./out/parser.cc"
    break;

  case 278:
#line 2206 "parser.yy"
        {
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (SCM_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5470 "./out/parser.cc"
    break;

  case 279:
#line 2221 "parser.yy"
        {
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (STRING, yyvsp[0], (yylsp[0]));
		}
	}
#line 5489 "./out/parser.cc"
    break;

  case 280:
#line 2236 "parser.yy"
        {
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (STRING, yyvsp[0], (yylsp[0]));
		}
	}
#line 5508 "./out/parser.cc"
    break;

  case 281:
#line 2251 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1]);
	}
#line 5522 "./out/parser.cc"
    break;

  case 282:
#line 2261 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5531 "./out/parser.cc"
    break;

  case 283:
#line 2266 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5540 "./out/parser.cc"
    break;

  case 284:
#line 2271 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5549 "./out/parser.cc"
    break;

  case 285:
#line 2276 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5557 "./out/parser.cc"
    break;

  case 287:
#line 2284 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-3]), yyvsp[-1]);
	}
#line 5565 "./out/parser.cc"
    break;

  case 289:
#line 2292 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-2]), yyvsp[0]);
	}
#line 5573 "./out/parser.cc"
    break;

  case 290:
#line 2311 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5581 "./out/parser.cc"
    break;

  case 291:
#line 2315 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5589 "./out/parser.cc"
    break;

  case 292:
#line 2319 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5597 "./out/parser.cc"
    break;

  case 293:
#line 2323 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5605 "./out/parser.cc"
    break;

  case 294:
#line 2330 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5613 "./out/parser.cc"
    break;

  case 295:
#line 2334 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5621 "./out/parser.cc"
    break;

  case 296:
#line 2338 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5629 "./out/parser.cc"
    break;

  case 297:
#line 2342 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5637 "./out/parser.cc"
    break;

  case 298:
#line 2348 "parser.yy"
                            {
		yyval = SCM_EOL;
	}
#line 5645 "./out/parser.cc"
    break;

  case 299:
#line 2352 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-1], yyvsp[-2]);
	}
#line 5659 "./out/parser.cc"
    break;

  case 300:
#line 2362 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5668 "./out/parser.cc"
    break;

  case 301:
#line 2367 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5677 "./out/parser.cc"
    break;

  case 302:
#line 2372 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		yyval = check_scheme_arg (parser, (yylsp[0]), n, yyvsp[-2], yyvsp[-3]);
	}
#line 5686 "./out/parser.cc"
    break;

  case 303:
#line 2377 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5695 "./out/parser.cc"
    break;

  case 304:
#line 2382 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5704 "./out/parser.cc"
    break;

  case 305:
#line 2387 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1]);
	}
#line 5718 "./out/parser.cc"
    break;

  case 306:
#line 2397 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5727 "./out/parser.cc"
    break;

  case 307:
#line 2402 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5736 "./out/parser.cc"
    break;

  case 308:
#line 2407 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5745 "./out/parser.cc"
    break;

  case 309:
#line 2412 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5753 "./out/parser.cc"
    break;

  case 310:
#line 2419 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5775 "./out/parser.cc"
    break;

  case 311:
#line 2437 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5790 "./out/parser.cc"
    break;

  case 312:
#line 2448 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5805 "./out/parser.cc"
    break;

  case 313:
#line 2459 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5827 "./out/parser.cc"
    break;

  case 314:
#line 2477 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5849 "./out/parser.cc"
    break;

  case 315:
#line 2495 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5867 "./out/parser.cc"
    break;

  case 316:
#line 2509 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else
					MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
			} else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
		}
	}
#line 5894 "./out/parser.cc"
    break;

  case 317:
#line 2532 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
	}
#line 5910 "./out/parser.cc"
    break;

  case 318:
#line 2544 "parser.yy"
        {
		yyval = yyvsp[-2];
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n)))
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
		else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			t->set_property ("digit", yyvsp[0]);
			SCM m = t->unprotect ();
			if (scm_is_true (scm_call_1 (yyvsp[-3], m)))
				MYREPARSE ((yylsp[0]), yyvsp[-3], SCM_ARG, m);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-3], SCM_ARG, yyvsp[0]);
		}
	}
#line 5930 "./out/parser.cc"
    break;

  case 319:
#line 2560 "parser.yy"
        {
		yyval = yyvsp[-2];
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
	}
#line 5940 "./out/parser.cc"
    break;

  case 321:
#line 2570 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-3]), yyvsp[-1]);
	}
#line 5948 "./out/parser.cc"
    break;

  case 324:
#line 2579 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-2]), yyvsp[0]);
	}
#line 5956 "./out/parser.cc"
    break;

  case 325:
#line 2585 "parser.yy"
                                        {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 5965 "./out/parser.cc"
    break;

  case 326:
#line 2593 "parser.yy"
             { yyval = SCM_EOL; }
#line 5971 "./out/parser.cc"
    break;

  case 327:
#line 2594 "parser.yy"
                            {
		yyval = yyvsp[0];
	}
#line 5979 "./out/parser.cc"
    break;

  case 328:
#line 2606 "parser.yy"
        {
		parser->lexer_->push_lyric_state ();
	}
#line 5987 "./out/parser.cc"
    break;

  case 329:
#line 2609 "parser.yy"
        {
		parser->lexer_->pop_state ();
		yyval = yyvsp[0];
	}
#line 5996 "./out/parser.cc"
    break;

  case 331:
#line 2617 "parser.yy"
                                              {
		if (scm_is_eq (yyvsp[-1], ly_symbol2scm ("chords")))
		{
		  yyval = MAKE_SYNTAX (unrelativable_music, (yyloc), yyvsp[0]);
		}
		else
		{
		  yyval = yyvsp[0];
		}
		parser->lexer_->pop_state ();
	}
#line 6012 "./out/parser.cc"
    break;

  case 332:
#line 2628 "parser.yy"
                                                                                   {
		yyval = MAKE_SYNTAX (context_create, (yyloc), yyvsp[-2], SCM_EOL, yyvsp[-1], yyvsp[0]);
		if (scm_is_eq (yyvsp[-2], ly_symbol2scm ("ChordNames")))
		{
		  yyval = MAKE_SYNTAX (unrelativable_music, (yyloc), yyval);
		}
		parser->lexer_->pop_state ();
	}
#line 6025 "./out/parser.cc"
    break;

  case 333:
#line 2639 "parser.yy"
                 {
		parser->lexer_->push_note_state (Lily::pitchnames);

		yyval = ly_symbol2scm ("notes");
	}
#line 6035 "./out/parser.cc"
    break;

  case 334:
#line 2645 "parser.yy"
                {
		parser->lexer_->push_note_state (Lily::drum_pitch_names);

		yyval = ly_symbol2scm ("drums");
	}
#line 6045 "./out/parser.cc"
    break;

  case 335:
#line 2650 "parser.yy"
                     {
		parser->lexer_->push_figuredbass_state ();

		yyval = ly_symbol2scm ("figures");
	}
#line 6055 "./out/parser.cc"
    break;

  case 336:
#line 2655 "parser.yy"
                    {
		parser->lexer_->chordmodifier_tab_ =
			alist_to_hashq (Lily::chordmodifiers);
		parser->lexer_->push_chord_state (Lily::pitchnames);
		yyval = ly_symbol2scm ("chords");

	}
#line 6067 "./out/parser.cc"
    break;

  case 337:
#line 2663 "parser.yy"
                { parser->lexer_->push_lyric_state ();
		yyval = ly_symbol2scm ("lyrics");
	}
#line 6075 "./out/parser.cc"
    break;

  case 338:
#line 2669 "parser.yy"
              {
		parser->lexer_->push_note_state (Lily::drum_pitch_names);

		yyval = ly_symbol2scm ("DrumStaff");
	}
#line 6085 "./out/parser.cc"
    break;

  case 339:
#line 2674 "parser.yy"
                  {
		parser->lexer_->push_figuredbass_state ();

		yyval = ly_symbol2scm ("FiguredBass");
	}
#line 6095 "./out/parser.cc"
    break;

  case 340:
#line 2679 "parser.yy"
                 {
		parser->lexer_->chordmodifier_tab_ =
			alist_to_hashq (Lily::chordmodifiers);
		parser->lexer_->push_chord_state (Lily::pitchnames);
		yyval = ly_symbol2scm ("ChordNames");
	}
#line 6106 "./out/parser.cc"
    break;

  case 341:
#line 2686 "parser.yy"
                { parser->lexer_->push_lyric_state ();
		yyval = ly_symbol2scm ("Lyrics");
	}
#line 6114 "./out/parser.cc"
    break;

  case 342:
#line 2692 "parser.yy"
                                         {
		yyval = MAKE_SYNTAX (context_change, (yyloc), yyvsp[-2], yyvsp[0]);
	}
#line 6122 "./out/parser.cc"
    break;

  case 343:
#line 2699 "parser.yy"
                         {
		yyval = scm_reverse_x (yyvsp[0], SCM_EOL);
	}
#line 6130 "./out/parser.cc"
    break;

  case 344:
#line 2705 "parser.yy"
                          {
		yyval = scm_list_3 (ly_symbol2scm ("assign"), yyvsp[-2], yyvsp[0]);
	}
#line 6138 "./out/parser.cc"
    break;

  case 345:
#line 2708 "parser.yy"
                       {
		yyval = scm_list_2 (ly_symbol2scm ("unset"), yyvsp[0]);
	}
#line 6146 "./out/parser.cc"
    break;

  case 346:
#line 2711 "parser.yy"
                                         {
		if (scm_ilength (yyvsp[-2]) < 2) {
			parser->parser_error ((yylsp[-2]), _("bad grob property path"));
			yyval = SCM_UNDEFINED;
		} else {
			yyval = scm_cons (ly_symbol2scm ("push"),
				       scm_cons2 (scm_car (yyvsp[-2]),
						  yyvsp[0],
						  scm_cdr (yyvsp[-2])));
		}
	}
#line 6162 "./out/parser.cc"
    break;

  case 347:
#line 2722 "parser.yy"
                            {
		yyval = scm_cons (ly_symbol2scm ("pop"), yyvsp[0]);
	}
#line 6170 "./out/parser.cc"
    break;

  case 348:
#line 2752 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 6178 "./out/parser.cc"
    break;

  case 349:
#line 2759 "parser.yy"
        {
		if (scm_is_null (yyvsp[0])
		    || scm_is_null (scm_cdr (yyvsp[0])))
			MYBACKUP (SCM_ARG, yyvsp[0], (yylsp[0]));
		else
			MYBACKUP (SYMBOL_LIST, scm_reverse_x (yyvsp[0], SCM_EOL), (yylsp[0]));
	}
#line 6190 "./out/parser.cc"
    break;

  case 351:
#line 2772 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 6198 "./out/parser.cc"
    break;

  case 352:
#line 2776 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 6206 "./out/parser.cc"
    break;

  case 353:
#line 2780 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-1]));
	}
#line 6214 "./out/parser.cc"
    break;

  case 354:
#line 2786 "parser.yy"
                 { yyval = ly_symbol2scm ("consists"); }
#line 6220 "./out/parser.cc"
    break;

  case 355:
#line 2787 "parser.yy"
                 { yyval = ly_symbol2scm ("remove"); }
#line 6226 "./out/parser.cc"
    break;

  case 356:
#line 2789 "parser.yy"
                  { yyval = ly_symbol2scm ("accepts"); }
#line 6232 "./out/parser.cc"
    break;

  case 357:
#line 2790 "parser.yy"
                       { yyval = ly_symbol2scm ("default-child"); }
#line 6238 "./out/parser.cc"
    break;

  case 358:
#line 2791 "parser.yy"
                 { yyval = ly_symbol2scm ("denies"); }
#line 6244 "./out/parser.cc"
    break;

  case 359:
#line 2793 "parser.yy"
                { yyval = ly_symbol2scm ("alias"); }
#line 6250 "./out/parser.cc"
    break;

  case 360:
#line 2794 "parser.yy"
               { yyval = ly_symbol2scm ("translator-type"); }
#line 6256 "./out/parser.cc"
    break;

  case 361:
#line 2795 "parser.yy"
                      { yyval = ly_symbol2scm ("description"); }
#line 6262 "./out/parser.cc"
    break;

  case 362:
#line 2796 "parser.yy"
               { yyval = ly_symbol2scm ("context-name"); }
#line 6268 "./out/parser.cc"
    break;

  case 363:
#line 2800 "parser.yy"
                           { yyval = yyvsp[0]; }
#line 6274 "./out/parser.cc"
    break;

  case 364:
#line 2801 "parser.yy"
                                 {
		yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
	}
#line 6282 "./out/parser.cc"
    break;

  case 365:
#line 2804 "parser.yy"
                                 {
		yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
	}
#line 6290 "./out/parser.cc"
    break;

  case 366:
#line 2808 "parser.yy"
        {
		if (!scm_is_string (yyvsp[0])
		    && !scm_is_eq (yyvsp[-1], ly_symbol2scm ("consists"))
		    && !scm_is_eq (yyvsp[-1], ly_symbol2scm ("remove")))
		{
			yyval = SCM_EOL;
			parser->parser_error ((yylsp[-1]), _ ("only \\consists and \\remove take non-string argument."));
		}
		else
		{
			yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
		}
	}
#line 6308 "./out/parser.cc"
    break;

  case 367:
#line 2826 "parser.yy"
        {
		SCM l = scm_reverse_x (yyvsp[0], SCM_EOL);
		if (scm_is_pair (l)
		    && to_boolean
		    (scm_object_property (scm_car (l),
					  ly_symbol2scm ("is-grob?"))))
			l = scm_cons (ly_symbol2scm ("Bottom"), l);
		if (scm_is_null (l) || scm_is_null (scm_cdr (l))) {
			parser->parser_error ((yylsp[0]), _ ("bad grob property path"));
			l = SCM_UNDEFINED;
		}
		yyval = l;
	}
#line 6326 "./out/parser.cc"
    break;

  case 368:
#line 2844 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[0]) && scm_is_null (scm_cddr (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _ ("bad grob property path"));
			yyval = SCM_UNDEFINED;
		}
	}
#line 6338 "./out/parser.cc"
    break;

  case 369:
#line 2852 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-1])) {
			yyval = scm_append_x (scm_list_2 (yyvsp[-1], yyvsp[0]));
			if (scm_is_null (scm_cddr (yyval))) {
				parser->parser_error ((yyloc), _ ("bad grob property path"));
				yyval = SCM_UNDEFINED;
			}
		}

	}
#line 6353 "./out/parser.cc"
    break;

  case 370:
#line 2867 "parser.yy"
        {
		SCM l = scm_reverse_x (yyvsp[0], SCM_EOL);
		switch (scm_ilength (l)) {
		case 1:
			l = scm_cons (ly_symbol2scm ("Bottom"), l);
		case 2:
			break;
		default:
			parser->parser_error ((yylsp[0]), _ ("bad context property path"));
			l = SCM_UNDEFINED;
		}
		yyval = l;
	}
#line 6371 "./out/parser.cc"
    break;

  case 371:
#line 2899 "parser.yy"
        {
		yyvsp[0] = scm_reverse_x (yyvsp[0], SCM_EOL);
		if (scm_is_null (yyvsp[0])
		    || to_boolean
		    (scm_object_property (scm_car (yyvsp[0]),
					  ly_symbol2scm ("is-grob?")))) {
			yyval = ly_symbol2scm ("Bottom");
			parser->lexer_->push_extra_token ((yylsp[0]), SCM_IDENTIFIER, yyvsp[0]);
		} else {
			yyval = scm_car (yyvsp[0]);
			parser->lexer_->push_extra_token ((yylsp[0]), SCM_IDENTIFIER,
							  scm_cdr (yyvsp[0]));
		}
	}
#line 6390 "./out/parser.cc"
    break;

  case 372:
#line 2916 "parser.yy"
                                           {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_override, (yyloc),
					  scm_car (yyvsp[-2]),
					  scm_cdr (yyvsp[-2]),
					  yyvsp[0]);
	}
#line 6404 "./out/parser.cc"
    break;

  case 373:
#line 2925 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (property_revert, (yyloc), yyvsp[-1], yyvsp[0]);
	}
#line 6412 "./out/parser.cc"
    break;

  case 374:
#line 2928 "parser.yy"
                                           {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_set, (yyloc),
					  scm_car (yyvsp[-2]),
					  scm_cadr (yyvsp[-2]),
					  yyvsp[0]);
	}
#line 6426 "./out/parser.cc"
    break;

  case 375:
#line 2937 "parser.yy"
                                  {
		if (SCM_UNBNDP (yyvsp[0]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_unset, (yyloc),
					  scm_car (yyvsp[0]),
					  scm_cadr (yyvsp[0]));
	}
#line 6439 "./out/parser.cc"
    break;

  case 382:
#line 2958 "parser.yy"
        {
		if (Text_interface::is_markup (yyvsp[0])) {
			yyval = yyvsp[0];
		} else {
			parser->parser_error ((yylsp[0]), (_ ("markup expected")));
			yyval = scm_string (SCM_EOL);
		}
	}
#line 6452 "./out/parser.cc"
    break;

  case 385:
#line 2971 "parser.yy"
        {
		if (scm_is_string (yyvsp[0])) {
			yyval = yyvsp[0];
		} else {
			parser->parser_error ((yylsp[0]), (_ ("simple string expected")));
			yyval = scm_string (SCM_EOL);
		}
	}
#line 6465 "./out/parser.cc"
    break;

  case 386:
#line 2982 "parser.yy"
               {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 6473 "./out/parser.cc"
    break;

  case 387:
#line 2986 "parser.yy"
        {
		if (!is_regular_identifier (yyvsp[0], false))
			parser->parser_error ((yylsp[0]), (_ ("symbol expected")));
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 6483 "./out/parser.cc"
    break;

  case 388:
#line 2992 "parser.yy"
        {
		// This is a bit of overkill but makes the same
		// routine responsible for all symbol interpretations.
		yyval = try_string_variants (Guile_user::symbol_p, yyvsp[0]);
		if (SCM_UNBNDP (yyval))
		{
			parser->parser_error ((yylsp[0]), (_ ("symbol expected")));
			// Generate a unique symbol in case it is used
			// for an assignment or similar
			yyval = scm_make_symbol (ly_string2scm ("undefined"));
		}
	}
#line 6500 "./out/parser.cc"
    break;

  case 393:
#line 3019 "parser.yy"
        {
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 6508 "./out/parser.cc"
    break;

  case 395:
#line 3024 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 6516 "./out/parser.cc"
    break;

  case 396:
#line 3028 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 6524 "./out/parser.cc"
    break;

  case 397:
#line 3034 "parser.yy"
                                   {
		// Let the rhythmic music iterator sort this mess out.
		if (scm_is_pair (yyvsp[0])) {
			unsmob<Music> (yyval)->set_property ("articulations",
							 scm_reverse_x (yyvsp[0], SCM_EOL));
		}
	}
#line 6536 "./out/parser.cc"
    break;

  case 398:
#line 3041 "parser.yy"
                                                                  {
		yyval = MAKE_SYNTAX (repetition_chord, (yyloc),
				  yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 6545 "./out/parser.cc"
    break;

  case 399:
#line 3045 "parser.yy"
                                                                    {
		yyval = MAKE_SYNTAX (multi_measure_rest, (yyloc), yyvsp[-1],
				  scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 6554 "./out/parser.cc"
    break;

  case 402:
#line 3056 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[-2]);
		SCM dur = unsmob<Duration> (yyvsp[-1])->smobbed_copy ();
		SCM es = m->get_property ("elements");
		SCM postevs = scm_reverse_x (yyvsp[0], SCM_EOL);

		for (SCM s = es; scm_is_pair (s); s = scm_cdr (s))
		  unsmob<Music> (scm_car (s))->set_property ("duration", dur);
		es = ly_append2 (es, postevs);

		m->set_property ("elements", es);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		yyval = m->self_scm ();
	}
#line 6573 "./out/parser.cc"
    break;

  case 403:
#line 3074 "parser.yy"
        {
		yyval = MAKE_SYNTAX (event_chord, (yyloc),
				  reverse_music_list (parser, (yyloc),
						      yyvsp[-1], false, false));
	}
#line 6583 "./out/parser.cc"
    break;

  case 404:
#line 3080 "parser.yy"
        {
		yyval = MAKE_SYNTAX (event_chord, (yyloc), scm_reverse_x (yyvsp[-1], SCM_EOL));
	}
#line 6591 "./out/parser.cc"
    break;

  case 405:
#line 3086 "parser.yy"
                                { yyval = SCM_EOL; }
#line 6597 "./out/parser.cc"
    break;

  case 406:
#line 3087 "parser.yy"
                                                 {
		if (unsmob<Music> (yyvsp[0]))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 6606 "./out/parser.cc"
    break;

  case 407:
#line 3095 "parser.yy"
        {
		bool q = to_boolean (yyvsp[-2]);
		bool ex = to_boolean (yyvsp[-3]);
		SCM check = yyvsp[-1];
		SCM post = yyvsp[0];

		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("pitch", yyvsp[-4]);
		if (q)
			n->set_property ("cautionary", SCM_BOOL_T);
                if (ex || q)
			n->set_property ("force-accidental", SCM_BOOL_T);

		if (scm_is_pair (post)) {
			SCM arts = scm_reverse_x (post, SCM_EOL);
			n->set_property ("articulations", arts);
		}
		if (scm_is_number (check))
		{
			int q = scm_to_int (check);
			n->set_property ("absolute-octave", scm_from_int (q-1));
		}

		yyval = n->unprotect ();
	}
#line 6636 "./out/parser.cc"
    break;

  case 408:
#line 3120 "parser.yy"
                                           {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("drum-type", yyvsp[-1]);

		if (scm_is_pair (yyvsp[0])) {
			SCM arts = scm_reverse_x (yyvsp[0], SCM_EOL);
			n->set_property ("articulations", arts);
		}
		yyval = n->unprotect ();
	}
#line 6651 "./out/parser.cc"
    break;

  case 409:
#line 3131 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);

		if (m && !m->is_mus_type ("post-event")) {
			while (m && m->is_mus_type ("music-wrapper-music")) {
				yyval = m->get_property ("element");
				m = unsmob<Music> (yyval);
			}

			if (!(m && m->is_mus_type ("rhythmic-event"))) {
				parser->parser_error ((yyloc), _ ("not a rhythmic event"));
				yyval = SCM_UNSPECIFIED;
			}
		}
	}
#line 6671 "./out/parser.cc"
    break;

  case 414:
#line 3156 "parser.yy"
                                        {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 6680 "./out/parser.cc"
    break;

  case 415:
#line 3163 "parser.yy"
                    {
		yyval = SCM_EOL;
	}
#line 6688 "./out/parser.cc"
    break;

  case 416:
#line 3166 "parser.yy"
                                 {
		yyval = post_event_cons (yyvsp[0], yyvsp[-1]);
	}
#line 6696 "./out/parser.cc"
    break;

  case 417:
#line 3172 "parser.yy"
                             {
		yyval = yyvsp[0];
	}
#line 6704 "./out/parser.cc"
    break;

  case 418:
#line 3175 "parser.yy"
                                         {
		Music *m = unsmob<Music> (yyvsp[0]);
		if (!m->is_mus_type ("post-event")) {
			parser->parser_error ((yylsp[0]), _ ("post-event expected"));
			yyval = SCM_UNSPECIFIED;
		} else {
			m->set_spot (parser->lexer_->override_input ((yyloc)));
			if (!SCM_UNBNDP (yyvsp[-1]))
				m->set_property ("direction", yyvsp[-1]);
			yyval = yyvsp[0];
		}
	}
#line 6721 "./out/parser.cc"
    break;

  case 419:
#line 3187 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("have to be in Lyric mode for lyrics"));
		yyval = MY_MAKE_MUSIC ("HyphenEvent", (yyloc))->unprotect ();
	}
#line 6731 "./out/parser.cc"
    break;

  case 420:
#line 3192 "parser.yy"
                   {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("have to be in Lyric mode for lyrics"));
		yyval = MY_MAKE_MUSIC ("ExtenderEvent", (yyloc))->unprotect ();
	}
#line 6741 "./out/parser.cc"
    break;

  case 421:
#line 3197 "parser.yy"
                                          {
		if (Music *m = unsmob<Music> (yyvsp[0])) {
			m->set_spot (parser->lexer_->override_input ((yyloc)));
			if (!SCM_UNBNDP (yyvsp[-1]))
			{
				m->set_property ("direction", yyvsp[-1]);
			}
		}
		yyval = yyvsp[0];
	}
#line 6756 "./out/parser.cc"
    break;

  case 422:
#line 3207 "parser.yy"
                                          {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		if (!SCM_UNBNDP (yyvsp[-1]))
			m->set_property ("direction", yyvsp[-1]);
		yyval = yyvsp[0];
	}
#line 6768 "./out/parser.cc"
    break;

  case 423:
#line 3215 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		m->set_property ("direction", scm_from_int (UP));
		yyval = yyvsp[0];
	}
#line 6779 "./out/parser.cc"
    break;

  case 424:
#line 3222 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		m->set_property ("direction", scm_from_int (DOWN));
		yyval = yyvsp[0];
	}
#line 6790 "./out/parser.cc"
    break;

  case 426:
#line 3232 "parser.yy"
                        {
		unsmob<Music> (yyvsp[0])->set_spot (parser->lexer_->override_input ((yyloc)));
		yyval = yyvsp[0];
	}
#line 6799 "./out/parser.cc"
    break;

  case 427:
#line 3239 "parser.yy"
                   {
		Music *s = MY_MAKE_MUSIC ("StringNumberEvent", (yyloc));
		s->set_property ("string-number", yyvsp[0]);
		yyval = s->unprotect ();
	}
#line 6809 "./out/parser.cc"
    break;

  case 429:
#line 3248 "parser.yy"
                                {
		yyval = yyvsp[0];
	}
#line 6817 "./out/parser.cc"
    break;

  case 430:
#line 3251 "parser.yy"
                        {
               Music *a = MY_MAKE_MUSIC ("TremoloEvent", (yyloc));
               a->set_property ("tremolo-type", yyvsp[0]);
               yyval = a->unprotect ();
        }
#line 6827 "./out/parser.cc"
    break;

  case 432:
#line 3260 "parser.yy"
                     {
		yyval = yyvsp[0];
	}
#line 6835 "./out/parser.cc"
    break;

  case 433:
#line 3263 "parser.yy"
                              {
		SCM s = parser->lexer_->lookup_identifier ("dash" + ly_scm2string (yyvsp[0]));
		if (scm_is_string (s)) {
			Music *a = MY_MAKE_MUSIC ("ArticulationEvent", (yyloc));
			a->set_property ("articulation-type", s);
			yyval = a->unprotect ();
		} else {
			Music *original = unsmob<Music> (s);
			if (original && original->is_mus_type ("post-event")) {
				Music *a = original->clone ();
				// origin will be set by post_event_nofinger
				yyval = a->unprotect ();
			} else {
				parser->parser_error ((yylsp[0]), _ ("expecting string or post-event as script definition"));
				yyval = SCM_UNSPECIFIED;
			}
		}
	}
#line 6858 "./out/parser.cc"
    break;

  case 434:
#line 3284 "parser.yy"
             { yyval = SCM_EOL; }
#line 6864 "./out/parser.cc"
    break;

  case 435:
#line 3285 "parser.yy"
                     { yyval = yyvsp[0]; }
#line 6870 "./out/parser.cc"
    break;

  case 436:
#line 3290 "parser.yy"
        {
                yyval = SCM_INUM0;
	}
#line 6878 "./out/parser.cc"
    break;

  case 439:
#line 3299 "parser.yy"
               {
		if (scm_is_eq (SCM_INUM0, yyvsp[0]))
			yyval = SCM_UNDEFINED;
	}
#line 6887 "./out/parser.cc"
    break;

  case 440:
#line 3306 "parser.yy"
             {
		yyval = scm_from_int (1);
	}
#line 6895 "./out/parser.cc"
    break;

  case 441:
#line 3309 "parser.yy"
                          {
		yyval = scm_oneplus (yyvsp[-1]);
	}
#line 6903 "./out/parser.cc"
    break;

  case 442:
#line 3315 "parser.yy"
            {
		yyval = scm_from_int (-1);
	}
#line 6911 "./out/parser.cc"
    break;

  case 443:
#line 3318 "parser.yy"
                         {
		yyval = scm_oneminus (yyvsp[-1]);
	}
#line 6919 "./out/parser.cc"
    break;

  case 444:
#line 3324 "parser.yy"
                              {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 6932 "./out/parser.cc"
    break;

  case 445:
#line 3339 "parser.yy"
                               {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 6945 "./out/parser.cc"
    break;

  case 447:
#line 3351 "parser.yy"
                                  {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 6958 "./out/parser.cc"
    break;

  case 450:
#line 3367 "parser.yy"
                    {
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		t->set_property ("text", yyvsp[0]);
		yyval = t->unprotect ();
	}
#line 6968 "./out/parser.cc"
    break;

  case 451:
#line 3372 "parser.yy"
                 {
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		t->set_property ("text",
			make_simple_markup (yyvsp[0]));
		yyval = t->unprotect ();
	}
#line 6979 "./out/parser.cc"
    break;

  case 452:
#line 3378 "parser.yy"
                 {
		// Flag a warning? could be unintentional
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		t->set_property ("text",
			make_simple_markup (yyvsp[0]));
		yyval = t->unprotect ();
	}
#line 6991 "./out/parser.cc"
    break;

  case 453:
#line 3386 "parser.yy"
        {
		// Could be using this for every gen_text_def but for speed
		yyval = MAKE_SYNTAX (create_script, (yylsp[0]), yyvsp[0]);
	}
#line 7000 "./out/parser.cc"
    break;

  case 454:
#line 3393 "parser.yy"
                 {
		Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yyloc));
		t->set_property ("digit", yyvsp[0]);
		yyval = t->unprotect ();
	}
#line 7010 "./out/parser.cc"
    break;

  case 455:
#line 3401 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Hat");
	}
#line 7018 "./out/parser.cc"
    break;

  case 456:
#line 3404 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Plus");
	}
#line 7026 "./out/parser.cc"
    break;

  case 457:
#line 3407 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Dash");
	}
#line 7034 "./out/parser.cc"
    break;

  case 458:
#line 3410 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Bang");
	}
#line 7042 "./out/parser.cc"
    break;

  case 459:
#line 3413 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Larger");
	}
#line 7050 "./out/parser.cc"
    break;

  case 460:
#line 3416 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Dot");
	}
#line 7058 "./out/parser.cc"
    break;

  case 461:
#line 3419 "parser.yy"
              {
		yyval = scm_from_ascii_string ("Underscore");
	}
#line 7066 "./out/parser.cc"
    break;

  case 462:
#line 3425 "parser.yy"
                { yyval = scm_from_int (DOWN); }
#line 7072 "./out/parser.cc"
    break;

  case 463:
#line 3426 "parser.yy"
                { yyval = scm_from_int (UP); }
#line 7078 "./out/parser.cc"
    break;

  case 464:
#line 3427 "parser.yy"
                { yyval = SCM_UNDEFINED; }
#line 7084 "./out/parser.cc"
    break;

  case 465:
#line 3431 "parser.yy"
        {
		yyval = SCM_UNDEFINED;
	}
#line 7092 "./out/parser.cc"
    break;

  case 466:
#line 3434 "parser.yy"
                        {
		yyval = yyvsp[0];
		parser->default_duration_ = *unsmob<Duration> (yyval);
	}
#line 7101 "./out/parser.cc"
    break;

  case 467:
#line 3443 "parser.yy"
        {
		if (SCM_UNBNDP (yyval))
			yyval = parser->default_duration_.smobbed_copy ();
	}
#line 7110 "./out/parser.cc"
    break;

  case 468:
#line 3450 "parser.yy"
                                {
		yyval = make_duration (yyvsp[-1], scm_to_int (yyvsp[0]));
		if (SCM_UNBNDP (yyval))
		{
			parser->parser_error ((yylsp[-1]), _ ("not a duration"));
			yyval = Duration ().smobbed_copy ();
		}
	}
#line 7123 "./out/parser.cc"
    break;

  case 469:
#line 3458 "parser.yy"
                                        {
		yyval = make_duration (yyvsp[-1], scm_to_int (yyvsp[0]));
	}
#line 7131 "./out/parser.cc"
    break;

  case 470:
#line 3464 "parser.yy"
                                   {
		yyval = make_duration (yyvsp[-1], 0, yyvsp[0]);
	}
#line 7139 "./out/parser.cc"
    break;

  case 471:
#line 3470 "parser.yy"
                        {
		yyval = SCM_INUM0;
	}
#line 7147 "./out/parser.cc"
    break;

  case 472:
#line 3473 "parser.yy"
                   {
		yyval = scm_oneplus (yyvsp[-1]);
	}
#line 7155 "./out/parser.cc"
    break;

  case 475:
#line 3485 "parser.yy"
        {
		yyval = SCM_UNDEFINED;
	}
#line 7163 "./out/parser.cc"
    break;

  case 476:
#line 3489 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_product (yyvsp[-2], yyvsp[0]);
		else
			yyval = yyvsp[0];
	}
#line 7174 "./out/parser.cc"
    break;

  case 477:
#line 3496 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_product (yyvsp[-2], scm_divide (scm_car (yyvsp[0]),
							  scm_cdr (yyvsp[0])));
		else
			yyval = scm_divide (scm_car (yyvsp[0]), scm_cdr (yyvsp[0]));
	}
#line 7186 "./out/parser.cc"
    break;

  case 478:
#line 3504 "parser.yy"
        {
		if (scm_is_false (Lily::scale_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _ ("not a multiplier"));
		} else if (SCM_UNBNDP (yyvsp[-2]))
			yyval = Lily::scale_to_factor (yyvsp[0]);
		else
			yyval = scm_product (yyvsp[-2], Lily::scale_to_factor (yyvsp[0]));
	}
#line 7200 "./out/parser.cc"
    break;

  case 479:
#line 3516 "parser.yy"
                {
		yyval = scm_from_int (parser->default_tremolo_type_);
	}
#line 7208 "./out/parser.cc"
    break;

  case 480:
#line 3519 "parser.yy"
                       {
		if (SCM_UNBNDP (make_duration (yyvsp[0]))) {
			parser->parser_error ((yylsp[0]), _ ("not a duration"));
			yyval = scm_from_int (parser->default_tremolo_type_);
		} else {
			yyval = yyvsp[0];
			parser->default_tremolo_type_ = scm_to_int (yyvsp[0]);
		}
	}
#line 7222 "./out/parser.cc"
    break;

  case 485:
#line 3536 "parser.yy"
        {
		// as an integer, it needs to be non-negative, and otherwise
		// it needs to be suitable as a markup.
		if (scm_is_integer (yyvsp[0])
		    ? scm_is_true (scm_negative_p (yyvsp[0]))
		    : !Text_interface::is_markup (yyvsp[0]))
		{
			parser->parser_error ((yylsp[0]), _ ("bass number expected"));
			yyval = SCM_INUM0;
		}
	}
#line 7238 "./out/parser.cc"
    break;

  case 486:
#line 3550 "parser.yy"
                { yyval = ly_rational2scm (FLAT_ALTERATION); }
#line 7244 "./out/parser.cc"
    break;

  case 487:
#line 3551 "parser.yy"
                { yyval = ly_rational2scm (SHARP_ALTERATION); }
#line 7250 "./out/parser.cc"
    break;

  case 488:
#line 3552 "parser.yy"
                { yyval = scm_from_int (0); }
#line 7256 "./out/parser.cc"
    break;

  case 489:
#line 3556 "parser.yy"
                     {
		Music *bfr = MY_MAKE_MUSIC ("BassFigureEvent", (yyloc));
		yyval = bfr->unprotect ();
	}
#line 7265 "./out/parser.cc"
    break;

  case 490:
#line 3560 "parser.yy"
                       {
		Music *bfr = MY_MAKE_MUSIC ("BassFigureEvent", (yyloc));
		yyval = bfr->self_scm ();

		if (scm_is_number (yyvsp[0]))
			bfr->set_property ("figure", yyvsp[0]);
		else if (Text_interface::is_markup (yyvsp[0]))
			bfr->set_property ("text", yyvsp[0]);

		bfr->unprotect ();
	}
#line 7281 "./out/parser.cc"
    break;

  case 491:
#line 3571 "parser.yy"
                          {
		yyval = yyvsp[-1];
		unsmob<Music> (yyvsp[-1])->set_property ("bracket-stop", SCM_BOOL_T);
	}
#line 7290 "./out/parser.cc"
    break;

  case 492:
#line 3575 "parser.yy"
                                              {
		Music *m = unsmob<Music> (yyvsp[-1]);
		if (scm_to_double (yyvsp[0])) {
			SCM salter = m->get_property ("alteration");
			SCM alter = scm_is_number (salter) ? salter : scm_from_int (0);
			m->set_property ("alteration",
					 scm_sum (alter, yyvsp[0]));
		} else {
			m->set_property ("alteration", scm_from_int (0));
		}
	}
#line 7306 "./out/parser.cc"
    break;

  case 493:
#line 3586 "parser.yy"
                                                 {
		Music *m = unsmob<Music> (yyvsp[-1]);
		m->set_property (yyvsp[0], SCM_BOOL_T);
	}
#line 7315 "./out/parser.cc"
    break;

  case 494:
#line 3594 "parser.yy"
                        {
		yyval = ly_symbol2scm ("augmented");
	}
#line 7323 "./out/parser.cc"
    break;

  case 495:
#line 3597 "parser.yy"
                        {
		yyval = ly_symbol2scm ("no-continuation");
	}
#line 7331 "./out/parser.cc"
    break;

  case 496:
#line 3600 "parser.yy"
                        {
		yyval = ly_symbol2scm ("diminished");
	}
#line 7339 "./out/parser.cc"
    break;

  case 497:
#line 3603 "parser.yy"
                      {
		yyval = ly_symbol2scm ("augmented-slash");
	}
#line 7347 "./out/parser.cc"
    break;

  case 498:
#line 3609 "parser.yy"
                    {
		yyval = yyvsp[0];
	}
#line 7355 "./out/parser.cc"
    break;

  case 499:
#line 3612 "parser.yy"
                          {
		yyval = yyvsp[0];
		unsmob<Music> (yyval)->set_property ("bracket-start", SCM_BOOL_T);
	}
#line 7364 "./out/parser.cc"
    break;

  case 500:
#line 3619 "parser.yy"
                        {
		yyval = SCM_EOL;
	}
#line 7372 "./out/parser.cc"
    break;

  case 501:
#line 3622 "parser.yy"
                                     {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 7380 "./out/parser.cc"
    break;

  case 502:
#line 3628 "parser.yy"
               { yyval = SCM_BOOL_F; }
#line 7386 "./out/parser.cc"
    break;

  case 503:
#line 3629 "parser.yy"
               { yyval = SCM_BOOL_T; }
#line 7392 "./out/parser.cc"
    break;

  case 504:
#line 3637 "parser.yy"
                                                                                                                     {
		if (!parser->lexer_->is_note_state ())
			parser->parser_error ((yylsp[-7]), _ ("have to be in Note mode for notes"));
		if (!SCM_UNBNDP (yyvsp[-2]))
		{
			// It's possible to get here without a
			// duration, like when there is no
			// octave_check but a question mark.  But we
			// point out the most frequent error of an
			// interspersed duration specifically
			if (!SCM_UNBNDP (yyvsp[-3]))
				parser->parser_error ((yylsp[-2]), _ ("octave marks must precede duration"));
			else
				parser->parser_error ((yylsp[-2]), _ ("badly placed octave marks"));
			// Try sorting the quotes to where they likely belong
			if (scm_is_number (yyvsp[-4])) {
				yyvsp[-4] = scm_sum (yyvsp[-4], yyvsp[-2]);
			} else {
				yyvsp[-7] = unsmob<Pitch> (yyvsp[-7])->transposed
					(Pitch (scm_to_int (yyvsp[-2]), 0)).smobbed_copy ();
			}
		}

		if (!SCM_UNBNDP (yyvsp[-6])
                    || !SCM_UNBNDP (yyvsp[-5])
                    || scm_is_number (yyvsp[-4])
                    || !SCM_UNBNDP (yyvsp[-3])
		    || scm_is_true (yyvsp[-1])
		    || scm_is_pair (yyvsp[0]))
		{
			Music *n = 0;
			if (scm_is_true (yyvsp[-1]))
				n = MY_MAKE_MUSIC ("RestEvent", (yyloc));
			else
				n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

			n->set_property ("pitch", yyvsp[-7]);
			if (SCM_UNBNDP (yyvsp[-3]))
				n->set_property ("duration",
						 parser->default_duration_.smobbed_copy ());
			else
				n->set_property ("duration", yyvsp[-3]);

			if (scm_is_number (yyvsp[-4]))
			{
				int q = scm_to_int (yyvsp[-4]);
				n->set_property ("absolute-octave", scm_from_int (q-1));
			}

			if (to_boolean (yyvsp[-5]))
				n->set_property ("cautionary", SCM_BOOL_T);
			if (to_boolean (yyvsp[-6]) || to_boolean (yyvsp[-5]))
				n->set_property ("force-accidental", SCM_BOOL_T);
			if (scm_is_pair (yyvsp[0]))
				n->set_property ("articulations",
						 scm_reverse_x (yyvsp[0], SCM_EOL));
			yyval = n->unprotect ();
		}
	}
#line 7456 "./out/parser.cc"
    break;

  case 505:
#line 3696 "parser.yy"
                                {
		if (!parser->lexer_->is_chord_state ())
                        parser->parser_error ((yylsp[-1]), _ ("have to be in Chord mode for chords"));
		if (scm_is_pair (yyvsp[0])) {
			if (unsmob<Pitch> (yyvsp[-1]))
				yyvsp[-1] = make_chord_elements ((yylsp[-1]),
							  yyvsp[-1],
							  parser->default_duration_.smobbed_copy (),
							  SCM_EOL);

			SCM elts = ly_append2 (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));

			yyval = MAKE_SYNTAX (event_chord, (yylsp[-1]), elts);
		} else if (!unsmob<Pitch> (yyvsp[-1]))
			yyval = MAKE_SYNTAX (event_chord, (yylsp[-1]), yyvsp[-1]);
		// A mere pitch drops through.
	}
#line 7478 "./out/parser.cc"
    break;

  case 506:
#line 3716 "parser.yy"
                                              {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("duration", yyvsp[0]);
		n->set_property ("drum-type", yyvsp[-1]);

		yyval = n->unprotect ();
	}
#line 7490 "./out/parser.cc"
    break;

  case 507:
#line 3723 "parser.yy"
                                                        {
		Music *ev = 0;
 		if (ly_scm2string (yyvsp[-1]) == "s") {
			/* Space */
			ev = MY_MAKE_MUSIC ("SkipEvent", (yyloc));
		  }
		else {
			ev = MY_MAKE_MUSIC ("RestEvent", (yyloc));

		    }
		ev->set_property ("duration", yyvsp[0]);
 		yyval = ev->unprotect ();
	}
#line 7508 "./out/parser.cc"
    break;

  case 508:
#line 3739 "parser.yy"
                    {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("markup outside of text script or \\lyricmode"));
		yyval = yyvsp[0];
	}
#line 7518 "./out/parser.cc"
    break;

  case 509:
#line 3744 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _f ("not a note name: %s", ly_scm2string (yyvsp[0])));
		yyval = yyvsp[0];
	}
#line 7528 "./out/parser.cc"
    break;

  case 510:
#line 3749 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("string outside of text script or \\lyricmode"));
		yyval = yyvsp[0];
	}
#line 7538 "./out/parser.cc"
    break;

  case 512:
#line 3758 "parser.yy"
                                                             {
		yyval = MAKE_SYNTAX (lyric_event, (yyloc), yyvsp[-2], yyvsp[-1]);
		if (scm_is_pair (yyvsp[0]))
			unsmob<Music> (yyval)->set_property
				("articulations", scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 7549 "./out/parser.cc"
    break;

  case 513:
#line 3768 "parser.yy"
                                                    {
		if (SCM_UNBNDP (yyvsp[0]))
			yyval = yyvsp[-1];
		else
			yyval = make_chord_elements ((yyloc), yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 7560 "./out/parser.cc"
    break;

  case 514:
#line 3774 "parser.yy"
                                                                                   {
		SCM its = scm_reverse_x (yyvsp[0], SCM_EOL);
		yyval = make_chord_elements ((yyloc), yyvsp[-3], yyvsp[-2], scm_cons (yyvsp[-1], its));
	}
#line 7569 "./out/parser.cc"
    break;

  case 515:
#line 3781 "parser.yy"
             {
		yyval = SCM_EOL;
	}
#line 7577 "./out/parser.cc"
    break;

  case 516:
#line 3784 "parser.yy"
                                 {
		yyval = scm_cons (yyvsp[0], yyval);
	}
#line 7585 "./out/parser.cc"
    break;

  case 517:
#line 3790 "parser.yy"
                    {
		yyval = ly_symbol2scm ("chord-colon");
	}
#line 7593 "./out/parser.cc"
    break;

  case 518:
#line 3793 "parser.yy"
                      {
		yyval = ly_symbol2scm ("chord-caret");
	}
#line 7601 "./out/parser.cc"
    break;

  case 519:
#line 3796 "parser.yy"
                                        {
 		yyval = scm_list_2 (ly_symbol2scm ("chord-slash"), yyvsp[0]);
	}
#line 7609 "./out/parser.cc"
    break;

  case 520:
#line 3799 "parser.yy"
                                       {
		yyval = scm_list_2 (ly_symbol2scm ("chord-bass"), yyvsp[0]);
	}
#line 7617 "./out/parser.cc"
    break;

  case 521:
#line 3805 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 7625 "./out/parser.cc"
    break;

  case 522:
#line 3808 "parser.yy"
                       {
		yyval = scm_reverse_x (yyvsp[0], SCM_EOL);
	}
#line 7633 "./out/parser.cc"
    break;

  case 523:
#line 3811 "parser.yy"
                          {
		yyval = yyvsp[0];
	}
#line 7641 "./out/parser.cc"
    break;

  case 524:
#line 3817 "parser.yy"
                    { yyval = scm_cons (yyvsp[0], SCM_EOL); }
#line 7647 "./out/parser.cc"
    break;

  case 525:
#line 3818 "parser.yy"
                                       {
		yyval = scm_cons (yyvsp[0], yyval);
	}
#line 7655 "./out/parser.cc"
    break;

  case 526:
#line 3824 "parser.yy"
                 {
		yyval = make_chord_step (yyvsp[0], 0);
        }
#line 7663 "./out/parser.cc"
    break;

  case 527:
#line 3827 "parser.yy"
                       {
		yyval = make_chord_step (yyvsp[-1], SHARP_ALTERATION);
	}
#line 7671 "./out/parser.cc"
    break;

  case 528:
#line 3830 "parser.yy"
                               {
		yyval = make_chord_step (yyvsp[-1], FLAT_ALTERATION);
	}
#line 7679 "./out/parser.cc"
    break;

  case 529:
#line 3836 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 7687 "./out/parser.cc"
    break;

  case 530:
#line 3839 "parser.yy"
                                              {
		yyval = scm_cons (yyvsp[-2], yyvsp[0]);
	}
#line 7695 "./out/parser.cc"
    break;

  case 531:
#line 3851 "parser.yy"
                                          {
		yyval = scm_sum (yyvsp[-2], yyvsp[0]);
	}
#line 7703 "./out/parser.cc"
    break;

  case 532:
#line 3854 "parser.yy"
                                            {
		yyval = scm_difference (yyvsp[-2], yyvsp[0]);
	}
#line 7711 "./out/parser.cc"
    break;

  case 534:
#line 3861 "parser.yy"
                      {
		yyval = yyvsp[0];
	}
#line 7719 "./out/parser.cc"
    break;

  case 535:
#line 3864 "parser.yy"
                                          {
		yyval = scm_product (yyvsp[-2], yyvsp[0]);
	}
#line 7727 "./out/parser.cc"
    break;

  case 536:
#line 3867 "parser.yy"
                                          {
		yyval = scm_divide (yyvsp[-2], yyvsp[0]);
	}
#line 7735 "./out/parser.cc"
    break;

  case 537:
#line 3873 "parser.yy"
                           { /* %prec UNARY_MINUS */
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 7743 "./out/parser.cc"
    break;

  case 541:
#line 3883 "parser.yy"
        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 7751 "./out/parser.cc"
    break;

  case 544:
#line 3891 "parser.yy"
                                        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 7759 "./out/parser.cc"
    break;

  case 546:
#line 3899 "parser.yy"
        {
		if (!scm_is_integer (yyvsp[0])
		    || scm_is_true (scm_negative_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _("not an unsigned integer"));
			yyval = SCM_INUM0;
		}
	}
#line 7772 "./out/parser.cc"
    break;

  case 547:
#line 3908 "parser.yy"
        {
		if (!scm_is_integer (yyvsp[0])
		    || scm_is_true (scm_negative_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _("not an unsigned integer"));
			yyval = SCM_INUM0;
		}
	}
#line 7785 "./out/parser.cc"
    break;

  case 548:
#line 3919 "parser.yy"
                { yyval = SCM_UNDEFINED; }
#line 7791 "./out/parser.cc"
    break;

  case 549:
#line 3921 "parser.yy"
        {
                if (SCM_UNBNDP (yyvsp[-1]))
                        yyval = SCM_BOOL_T;
                else
                        yyval = scm_not (yyvsp[-1]);
        }
#line 7802 "./out/parser.cc"
    break;

  case 550:
#line 3936 "parser.yy"
        { yyval = SCM_UNDEFINED; }
#line 7808 "./out/parser.cc"
    break;

  case 551:
#line 3938 "parser.yy"
        {
                if (SCM_UNBNDP (yyvsp[-1]))
                        yyval = SCM_BOOL_T;
                else
                        yyval = scm_not (yyvsp[-1]);
        }
#line 7819 "./out/parser.cc"
    break;

  case 552:
#line 3948 "parser.yy"
                { parser->lexer_->push_markup_state (); }
#line 7825 "./out/parser.cc"
    break;

  case 553:
#line 3949 "parser.yy"
                    {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 7834 "./out/parser.cc"
    break;

  case 554:
#line 3957 "parser.yy"
        {
		parser->lexer_->push_markup_state ();
	}
#line 7842 "./out/parser.cc"
    break;

  case 555:
#line 3973 "parser.yy"
        {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 7851 "./out/parser.cc"
    break;

  case 556:
#line 3981 "parser.yy"
                               {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 7860 "./out/parser.cc"
    break;

  case 557:
#line 3986 "parser.yy"
        {
		yyval = make_simple_markup (yyvsp[0]);
	}
#line 7868 "./out/parser.cc"
    break;

  case 558:
#line 3993 "parser.yy"
        {
		yyval = MAKE_SYNTAX (partial_markup, (yylsp[-1]), yyvsp[-1]);
		parser->lexer_->pop_state ();
	}
#line 7877 "./out/parser.cc"
    break;

  case 559:
#line 4000 "parser.yy"
                    {
		yyval = scm_list_2 (Lily::line_markup,  yyvsp[0]);
	}
#line 7885 "./out/parser.cc"
    break;

  case 560:
#line 4004 "parser.yy"
        {
		yyval = scm_car (MAKE_SYNTAX (composed_markup_list,
					   (yylsp[0]), yyvsp[-1], scm_list_1 (yyvsp[0])));
	}
#line 7894 "./out/parser.cc"
    break;

  case 561:
#line 4008 "parser.yy"
                               {
		yyval = yyvsp[0];
	}
#line 7902 "./out/parser.cc"
    break;

  case 562:
#line 4015 "parser.yy"
        {
		if (Text_interface::is_markup (yyvsp[0]))
			MYBACKUP (MARKUP_IDENTIFIER, yyvsp[0], (yylsp[0]));
		else if (Text_interface::is_markup_list (yyvsp[0]))
			MYBACKUP (MARKUPLIST_IDENTIFIER, yyvsp[0], (yylsp[0]));
		else {
			parser->parser_error ((yylsp[0]), _ ("not a markup"));
			MYBACKUP (MARKUP_IDENTIFIER, scm_string (SCM_EOL), (yylsp[0]));
		}
	}
#line 7917 "./out/parser.cc"
    break;

  case 564:
#line 4029 "parser.yy"
                             {
		yyval = yyvsp[0];
	}
#line 7925 "./out/parser.cc"
    break;

  case 566:
#line 4036 "parser.yy"
                           {
		yyval = yyvsp[0];
	}
#line 7933 "./out/parser.cc"
    break;

  case 567:
#line 4039 "parser.yy"
                              {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 7941 "./out/parser.cc"
    break;

  case 568:
#line 4043 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 7949 "./out/parser.cc"
    break;

  case 569:
#line 4046 "parser.yy"
                     {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 7957 "./out/parser.cc"
    break;

  case 570:
#line 4048 "parser.yy"
                             {
		Score *sc = unsmob<Score> (yyvsp[-1]);
		sc->origin ()->set_spot ((yyloc));
		if (sc->defs_.empty ()) {
			Output_def *od = get_layout (parser);
			sc->add_output_def (od);
			od->unprotect ();
		}
		yyval = scm_list_1 (scm_list_2 (Lily::score_lines_markup_list, yyvsp[-1]));
		parser->lexer_->pop_state ();
	}
#line 7973 "./out/parser.cc"
    break;

  case 571:
#line 4062 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (composed_markup_list,
				  (yylsp[0]), yyvsp[-1], yyvsp[0]);
	}
#line 7982 "./out/parser.cc"
    break;

  case 572:
#line 4069 "parser.yy"
                                        {
		yyval = scm_reverse_x (yyvsp[-1], SCM_EOL);
	}
#line 7990 "./out/parser.cc"
    break;

  case 573:
#line 4075 "parser.yy"
                        {  yyval = SCM_EOL; }
#line 7996 "./out/parser.cc"
    break;

  case 574:
#line 4076 "parser.yy"
                                         {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8004 "./out/parser.cc"
    break;

  case 575:
#line 4079 "parser.yy"
                                              {
		yyval = scm_reverse_x (yyvsp[0], yyvsp[-1]);
	}
#line 8012 "./out/parser.cc"
    break;

  case 576:
#line 4085 "parser.yy"
                                                           {
	  yyval = scm_cons (yyvsp[-1], scm_reverse_x(yyvsp[0], SCM_EOL));
	}
#line 8020 "./out/parser.cc"
    break;

  case 577:
#line 4091 "parser.yy"
            {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 8028 "./out/parser.cc"
    break;

  case 578:
#line 4093 "parser.yy"
                                {
		parser->lexer_->pop_state ();
                yyval = yyvsp[-1];
	}
#line 8037 "./out/parser.cc"
    break;

  case 579:
#line 4101 "parser.yy"
                                                                     {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8045 "./out/parser.cc"
    break;

  case 580:
#line 4104 "parser.yy"
                                                                {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8053 "./out/parser.cc"
    break;

  case 581:
#line 4108 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8061 "./out/parser.cc"
    break;

  case 582:
#line 4111 "parser.yy"
                                                                      {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8069 "./out/parser.cc"
    break;

  case 583:
#line 4114 "parser.yy"
                                                                    {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8077 "./out/parser.cc"
    break;

  case 584:
#line 4117 "parser.yy"
                                                          {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 8085 "./out/parser.cc"
    break;

  case 585:
#line 4120 "parser.yy"
                              {
		yyval = SCM_EOL;
	}
#line 8093 "./out/parser.cc"
    break;

  case 586:
#line 4126 "parser.yy"
                                       { yyval = yyvsp[0]; }
#line 8099 "./out/parser.cc"
    break;

  case 587:
#line 4127 "parser.yy"
                                                             {
	  yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8107 "./out/parser.cc"
    break;

  case 588:
#line 4134 "parser.yy"
        {
		yyval = scm_list_1 (scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 8115 "./out/parser.cc"
    break;

  case 589:
#line 4138 "parser.yy"
        {
		yyval = scm_cons (scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL)),
			       yyvsp[-2]);
	}
#line 8124 "./out/parser.cc"
    break;

  case 590:
#line 4146 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8132 "./out/parser.cc"
    break;

  case 591:
#line 4150 "parser.yy"
        {
		yyval= yyvsp[0];
	}
#line 8140 "./out/parser.cc"
    break;

  case 592:
#line 4154 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8148 "./out/parser.cc"
    break;

  case 593:
#line 4158 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8156 "./out/parser.cc"
    break;

  case 594:
#line 4164 "parser.yy"
                                                                    {
	  yyval = scm_cons (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 8164 "./out/parser.cc"
    break;

  case 595:
#line 4170 "parser.yy"
                                {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 8172 "./out/parser.cc"
    break;

  case 596:
#line 4173 "parser.yy"
                                                {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8180 "./out/parser.cc"
    break;

  case 599:
#line 4185 "parser.yy"
        {
		yyval = make_simple_markup (yyvsp[0]);
	}
#line 8188 "./out/parser.cc"
    break;

  case 601:
#line 4192 "parser.yy"
              {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 8196 "./out/parser.cc"
    break;

  case 602:
#line 4194 "parser.yy"
                             {
		Score *sc = unsmob<Score> (yyvsp[-1]);
		sc->origin ()->set_spot ((yyloc));
		if (sc->defs_.empty ()) {
			Output_def *od = get_layout (parser);
			sc->add_output_def (od);
			od->unprotect ();
		}
		yyval = scm_list_2 (Lily::score_markup, yyvsp[-1]);
		parser->lexer_->pop_state ();
	}
#line 8212 "./out/parser.cc"
    break;

  case 603:
#line 4205 "parser.yy"
                                                         {
		yyval = scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 8220 "./out/parser.cc"
    break;

  case 604:
#line 4209 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8228 "./out/parser.cc"
    break;

  case 605:
#line 4216 "parser.yy"
        {
		yyval = scm_car (MAKE_SYNTAX (composed_markup_list,
					   (yylsp[0]), yyvsp[-1], scm_list_1 (yyvsp[0])));
	}
#line 8237 "./out/parser.cc"
    break;

  case 606:
#line 4220 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 8245 "./out/parser.cc"
    break;


#line 8249 "./out/parser.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, parser, retval, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *, YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, parser, retval, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, parser, retval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, parser, retval);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, parser, retval, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, parser, retval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, parser, retval);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 4225 "parser.yy"


void
Lily_parser::set_yydebug (bool x)
{
	yydebug = x;
}

SCM
Lily_parser::do_yyparse ()
{
	return scm_c_with_fluid (Lily::f_parser,
				 self_scm (),
				 do_yyparse_trampoline,
				 static_cast <void *>(this));
}

SCM
Lily_parser::do_yyparse_trampoline (void *parser)
{
	SCM retval = SCM_UNDEFINED;
	yyparse (static_cast <Lily_parser *>(parser), &retval);
	return retval;
}



/*

It is a little strange to have this function in this file, but
otherwise, we have to import music classes into the lexer.

*/
int
Lily_lexer::try_special_identifiers (SCM *destination, SCM sid)
{
	if (unsmob<Book> (sid)) {
		Book *book =  unsmob<Book> (sid)->clone ();
		*destination = book->self_scm ();
		book->unprotect ();

		return BOOK_IDENTIFIER;
	} else if (scm_is_number (sid)) {
		*destination = sid;
		return NUMBER_IDENTIFIER;
	} else if (unsmob<Context_def> (sid))
	{
		*destination = unsmob<Context_def> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
        } else if (unsmob<Context_mod> (sid)) {
                *destination = unsmob<Context_mod> (sid)->smobbed_copy ();
                return SCM_IDENTIFIER;
	} else if (Music *mus = unsmob<Music> (sid)) {
		mus = mus->clone ();
		*destination = mus->self_scm ();
		bool is_event = mus->is_mus_type ("post-event");
		mus->unprotect ();
		return is_event ? EVENT_IDENTIFIER : MUSIC_IDENTIFIER;
	} else if (unsmob<Pitch> (sid)) {
		*destination = unsmob<Pitch> (sid)->smobbed_copy ();
		return PITCH_IDENTIFIER;
	} else if (unsmob<Duration> (sid)) {
		*destination = unsmob<Duration> (sid)->smobbed_copy ();
		return DURATION_IDENTIFIER;
	} else if (unsmob<Output_def> (sid)) {
		*destination = unsmob<Output_def> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
	} else if (unsmob<Score> (sid)) {
		*destination = unsmob<Score> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
	} else if (scm_is_pair (sid)
		   && scm_is_pair (scm_car (sid))
		   && scm_is_true (Lily::key_p (scm_caar (sid)))) {
		*destination = sid;
		return LOOKUP_IDENTIFIER;
	}
	return -1;
}

SCM
get_next_unique_context_id ()
{
	return scm_from_ascii_string ("$uniqueContextId");
}


SCM
get_next_unique_lyrics_context_id ()
{
	static int new_context_count;
	char s[128];
	snprintf (s, sizeof (s)-1, "uniqueContext%d", new_context_count++);
	return scm_from_ascii_string (s);
}

// check_scheme_arg checks one argument with a given predicate for use
// in an argument list and throws a syntax error if it is unusable.
// The argument is prepended to the argument list in any case.  After
// throwing a syntax error, the argument list is terminated with #f as
// its last cdr in order to mark it as uncallable while not losing
// track of its total length.
//
// There are a few special considerations: if optional argument disp
// is given (otherwise it defaults to SCM_UNDEFINED), it will be used
// instead of arg in a prospective error message.  This is useful if
// arg is not the actual argument but rather a transformation of it.
//
// If arg itself is SCM_UNDEFINED, the predicate is considered false
// and an error message using disp is produced unconditionally.

SCM check_scheme_arg (Lily_parser *parser, Input loc,
		      SCM arg, SCM args, SCM pred, SCM disp)
{
	if (SCM_UNBNDP (arg))
		args = scm_cons (disp, args);
	else {
		args = scm_cons (arg, args);
		if (scm_is_true (scm_call_1 (pred, arg)))
			return args;
	}
	scm_set_cdr_x (scm_last_pair (args), SCM_EOL);
	MAKE_SYNTAX (argument_error, loc, scm_length (args), pred,
		     SCM_UNBNDP (disp) ? arg : disp);
	scm_set_cdr_x (scm_last_pair (args), SCM_BOOL_F);
	return args;
}

SCM loc_on_copy (Lily_parser *parser, Input loc, SCM arg)
{
	if (Music *m = unsmob<Music> (arg))
	{
		m = m->clone ();
		m->set_spot (parser->lexer_->override_input (loc));
		return m->unprotect ();
	}
	if (Book *b = unsmob<Book> (arg))
	{
		b = b->clone ();
		b->origin ()->set_spot (parser->lexer_->override_input (loc));
		return b->unprotect ();
	}
	if (Context_def *cd = unsmob<Context_def> (arg))
	{
		cd = cd->clone ();
		cd->origin ()->set_spot (parser->lexer_->override_input (loc));
		return cd->unprotect ();
	}
	if (Output_def *od = unsmob<Output_def> (arg))
	{
		od = od->clone ();
		od->input_origin_ = parser->lexer_->override_input (loc);
		return od->unprotect ();
	}
	if (Score *s = unsmob<Score> (arg))
	{
		s = s->clone ();
		s->origin ()->set_spot (parser->lexer_->override_input (loc));
		return s->unprotect ();
	}
	if (Context_mod *cm = unsmob<Context_mod> (arg))
	{
		return cm->smobbed_copy ();
	}
	return arg;
}

SCM
make_reverse_key_list (SCM keys)
{
	if (scm_is_true (Lily::key_p (keys)))
		return scm_list_1 (keys);
	if (scm_is_string (keys))
		return scm_list_1 (scm_string_to_symbol (keys));
	if (!ly_is_list (keys))
		return SCM_UNDEFINED;
	SCM res = SCM_EOL;
	for (; scm_is_pair (keys); keys = scm_cdr (keys))
	{
		SCM elt = scm_car (keys);
		if (scm_is_true (Lily::key_p (elt)))
			res = scm_cons (elt, res);
		else if (scm_is_string (elt))
			res = scm_cons (scm_string_to_symbol (elt), res);
		else return SCM_UNDEFINED;
	}
	return res;
}

SCM
try_string_variants (SCM pred, SCM str)
{
	// a matching predicate is always ok
	if (scm_is_true (scm_call_1 (pred, str)))
		return str;
	// a key may be interpreted as a list of keys if it helps
	if (scm_is_true (Lily::key_p (str))) {
		str = scm_list_1 (str);
		if (scm_is_true (scm_call_1 (pred, str)))
			return str;
		return SCM_UNDEFINED;
	}

	if (!scm_is_string (str))
		return SCM_UNDEFINED;

	// Let's attempt the symbol list interpretation first.

	str = scm_string_to_symbol (str);

	SCM lst = scm_list_1 (str);

	if (scm_is_true (scm_call_1 (pred, lst)))
		return lst;

	// Try the single symbol interpretation

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	return SCM_UNDEFINED;
}

SCM
try_word_variants (SCM pred, SCM str)
{
	// str is always a string when we come here

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	// If this cannot be a string representation of a symbol list,
	// we are through.

	if (!is_regular_identifier (str, true))
		return SCM_UNDEFINED;

	str = scm_string_split (str, SCM_MAKE_CHAR ('.'));
	for (SCM p = str; scm_is_pair (p); p = scm_cdr (p))
		scm_set_car_x (p, scm_string_split (scm_car (p),
						    SCM_MAKE_CHAR (',')));
	str = scm_append_x (str);
	for (SCM p = str; scm_is_pair (p); p = scm_cdr (p))
		scm_set_car_x (p, scm_string_to_symbol (scm_car (p)));

	// Let's attempt the symbol list interpretation first.

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	// If there is just one symbol in the list, we might interpret
	// it as a single symbol

	if (scm_is_null (scm_cdr (str)))
	{
		str = scm_car (str);
		if (scm_is_true (scm_call_1 (pred, str)))
			return str;
	}

	return SCM_UNDEFINED;
}

bool
is_regular_identifier (SCM id, bool multiple)
{
  if (!scm_is_string (id))
	  return false;

  string str = ly_scm2string (id);

  bool middle = false;

  for (string::iterator it=str.begin(); it != str.end (); it++)
  {
	  int c = *it & 0xff;
	  if ((c >= 'a' && c <= 'z')
	      || (c >= 'A' && c <= 'Z')
	      || c > 0x7f)
		  middle = true;
	  else if (middle && (c == '-' || c == '_' || (multiple &&
						       (c == '.' || c == ','))))
		  middle = false;
	  else
		  return false;
  }
  return middle;
}

SCM
make_music_from_simple (Lily_parser *parser, Input loc, SCM simple)
{
	if (unsmob<Music> (simple))
		return simple;

	if (scm_is_symbol (simple))
	{
		SCM out = SCM_UNDEFINED;
		switch (parser->lexer_->scan_word (out, simple))
		{
		case DRUM_PITCH:
		{
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			n->set_property ("duration", parser->default_duration_.smobbed_copy ());
			n->set_property ("drum-type", out);
			return n->unprotect ();
		}
		case NOTENAME_PITCH:
		case TONICNAME_PITCH:
			// Take the parsed pitch
			simple = out;
			break;
		// Don't scan CHORD_MODIFIER etc.
		}
	}

	if (parser->lexer_->is_note_state ()) {
		if (unsmob<Pitch> (simple)) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			n->set_property ("duration", parser->default_duration_.smobbed_copy ());
			n->set_property ("pitch", simple);
			return n->unprotect ();
		}
		SCM d = simple;
		if (scm_is_integer (simple))
			d = make_duration (simple);
		if (unsmob<Duration> (d)) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			n->set_property ("duration", d);
			return n->unprotect ();
		}
		return simple;
	} else if (parser->lexer_->is_lyric_state ()) {
		if (Text_interface::is_markup (simple))
			return MAKE_SYNTAX (lyric_event, loc, simple,
					    parser->default_duration_.smobbed_copy ());
	} else if (parser->lexer_->is_chord_state ()) {
		if (unsmob<Pitch> (simple))
			return MAKE_SYNTAX
				(event_chord,
				 loc,
				 make_chord_elements (loc, simple,
						      parser->default_duration_.smobbed_copy (),
						      SCM_EOL));
	}
	return simple;
}

Music *
make_music_with_input (SCM name, Input where)
{
       Music *m = make_music_by_name (name);
       m->set_spot (where);
       return m;
}

SCM
make_simple_markup (SCM a)
{
	return a;
}

SCM
make_duration (SCM d, int dots, SCM factor)
{
	Duration k;

	if (Duration *dur = unsmob<Duration> (d)) {
		if (!dots && SCM_UNBNDP (factor))
			return d;
		k = *dur;
		if (dots)
			k = Duration (k.duration_log (), k.dot_count () + dots)
				.compressed (k.factor ());
	} else {
		int t = scm_to_int (d);
		if (t > 0 && (t & (t-1)) == 0)
			k = Duration (intlog2 (t), dots);
		else
			return SCM_UNDEFINED;
	}

	if (!SCM_UNBNDP (factor))
		k = k.compressed (ly_scm2rational (factor));

	return k.smobbed_copy ();
}

SCM
make_chord_step (SCM step_scm, Rational alter)
{
	Pitch m (0, scm_to_int (step_scm) - 1, alter);

	// Notename/octave are normalized
	if (m.get_notename () == 6)
		m = m.transposed (Pitch (0, 0, FLAT_ALTERATION));

	return m.smobbed_copy ();
}


SCM
make_chord_elements (Input loc, SCM pitch, SCM dur, SCM modification_list)
{
	SCM res = Lily::construct_chord_elements (pitch, dur, modification_list);
	for (SCM s = res; scm_is_pair (s); s = scm_cdr (s))
	{
		unsmob<Music> (scm_car (s))->set_spot (loc);
	}
	return res;
}

// Return true if there are post events unaccounted for
bool
add_post_events (Music *m, SCM events)
{
	if (!scm_is_pair (events))
		return false;	// successfully added -- nothing

	while (m) {
		if (m->is_mus_type ("rhythmic-event")) {
			m->set_property
				("articulations",
				 scm_append_x (scm_list_2
					       (m->get_property ("articulations"),
						events)));
			return false;
		}
		if (m->is_mus_type ("event-chord")) {
			m->set_property
				("elements",
				 scm_append_x (scm_list_2
					       (m->get_property ("elements"),
						events)));
			return false;
		}
		if (m->is_mus_type ("sequential-music")) {
			SCM lp = scm_last_pair (m->get_property ("elements"));
			if (scm_is_pair (lp)) {
				m = unsmob<Music> (scm_car (lp));
				continue;
			}
			return true;
		}
		if (m->is_mus_type ("music-wrapper-music")
		    || m->is_mus_type ("time-scaled-music")) {
			m = unsmob<Music> (m->get_property ("element"));
			continue;
		}
		break;
	}
	return true;
}

// Returns either a list or a post-event
//
// If PRESERVE is true, unattachable post-events are not thrown away
// but rather added attached to empty chords.  If COMPRESS is true, a
// sequence consisting only of post-events may be returned as a single
// post-event.
SCM reverse_music_list (Lily_parser *parser, Input loc, SCM lst, bool preserve, bool compress)
{
	SCM res = SCM_EOL;	// Resulting reversed list
	SCM bad = SCM_EOL;	// Bad post events
	SCM post = SCM_EOL;	// current unattached events
	for (; scm_is_pair (lst); lst = scm_cdr (lst)) {
		SCM elt = scm_car (lst);
		Music *m = unsmob<Music> (elt);
		assert (m);
		if (m->is_mus_type ("post-event")) {
			post = post_event_cons (elt, post);
			continue;
		}
		if (add_post_events (m, post)) {
			bad = scm_cons (scm_car (post), bad);
			if (preserve) {
				Music *p = unsmob<Music> (scm_car (post));
				res = scm_cons (MAKE_SYNTAX (event_chord,
							     *p->origin (),
							     post),
						res);
			}
		}
		post = SCM_EOL;
		res = scm_cons (elt, res);
	}
	if (scm_is_pair (post)) {
		if (scm_is_null (res) && compress) { // pure postevent list
			if (scm_is_null (scm_cdr (post)))
				return scm_car (post);
			Music *m = MY_MAKE_MUSIC ("PostEvents", loc);
			m->set_property ("elements", post);
			return m->unprotect ();
		}
		bad = ly_append2 (post, bad);
		if (preserve) {
			Music *p = unsmob<Music> (scm_car (post));
			res = scm_cons (MAKE_SYNTAX (event_chord,
						     *p->origin (),
						     post),
					res);
		}
	}
	for (; scm_is_pair (bad); bad = scm_cdr (bad))
	{
		Music *what = unsmob<Music> (scm_car (bad));
		if (preserve)
			what->origin ()->warning (_f ("Unattached %s",
						      what->name ()));
		else
			what->origin ()->warning (_f ("Dropping unattachable %s",
						      what->name ()));
	}
	return res;
}

SCM post_event_cons (SCM post_event, SCM tail)
{
	Music *ev = unsmob<Music> (post_event);
	if (!ev)
		return tail;
	if (!ev->is_mus_type ("post-event-wrapper"))
		return scm_cons (post_event, tail);
	SCM elts = SCM_UNDEFINED;
	SCM props = SCM_EOL;
	SCM tweaks = SCM_UNDEFINED;
	for (SCM p = ev->get_property_alist (true);
	     scm_is_pair (p);
	     p = scm_cdr (p))
	{
		SCM pair = scm_car (p);
		SCM sym = scm_car (pair);
		if (scm_is_eq (sym, ly_symbol2scm ("origin")))
			continue;
		else if (scm_is_eq (sym, ly_symbol2scm ("elements"))
			 && SCM_UNBNDP (elts))
			elts = scm_cdr (pair);
		else if (scm_is_eq (sym, ly_symbol2scm ("tweaks"))
			 && SCM_UNBNDP (tweaks))
			tweaks = scm_cdr (pair);
		else
			props = scm_cons (pair, props);
	}
	if (!scm_is_pair (elts))
		return tail;
	for (SCM p = elts; scm_is_pair (p); p = scm_cdr (p))
	{
		Music *ev = unsmob<Music> (scm_car (p));
		// tweaks are always collected in-order, newer tweaks
		// nearer to the front of the list
		if (scm_is_pair (tweaks))
			ev->set_property ("tweaks",
					  scm_reverse_x (tweaks, ev->get_property ("tweaks")));
		// other properties are applied last to first so that
		// in case of duplicate properties, the actually
		// current one survives
		for (SCM q = props; scm_is_pair (q); q = scm_cdr (q))
			ev->set_property (scm_caar (q), scm_cdar (q));
	}
	return ly_append2 (elts, tail);
}

int
yylex (YYSTYPE *s, YYLTYPE *loc, Lily_parser *parser)
{
	Lily_lexer *lex = parser->lexer_;

	lex->lexval_ = s;
	lex->lexloc_ = loc;
	int tok = lex->pop_extra_token ();
	if (tok >= 0)
		return tok;
	lex->prepare_for_next_token ();
	return lex->yylex ();
}
